<?php

namespace   app\admin\controller;

use think\{Db, Controller, Config, Session, Cookie, Cache};
use common\{Tools, Logint, Codeinfo, Hithandle, Dbbase};

class Common extends Controller
{
    static $COUNT = array(
        'success' => 0,
        'error' => 0,
        'file' => 0,
        'dir' => 0,
        'share' => 0
    );
    public function _initialize()
    {
        if (!Session::has('administrator', 'admin')) {
            Session::clear('admin');
            Cookie::clear('sys_');
            echo json_encode(Codeinfo::NOLOGIN);
            die;
        } elseif (time() - Cookie::get('t') >= 3600) {
            Session::clear('system');
            Cookie::clear('sys_');
            echo json_encode(Codeinfo::NOLOGIN);
            die;
        } else {
            Cookie::set('t', $_SERVER['REQUEST_TIME']);
        }
    }
    static function Logout()
    {
        Session::clear('system');
        Cookie::clear('sys_');
        return true;
    }
    static function resetPw($params)
    {
        $udb = db::name('sysuser')->where('username', Session::get('administrator', 'admin'))->find();
        if ($params->newPw === $params->rePw) {
            $newpass = md5($params->newPw . $udb['salt']);
            $udb = db::name('sysuser')->where('username', Session::get('administrator', 'admin'))->setField('password', $newpass);
            $data['status'] = true;
            $data['info'] = "OK";
        } else {
            $data['status'] = false;
            $data['info'] = "密码校验失败";
        }

        return $data;
    }
    static function getStyle()
    {
        try {
            $data['status'] = true;
            $data['style'] = json_decode(file_get_contents(APP_PATH . 'style.json'));
        } catch (\Exception $th) {
            $data['status'] = false;
            $data['msg'] = '样式表读取失败';
            $data['allmsg'] = $th->getMessage();
        }
        return $data;
    }
    static function UPstyle($params)
    {
        try {
            file_put_contents(APP_PATH . 'style.json', json_encode($params));
            $data['status'] = true;
        } catch (\Exception $th) {
            $data = Codeinfo::RIGHTFAILD;
            $data['allmsg'] = $th->getMessage();
        }
        return $data;
    }
    static function deleteuserFile($file)
    {
        try {
            if (unlink(ROOT_PATH . 'public' . $file->url)) {
                $data = Codeinfo::FILEDELETESUCCESS;
            } else {
                $data = Codeinfo::FILEDELETEFAILD;
            }
        } catch (\Exception $th) {
            $data = Codeinfo::FILEDELETEFAILD;
            $data['all'] = $th;
        }
        return $data;
    }
    static function extractCard($params)
    {
        $cards = db::name('card')->field('cdkey,time,money')->order('id desc')->select();
        $text = '';
        if (!$cards) {
            $data = [
                'code' => "204NCD",
                'info' => "无可提取卡密",
                'status' => false
            ];
            return $data;
            die;
        }
        $preg_index = [
            '{卡密}',
            '{金额}',
            '{日期}'
        ];
        foreach ($cards as $key => $value) {
            $preg_low = [
                $value['cdkey'],
                $value['money'],
                $value['time'],
            ];
            $text .= str_replace($preg_index, $preg_low, $params->format) . PHP_EOL;
        }
        $data = Codeinfo::SUCCESS;
        $data['text'] = $text;
        return $data;
    }
    static function cardList($params)
    {
        $cards = db::name('card')->page($params->page, 100)->order('id DESC')->select();
        $data = Codeinfo::SUCCESS;
        $data['cardlink'] = db::name('syssetting')->find('cardlink');
        $data['cards'] = $cards;
        return $data;
    }
    static function buildCard($params)
    {
        if (empty($params->money) || empty($params->number)) {
            $data = Codeinfo::FROMFAILD;
            return $data;
        }
        $cards = [];
        for ($i = 0; $i < $params->number; $i++) {
            $cards[] = [
                'time' => date('Y-m-d H:i:s', time()),
                'cdkey' => strtoupper(md5(uniqid(Config::get('dirhash'), true))),
                'money' => $params->money,
                'status' => 0
            ];
        }
        if (db::name('card')->insertAll($cards)) {
            $data = Codeinfo::SUCCESS;
        } else {
            $data = Codeinfo::DBFAILD;
        }
        return $data;
    }
    static function getItem()
    {
        $items = db::name('goods')->field('id,type,content,enid,money')->select();
        return $items;
    }
    static function deleteItem($params)
    {
        if (db::name('goods')->where('enid', $params->enid)->delete()) {
            $data = Codeinfo::SUCCESS;
        } else {
            $data = Codeinfo::DBFAILD;
        }
        return $data;
    }
    static function addItem($params)
    {
        if (!$params->type || !$params->money || !$params->content) {
            $data = Codeinfo::FROMFAILD;
            return $data;
            die;
        }
        $adddata = [
            'enid' => md5(uniqid($params->type, true)),
            'type' => $params->type,
            'content' => $params->content,
            'money' => $params->money,
            'time' => date('Y-m-d H:i:s', time())
        ];
        if (db::name('goods')->insert($adddata)) {
            $data = Codeinfo::SUCCESS;
        } else {
            $data = Codeinfo::DBFAILD;
        }
        return $data;
    }
    static function setMarket($params)
    {
        $add = [
            'type' => 'markketing',
            'content' => json_encode($params),
            'uptime' => date('Y-m-d H:i:s', time())
        ];
        if (db::name('syssetting')->update($add)) {
            $data = Codeinfo::SUCCESS;
        } else {
            $data = Codeinfo::DBFAILD;
        }
        return $data;
    }
    static function getMarket()
    {
        $listen = db::name('syssetting')->find('markketing');
        if ($listen) {
            $data = Codeinfo::SUCCESS;
            $data['seting'] = json_decode($listen['content']);
        } else {
            $data = Codeinfo::DBFAILD;
        }
        return $data;
    }
    static function uploadPic($file, $type)
    {

        if ($type != 'logo.png') {
            $info = $file->validate(
                [
                    'size' => 1024000,
                    'ext' => 'jpg,png,gif,jpeg'
                ]
            )->move(ROOT_PATH . 'public' . DS . 'uploads');
        } else {
            $info = $file->validate(
                [
                    'size' => 1024000,
                    'ext' => 'jpg,png,gif,jpeg'
                ]
            )->move(ROOT_PATH . 'public' . DS . 'uploads', $type);
        }
        if ($info) {
            $resdata = [
                'path' => '/uploads/' . str_replace('\\', '/', $info->getSaveName()),
                'name' => $info->getFilename(),
                'type' => $type
            ];
        } else {
            $resdata = Codeinfo::FAILD;
        }
        return $resdata;
    }
    static function modifyServer($params)
    {
        switch ($params->modify) {
            case 'save':
                $savedb = array(
                    'ssid' => $params->from->ssid,
                    'form' => $params->from->form,
                    'baseurl' => $params->from->baseurl,
                    'playhost' => $params->from->playhost,
                    'apikey' => $params->from->apikey,
                    'uploadkey' => $params->from->uploadkey,
                    'guard' => $params->from->guard,
                    'weight' => $params->from->weight
                );
                db::name('server')->where('ssid', $params->from->ssid)->update($savedb) ? $data = Codeinfo::SUCCESS : $data = Codeinfo::DBFAILD;
                Hithandle::cacheChange('server', 'update', $savedb);
                break;
            case 'delete':
                db::name('filecount')->where('ssid', $params->ssid)->delete();
                db::name('server')->where('ssid', $params->ssid)->delete();
                db::name('servercache')->where('ssid', $params->ssid)->delete();
                $data = Codeinfo::SUCCESS;
                break;
            default:
                # code...
                break;
        }
        return $data;
    }
    static function importServerDB($params)
    {
        $limit = 1000;
        $count = 0;
        $par = array(
            'page' => $params->page,
            'limit' => $limit,
        );
        $resdata = Tools::GetServer($params->ssid, 'getdb', $par);
        $server = db::name('server')->where('ssid', $params->ssid)->find();
        if (@!$resdata->data) {
            $data['status'] = false;
            $data['info'] = '读写密钥错误或者目标服务器数据为空';
            $data['code'] = '500';
            return $data;
            die;
        }
        $count = count($resdata->data);
        $user = db::name('user')->where('username', session::get('administrator', 'admin'))->find();
        if ($serdirdb = db::name('filelist')
            ->where('path', '/')
            ->where('type', 'dir')
            ->where('deserver', $params->ssid)
            ->find()
        ) {
            $serdir = $serdirdb['path'];
            $serhash = $serdirdb['hash'];
        } else {
            $serdirdb = [
                'hash' => md5('/' . $server['form'] . config('dirhash') . $user['id'] . uniqid('', true)),
                'fromHash' => $user['hash'],
                'path' => '/',
                'fromPath' => '',
                'user' => $user['id'],
                'filename' => '',
                'type' => 'dir',
                'size' => '-',
                'dborder' => 99,
                'deserver' => $params->ssid,
                'uptime' => date('Y-m-d H:i:s', time())
            ];
            if (!db::name('filelist')->insert($serdirdb)) {
                $data = Codeinfo::MKDRIFAILD;
                return $data;
                die;
            } else {
                $serdir = $serdirdb['path'];
                $serhash = $serdirdb['hash'];
            }
        }
        foreach ($resdata->data as $key => $value) {
            $value->ssid = $params->ssid;
            $value->user = session::get('administrator', 'admin');
            $adddata = Tools::fileStandard($value);
            if (!db::name('filecount')->where('shareid', $value->shareid)->find()) {

                if (db::name('filecount')->insert($adddata)) {
                    self::$COUNT['success'] = self::$COUNT['success'] + 1;

                    if (@$value->category) {
                        if ($dirdb = db::name('filelist')->where('path', $serdir === '/' ? $serdir . $value->category : $serdir . '/' . $value->category)->where('type', 'dir')->find()) {
                            $userfile = [
                                'path' => $serdir === '/' ? $serdir . $value->category : $serdir . '/' . $value->category,
                                'filename' => $adddata['title'],
                                'uid' => $user['id'],
                                'hash' => $dirdb['hash'],
                                'mime' => $adddata['mime'],
                                'size' => $adddata['size'],
                                'fid' => $adddata['fid'],
                                'qr' => $adddata['qr'],
                                'share' => '/share/' . $adddata['shareid']
                            ];
                        } else {
                            $MKDIR = [
                                'hash' => md5($serdir . '/' . $value->category . config('dirhash') . $user['id'] . uniqid(time(), true)),
                                'fromHash' => $serdirdb['hash'],
                                'path' => $serdir === '/' ? $serdir . $value->category : $serdir . '/' . $value->category,
                                'fromPath' => $serdir,
                                'user' => $user['id'],
                                'filename' => $value->category,
                                'type' => 'dir',
                                'size' => '-',
                                'dborder' => 99,
                                'deserver' => $params->ssid,
                                'uptime' => date('Y-m-d H:i:s', time())
                            ];
                            if (db::name('filelist')->insert($MKDIR)) {
                                $userfile = [
                                    'path' => $serdir === '/' ? $serdir . $value->category : $serdir . '/' . $value->category,
                                    'filename' => $adddata['title'],
                                    'uid' => $user['id'],
                                    'hash' => $MKDIR['hash'],
                                    'mime' => $adddata['mime'],
                                    'size' => $adddata['size'],
                                    'fid' => $adddata['fid'],
                                    'qr' => $adddata['qr'],
                                    'share' => '/share/' . $adddata['shareid']
                                ];
                            }
                        }
                    } else {
                        $userfile = [
                            'path' => $serdir,
                            'filename' => $adddata['title'],
                            'uid' => $user['id'],
                            'hash' => $serhash,
                            'mime' => $adddata['mime'],
                            'size' => $adddata['size'],
                            'fid' => $adddata['fid'],
                            'qr' => $adddata['qr'],
                            'share' => '/share/' . $adddata['shareid']
                        ];
                    }
                    $userfile['deserver'] = $params->ssid;
                    self::addFile($userfile);
                } else {
                    self::$COUNT['error'] = self::$COUNT['error'] + 1;
                }
            } else {
                self::$COUNT['file'] = self::$COUNT['file'] + 1;
            }
        }
        $data = Codeinfo::SUCCESS;
        $data['datacount']['total'] = $resdata->total;
        $data['datacount']['page'] = $params->page;
        $data['datacount']['pagesize'] = $limit;
        $data['datacount']['pagecount'] = ceil($resdata->total / $limit);
        $data['count'] = self::$COUNT;
        return $data;
    }
    static function addFile($params)
    {
        $dbdata = array(
            'hash' => md5($params['path'] . $params['filename'] . $params['uid'] . uniqid(time(), true)),
            'fromHash' => $params['hash'],
            'path' => $params['path'] == '/' ? $params['path'] . $params['filename'] : $params['path'] . '/' . $params['filename'],
            'fromPath' => $params['path'],
            'user' => $params['uid'],
            'filename' => $params['filename'],
            'type' => Tools::file_format($params['mime']),
            'mime' => strtolower($params['mime']),
            'size' => $params['size'],
            'fid' => $params['fid'],
            'deserver' => $params['deserver'],
            'uptime' => date('Y-m-d H:i:s', time())
        );

        if (db::name('filelist')->data($dbdata)->insert()) {
            if (@$ushare = db::name('share')->where('user', $params['uid'])->where('fid', $params['fid'])->find()) {
                $data = Codeinfo::SUCCESS;
            } else {
                $blmime = Tools::ifmime($dbdata['mime']);
                $sharedb = array(
                    'shareid' => Tools::only($params['filename'] . $params['uid'] . time()),
                    'user' => $params['uid'],
                    'fid' => $params['fid'],
                    'createTime' => date('Y-m-d H:i:s')
                );
                if (db::name('share')->insert($sharedb)) {
                    $data = Codeinfo::SUCCESS;
                } else {
                    $data = Codeinfo::DBFAILD;
                }
            }
            $data['msg'] = "SUCCESS";
        } else {
            $data = Codeinfo::DBFAILD;
        }
        return $data;
    }
    static function DeleteFile($params)
    {
        $MSTER_DB = db::name('filecount')
            ->where('id', 'in', $params->id)
            ->select();
        foreach ($MSTER_DB as $key => $value) {
            if (db::name('filelist')->where("fid", $value['fid'])->delete()) {
                $par = [
                    'shareid' => $value['shareid']
                ];
                if (Tools::getServer($value['ssid'], 'remove', $par)) {
                    self::$COUNT['success'] = self::$COUNT['success'] + 1;
                } else {
                    self::$COUNT['error'] = self::$COUNT['error'] + 1;
                }
                db::name('filecount')
                    ->where('id', $value['id'])
                    ->delete();
            }
        }
        return self::$COUNT;
    }
    static function ModifyTable($params)
    {
        $config = array(
            'path'     => APP_PATH . 'DBbackup/', //数据库备份路径
            'part'     => 20971520, //数据库备份卷大小
            'compress' => 0, //数据库备份文件是否启用压缩 0不压缩 1 压缩
            'level'    => 9 //数据库备份文件压缩级别 1普通 4 一般  9最高
        );
        $db = new Dbbase($config);
        switch ($params->type) {
            case 'optimize':
                foreach ($params->table as $key => $value) {
                    $db->optimize($value) === $value ? self::$COUNT['success'] = self::$COUNT['success'] + 1 : self::$COUNT['error'] = self::$COUNT['error'] + 1;
                }
                break;
            case 'gettable':
                $data['tablelist'] = Tools::arr2size($db->dataList(), 'data_length');
                $data['filelist'] = Tools::arr2time($db->fileList(), 'detime');
                break;
            case 'repair':
                $data['list'] = $db->repair($params->table);
                break;
            case 'backup':
                $file = ['name' => date('Ymd-His'), 'part' => 1];
                foreach ($params->table as $key => $value) {
                    ($db->setFile($file)->backup($value, 0) == 0) ? self::$COUNT['success'] = self::$COUNT['success'] + 1 : self::$COUNT['error'] = self::$COUNT['error'] + 1;
                }
                Logint::insert('备份数据库' . self::$COUNT['success'] . '个表', 'daily');
                break;
            case 'recovery':
                $start = 0;
                $file = $db->getFile('timeverif', $params->table);
                ($db->setFile($file)->import($start) == 0) ? self::$COUNT['success'] = self::$COUNT['success'] + 1 : self::$COUNT['error'] = self::$COUNT['error'] + 1;
                Logint::insert('恢复数据库至' . date('Y-m-d H:i:s', $params->table), 'daily');
                break;
            case 'delete':
                if (is_array($params->table)) {
                    foreach ($params->table as $key => $value) {
                        $db->delFile($value) ? self::$COUNT['success'] = self::$COUNT['success'] + 1 : $COUNT['error'] = self::$COUNT['error'] + 1;
                    }
                } else {
                    $db->delFile($params->table) ? self::$COUNT['success'] = self::$COUNT['success'] + 1 : $COUNT['error'] = self::$COUNT['error'] + 1;
                }
                Logint::insert('删除' . self::$COUNT['success'] . '个备份文件', 'daily');
                break;
        }
        $data['count'] = self::$COUNT;
        return $data;
    }
    static function GetServer($params)
    {
        $serverlist = [];
        switch ($params->type) {
            case 'default':
                $serverlist = db::name('server')
                    ->order('id desc')
                    ->select();
                break;
            case 'update':
                $serverlist = db::name('server')
                    ->where('ssid', $params->ssid)
                    ->select();
                break;
            default:
                # code...
                break;
        }

        foreach ($serverlist as $key => $value) {
            if (cache::get('YZMSYSINFO' . $value['ssid']) && $params->type === 'default') {
                $serverlist[$key]['sys'] = cache::get('YZMSYSINFO' . $value['ssid']);
            } else {
                $reqSERVER = Tools::GetServer($value['ssid'], 'getinfo');
                if (!$reqSERVER) {
                    $data = Codeinfo::SERVERTIMEOUT;
                } else {
                    $cpu = 0;
                    $mem = 0;
                    $netUP = 0;
                    $netDOWN = 0;
                    if (@$reqSERVER->err_code === -1 || @$reqSERVER->msg === "need r/w apikey!!!") {
                        $info['bs'] = "读写密钥错误";
                    } else {
                        foreach (@$reqSERVER->sysinfo as $k => $v) {
                            $cpu += $v->_value->cpu->load;
                            $mem += $v->_value->memory->used;
                            $netUP += $v->_value->net->upRate;
                            $netDOWN += $v->_value->net->downRate;
                            $DISKtotal = $v->_value->disk->total;
                            $DISKused = $v->_value->disk->used;
                        }
                        $info['bs'] = !@$reqSERVER->license->id ? '授权异常' : @$reqSERVER->license->id;
                        $info['od'] = @$reqSERVER->license->outdate;
                        $info['cpu'] = round(($cpu / count($reqSERVER->sysinfo)), 2) . '%';
                        $info['mem'] = Tools::formatBytes(($mem / count($reqSERVER->sysinfo))) . ' / ' . Tools::formatBytes($v->_value->memory->total);
                        $info['net'] = Tools::formatBytes(($netUP / count($reqSERVER->sysinfo))) . ' / ' . Tools::formatBytes($netDOWN / count($reqSERVER->sysinfo));
                        $info['files'] = @$reqSERVER->general_files;
                        $info['disk'] = Tools::formatBytes($DISKused * 1024) . ' / ' . Tools::formatBytes($DISKtotal * 1024);
                        cache::set('YZMSYSINFO' . $value['ssid'], $info, 180);
                    }
                    $serverlist[$key]['sys'] = $info;
                }
            }
        }
        return $serverlist;
    }
    static function testserver($params)
    {
        $getpar = array(
            'uploadkey' => $params->server->uploadkey,
            'status' => 'md5Check',
            'md5' => 'test',
            'name' => 'test',
            '_' => $_SERVER['REQUEST_TIME']
        );
        $getpar2 = array(
            'id' => 'test',
            'key' => $params->server->apikey
        );
        $SERVERURI = array(
            'upload' => $params->server->baseurl . Tools::CHECKFILE . '?' . http_build_query($getpar),
            'rm' => $params->server->baseurl . Tools::REMOVEFILE . '?' . http_build_query($getpar2)
        );
        foreach ($SERVERURI as $key => $value) {
            $json = Tools::curlGet($value);
            if (!$json) {
                $data = Codeinfo::SERVERTIMEOUT;
                return $data;
                die;
            }
            $json = json_decode($json);
            switch ($key) {
                case 'upload':
                    @$json->err_code == 1 ? $data['upload']['info'] = '上传密钥错误' : $data['upload']['info'] = true;
                    break;
                case 'rm':
                    @$json->err_code == -1 || @$json->msg === "need r/w apikey!!!" ? $data['rm']['info'] = '读写密钥错误' : $data['rm']['info'] = true;
                    break;
            }
        }

        return $data;
    }
    static function AddServer($params)
    {
        $data = Codeinfo::SUCCESS;
        do {
            $onlyid = Tools::only($params->server->form . time());
        } while (
            db::name('server')->where('ssid', $onlyid)->find()
        );
        $servermap['baseurl'] = $params->server->baseurl;
        $servermap['uploadkey'] = $params->server->uploadkey;
        $servermap['apikey'] = $params->server->apikey;
        if (db::name('server')->where($servermap)->find()) {
            $data = Codeinfo::SERVERREPEAT;
        } else {
            if (!strstr($params->server->baseurl, 'http://', false) && !strstr($params->server->baseurl, 'https://', false)) {
                $params->server->baseurl = 'http://' . $params->server->baseurl;
            }
            if (!strstr($params->server->playhost, 'http://', false) && !strstr($params->server->playhost, 'https://', false)) {
                $params->server->playhost = 'http://' . $params->server->playhost;
            }
            $adddata = [
                'form' => $params->server->form,
                'ssid' => $onlyid,
                'baseurl' => $params->server->baseurl,
                'playhost' => $params->server->playhost,
                'uploadkey' => $params->server->uploadkey,
                'apikey' => $params->server->apikey
            ];
            if (!db::name('server')->insert($adddata)) {
                $data = Codeinfo::DBFAILD;
            } else {
                Logint::insert('新增存储单元 ' . $params->server->form . ' 成功', 'daily');
                $cache = array(
                    'ssid' => $onlyid,
                    'form' => $params->server->form,
                );
                Hithandle::cacheChange('server', 'update', $cache);
            }
        }
        return $data;
    }
    static function IndexData()
    {
        $data = array(
            'savehost' => db::name('server')->count(),
            'user' => db::name('user')->count(),
            'file' => db::name('filecount')->count(),
            'filesize' => Tools::formatBytes(db::name('filecount')->sum('size')),
            'share' => db::name('share')->count(),
            'shareclick' => db::name('ClickCount')->sum('click'),
            'newfile' => db::view('filecount', 'ssid,title,user')
                ->view('server', 'form,ssid', 'filecount.ssid')
                ->order('filecount.id DESC')
                ->limit(10)
                ->select(),
            'newuser' => Tools::arr2userstatus(Tools::arr2time(db::name('user')->field('createtime,username,status')->order('ID DESC')->limit(10)->select(), 'createtime'), 'status'),
            'log' => Tools::arr2time(db::name('log')->limit(10)->order('ID DESC')->select(), 'createtime'),
        );
        return $data;
    }
    static function SetSystem($params)
    {
        switch ($params->type) {
            case 'webset':
                $data = Codeinfo::SUCCESS;
                //$update['system']=json_decode(file_get_contents(APP_PATH.'config.json'),true);
                /** Set webinfo */
                $params->from->webname ? $update['system']['webname'] = $params->from->webname : '';
                $params->from->subname ? $update['system']['subname'] = $params->from->subname : '';
                @$params->from->notice ? $update['system']['notice'] = $params->from->notice : '';
                /** Set syssafe */
                $update['system']['weboff'] = $params->from->weboff == true ? 1 : 0;
                $update['system']['regoff'] = $params->from->regoff == true ? 1 : 0;
                $update['system']['isVerify'] = $params->from->examine == true ? 1 : 0;
                $update['system']['force'] = $params->from->force == true ? 1 : 0;
                $update['system']['comment'] = $params->from->comment == true ? 1 : 0;
                $update['system']['publicoff'] = $params->from->publicoff == true ? 1 : 0;
                $update['system']['timeout'] = intval($params->from->timeout);
                $update['system']['defaultspace'] = $params->from->defaultspace * 1024 * 1024 * 1024;
                $update['system']['safe_num'] = intval($params->from->safe_num);
                try {
                    file_put_contents(APP_PATH . 'config.json', json_encode($update));
                } catch (\Exception $th) {
                    $data = Codeinfo::RIGHTFAILD;
                    $data['allmsg'] = $th->getMessage();
                }
                break;
            case 'email':
                Tools::setconfig(
                    'config',
                    [
                        'smtphost',
                        'fromuser',
                        'fromusername',
                        'username',
                        'userpw',
                    ],
                    [
                        $params->from->smtphost,
                        $params->from->fromuser,
                        $params->from->fromusername,
                        $params->from->username,
                        $params->from->userpw,
                    ]
                ) ? $data = Codeinfo::SUCCESS : $data = Codeinfo::DBFAILD;
                break;
        }
        return $data;
    }
    static function GetSetitem($params)
    {
        try {
            $data = json_decode(file_get_contents(APP_PATH . 'config.json'), true);
            $data['system']['defaultspace'] = $data['system']['defaultspace'] / 1024 / 1024 / 1024;
            $data['email'] = config::get('email');
            $data['status'] = true;
        } catch (\Exception $th) {
            $data = Codeinfo::CONFIGFAILD;
            $data['allmsg'] = $th->getMessage();
        }
        return $data;
    }
    static function FileList($params)
    {
        $map = array();
        switch ($params->type) {
            case 'select':
                $map['ssid'] = $params->ssid;
                @$params->keywords ? $map['title'] = ['like', '%' . $params->keywords . '%'] : '';
                break;
            case 'search':
                @$params->ssid ? $map['ssid'] = $params->ssid : '';
                $map['title'] = ['like', '%' . $params->keywords . '%'];
                break;
            case 'page':
                @$params->keywords ? $map['title'] = ['like', '%' . $params->keywords . '%'] : '';
                @$params->ssid ? $map['ssid'] = $params->ssid : '';
                break;
        }
        $data['count'] = db::name('filecount')
            ->where($map)
            ->count();
        $data['data'] = db::view('filecount', 'id,ssid,title,user,md5,fid,createTime,size,shareid,mime,path,duration,mp4,pic,filetype')
            ->view('server', 'form,playhost', 'server.ssid=filecount.ssid')
            ->where($map)
            ->order('createTime DESC')
            ->page($params->page, 50)
            ->select();
        foreach ($data['data'] as $key => $value) {
            $data['data'][$key]['sid'] = db::name('share')->where('fid', $value['fid'])->field('shareid')->find()['shareid'];
        }
        $data['data'] = Tools::arr2time($data['data'], 'createTime');
        $data['data'] = Tools::arr2size($data['data'], 'size');
        $data['page'] = $params->page;
        $data['serverlist'] = db::name('server')->order('ID DESC')->select();
        return $data;
    }
    static function getUser($params)
    {
        $map = array();
        $map['uid'] = ['>', 1];
        switch ($params->type) {
            case '0':
            case '3':
            case '1':
                $data['data'] = db::view('user', 'username,createtime,status,id')
                    ->view('usercache', 'files,disksize,diskspace,logintime,uid', 'usercache.uid=user.id', 'LEFT')
                    ->where('user.id', '>', 1)
                    ->page($params->page, 50)
                    ->order('user.id DESC')
                    ->where('user.status', $params->type)
                    ->select();
                break;
            case 'search':
                $data['data'] = db::view('user', 'username,createtime,status,id')
                    ->view('usercache', 'files,disksize,diskspace,logintime,uid', 'usercache.uid=user.id', 'LEFT')
                    ->where('user.id', '>', 1)
                    ->page($params->page, 50)
                    ->order('user.id DESC')
                    ->where('user.username', 'like', "%" . $params->username . "%")
                    ->select();;
                break;
            default:
                $data['data'] = db::view('user', 'username,createtime,status,id')
                    ->view('usercache', 'files,disksize,diskspace,logintime,uid', 'usercache.uid=user.id', 'LEFT')
                    ->where('user.id', '>', 1)
                    ->page($params->page, 50)
                    ->order('user.id DESC')
                    ->select();
                break;
        }
        foreach ($data['data'] as $key => $value) {
            $data['data'][$key]['diskspace'] = Tools::formatBytes($data['data'][$key]['diskspace']);
            $data['data'][$key]['disksize'] = Tools::formatBytes($data['data'][$key]['disksize']);
        }
        $data['count'] = db::name('user')->count() - 1;
        $data['page'] = $params->page;
        return $data;
    }
    static function userStatus($params)
    {
        $iid = array();
        switch ($params->type) {
            case 'delete':
                foreach ($params->alluser as $key => $value) {
                    $ids[] = $value->cacheid;
                }
                return self::ClerUser($ids);
                break;
            case 'examine':
                foreach ($params->alluser as $key => $value) {
                    if ($value->status === 0) {
                        $iid[] = $value->cacheid;
                    }
                }
                return $iid ? self::SetUserStatus(1, $iid) : self::$COUNT;
                break;
            case 'closure':
                foreach ($params->alluser as $key => $value) {
                    if ($value->status != 0 && $value->status != 3) {
                        $iid[] = $value->cacheid;
                    }
                }
                return $iid ? self::SetUserStatus(3, $iid) : self::$COUNT;
                break;
            case 'reset':
                foreach ($params->alluser as $key => $value) {
                    if ($value->status === 3) {
                        $iid[] = $value->cacheid;
                    }
                }
                return $iid ? self::SetUserStatus(1, $iid) : self::$COUNT;
                break;
            case 'upstep':
                foreach ($params->alluser as $key => $value) {
                    $iid[] = $value->cacheid;
                    $newdisk = $value->newdisk;
                }
                return $iid ? self::SetUserStatus(4, $iid, $newdisk * 1024 * 1024 * 1024) : self::$COUNT;
                break;
        }
    }
    static function SetUserStatus($status, $iid, $newdisk = 0)
    {
        if ($status === 4) {
            foreach ($iid as $key => $value) {
                if (db::name('user')->where('id', $value)->setField('diskspace', $newdisk) && db::name('usercache')->where('uid', $value)->setField('diskspace', $newdisk)) {
                    self::$COUNT['success']++;
                } else {
                    self::$COUNT['error']++;
                }
            }
        } else {
            foreach ($iid as $key => $value) {
                if (db::name('user')->where('id', $value)->setField('status', $status) && db::name('usercache')->where('uid', $value)->setField('status', $status)) {
                    self::$COUNT['success'] = self::$COUNT['success'] + 1;
                } else {
                    self::$COUNT['error'] = self::$COUNT['error'] + 1;
                }
            }
        }
        switch ($status) {
            case '1':
                Logint::insert('审核用户:' . self::$COUNT['success'] . '个', 'daily');
                break;
            case '3':
                Logint::insert('封禁用户:' . self::$COUNT['success'] . '个', 'daily');
                break;
        }
        return self::$COUNT;
    }
    static function ClerUser($user)
    {
        $map['id'] = ['in', $user];
        $userdata = Db::name('user')->where($map)->select();
        foreach ($userdata as $key => $value) {
            $userFILE = db::name('filelist')->where('user', $value['id'])->select();
            if (count($userFILE) != 0) {
                foreach ($userFILE as $k => $v) {
                    if ($v['type'] === 'dir') {
                        db::name('filelist')->where('id', $v['id'])->delete() ? self::$COUNT['dir'] = self::$COUNT['dir'] + 1 : self::$COUNT['error'] = self::$COUNT['error'] + 1;
                    } else {
                        $FILEMAP['user'] = ['neq', $value['id']];
                        $FILEMAP['fid'] = $v['fid'];
                        if (db::name('filelist')->where($FILEMAP)->count() != 0) {
                            db::name('filelist')->where('id', $v['id'])->delete() ? self::$COUNT['file'] = self::$COUNT['file'] + 1 : self::$COUNT['error'] = self::$COUNT['error'] + 1;
                        } else {
                            $fileMASTER = db::name('filecount')->where('fid', $v['fid'])->find();
                            Tools::getServer($fileMASTER['ssid'], 'remove', array('shareid' => $fileMASTER['shareid']));
                            if (db::name('filecount')->where('fid', $fileMASTER['fid'])->delete() && db::name('filelist')->where('fid', $fileMASTER['fid'])->where('user', $value['id'])->delete()) {
                                self::$COUNT['file'] = self::$COUNT['file'] + 1;
                            } else {
                                self::$COUNT['error'] = self::$COUNT['error'] + 1;
                            }
                        }
                    }
                }
            }
            db::name('user')->where('id', $value['id'])->delete() ? self::$COUNT['success'] = self::$COUNT['success'] + 1 : self::$COUNT['error'] = self::$COUNT['error'] + 1;
            db::name('usercache')->where('uid', $value['id'])->delete() ? '' : self::$COUNT['error'] = self::$COUNT['error'] + 1;
            db::name('share')->where('user', $value['id'])->delete() ? '' : self::$COUNT['share'] = self::$COUNT['share'] + 1;
        }
        Logint::insert('删除用户' . self::$COUNT['success'] . '个,文件' . self::$COUNT['file'] . '个,目录' . self::$COUNT['dir'] . '个,分享' . self::$COUNT['share'] . '个,失败' . self::$COUNT['error'] . '次', 'dialy');
        return self::$COUNT;
    }
    static function getCashlist($params)
    {
        $map = [];
        switch ($params->type) {
            case '全部':

                break;
            case '待提现':
                $map['status'] = 0;
                break;
            case '已提现':
                $map['status'] = 1;
                break;
            case '提现失败':
                $map['status'] = 3;
                break;
        }
        $list = db::view('cash', 'id,uid,status,msg,money,uptime,endtime')
            ->view('user', 'username,nickname,alipay', 'user.id=cash.uid')
            ->where($map)
            ->page($params->page, 50)
            ->order('id DESC')
            ->select();
        return $list;
    }
    static function setCashstatus($params)
    {
        switch ($params->status) {
            case '1':
                $update = [
                    'status' => 1,
                    'msg' => '提现成功'
                ];
                break;
            case '3':
                $update = [
                    'status' => 3,
                    'msg' => $params->msg
                ];
                break;
        }
        $update['endtime'] = date('Y-m-d H:i:s', time());
        if (db::name('cash')->where('id', $params->id)->update($update)) {
            $data = Codeinfo::SUCCESS;
        } else {
            $data = Codeinfo::DBFAILD;
        }
        return $data;
    }
    static function saveCardlink($params)
    {
        if (db::name('syssetting')->find('cardlink')) {
            $update = [
                'content' => $params->cardlink,
                'uptime' => date('Y-m-d H:i:s', time())
            ];
            if (db::name('syssetting')->where('type', 'cardlink')->update($update)) {
                $data = Codeinfo::SUCCESS;
            } else {
                $data = Codeinfo::DBFAILD;
            }
        } else {
            $update = [
                'type' => 'cardlink',
                'content' => $params->cardlink,
                'uptime' => date('Y-m-d H:i:s', time())
            ];
            if (db::name('syssetting')->insert($update)) {
                $data = Codeinfo::SUCCESS;
            } else {
                $data = Codeinfo::DBFAILD;
            }
        }
        return $data;
    }
    static function deleteCard($params)
    {
        $params = json_encode($params);
        $params = json_decode($params, true);
        foreach ($params['rows'] as $key => $value) {
            $iid[] = $value['id'];
        }
        if (db::name('card')->delete($iid)) {
            $data = Codeinfo::SUCCESS;
        } else {
            $data = Codeinfo::DBFAILD;
        }
        return $data;
    }
}
