<?php

namespace app\admin\controller;

use think\captcha\Captcha;
use think\Request;
use think\Db;
use think\Session;
use think\Cookie;
use think\Controller;
use common\Codeinfo;
use common\CloseIP;
use common\Logint;
use common\Tools;

class Index extends Controller
{
    public function _initialize()
    {
        $SESSIP = new CloseIP();
        if ($SESSIP->init()) {
            echo json_encode(Codeinfo::DIEIP);
            die;
        }
    }
    public function index(Request $reqdata)
    {
        $param = $reqdata->param();
        @$model = $param['model'];
        @$params = json_decode($param['params']);
        $data = [];
        $data = Codeinfo::FAILD;
        Cookie::init(['prefix' => 'sys_', 'expire' => 3600, 'path' => '/']);
        switch ($model) {
            case 'ST':
                $data = Codeinfo::SUCCESS;
                if (Session::has('administrator', 'system')) {
                    $data['show'] = Codeinfo::SUCCESS;
                    $data['show']['user']['username'] = Session::get('administrator', 'system');
                } else {
                    $CLOCKFILEPATH = APP_PATH . 'install.lock';
                    if (!is_file($CLOCKFILEPATH)) {
                        $data['show'] = Codeinfo::NOINSTALL;
                    } else {
                        $data['show'] = Codeinfo::SERVERINSTALLCLOCK;
                    }
                }
                break;
            case 'install':
                $data = Codeinfo::SUCCESS;
                $CLOCKFILEPATH = APP_PATH . 'install.lock';
                if (!is_file($CLOCKFILEPATH)) {
                    $data['show'] = self::InstallSystem($params);
                } else {
                    $data['show'] = Codeinfo::SERVERINSTALLCLOCK;
                }
                break;
            case 'login':
                $data = Codeinfo::SUCCESS;
                $captcha = new Captcha();
                $captcha->check($params->code, 2) ? $data['show'] = self::Login($params) : $data['show'] = Codeinfo::CDFAILD;
                break;
            case 'uploadPic':
                $data = Codeinfo::SUCCESS;
                $COMMON = new Common;
                $data['show'] = $COMMON->$model($reqdata->file('file'), $param['type']);
                break;
            case 'IndexData':
            case 'FileList':
            case 'DeleteFile':
            case 'getUser':
            case 'userStatus':
            case 'GetSetitem':
            case 'SetSystem':
            case 'GetServer':
            case 'testserver':
            case 'AddServer':
            case 'ModifyTable':
            case 'Logout':
            case 'importServerDB':
            case 'modifyServer':
            case 'UPstyle':
            case 'getStyle':
            case 'resetPw':
            case 'deleteuserFile':
            case 'buildCard':
            case 'cardList':
            case 'extractCard':
            case 'getItem':
            case 'addItem':
            case 'deleteItem':
            case 'setMarket':
            case 'getMarket':
            case 'getCashlist':
            case 'setCashstatus':
            case 'saveCardlink':
            case 'deleteCard':
                $data = Codeinfo::SUCCESS;
                $COMMON = new Common;
                $data['show'] = $COMMON->$model($params);
                break;
            case 'getver':
            case 'check_right':
            case 'down_pack':
            case 'unzip':
            case 'check_db':
            case 'move_files':
                $data = Codeinfo::SUCCESS;
                $COMMON = new Update;
                $data['show'] = $COMMON->$model($params);
                break;
        }
        $data['ver'] = VER;
        return json($data);
    }
    private function InstallSystem($params)
    {
        !strstr($params->prefix, '_') ? $params->prefix .= '_' : '';
        $dbinfo = [
            'type' => 'mysql',
            'hostname' => $params->dbhost,
            'username' => $params->dbuser,
            'password' => $params->dbpass,
            'prefix' => $params->prefix,
        ];
        $sqlarr = [
            'dbname' => "show databases like '{$params->dbname}'",
            'dbtable' => "show tables like '{$params->prefix}sysuser'",
            'createDBBASE' => "CREATE DATABASE `" . $params->dbname . "` DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;",
            'createTable' => array(
                'album',
                'buylog',
                'card',
                'cash',
                'comment',
                'filecount',
                'filelist',
                'goods',
                'group',
                'log',
                'record',
                'server',
                'servercache',
                'share',
                'statistics',
                'syssetting',
                'sysuser',
                'user',
                'useratta',
                'usercache',
                'userext',
                'userextlog',
                'usersetting',
                'user_center_record',
                'user_fans_count',
                'user_follow',
                'file_sale',
                'click_count'
            )
        ];
        $write = Db::connect($dbinfo);
        try {
            if ($write->execute($sqlarr['dbname']) === 1) {
                $dbinfo['database'] = $params->dbname;
                $write = Db::connect($dbinfo);
                self::createTable($write, $params->dbname, $sqlarr, $params->prefix);
            } else {
                $data = $write->execute($sqlarr['createDBBASE']);
                $dbinfo['database'] = $params->dbname;
                $write = Db::connect($dbinfo);
                self::createTable($write, $params->dbname, $sqlarr, $params->prefix);
            }
            $onlyID = Tools::only(time());
            $adminsql = "INSERT INTO `{$params->prefix}sysuser` VALUES ('1', '{$params->admin}', '" . md5($params->adminpw . $onlyID) . "', '{$onlyID}', '" . date('Y-m-d H:i:s', time()) . "', '', '');";
            $write->execute($adminsql);
            $onlyEnid = Tools::only(time());
            $indexuser = "INSERT INTO `{$params->prefix}user` (`id`, `enid`,`username`, `password`, `salt`, `phone`, `nickname`, `avatar`, `status`, `hash`, `createtime`,`diskspace`, `logintime`, `loginip`) VALUES ('1','{$onlyEnid}' ,'{$params->admin}', '" . md5($params->adminpw . $onlyID) . "', '{$onlyID}', NULL, NULL, NULL, '1', '" . md5('/' . config('system.dirhash') . $params->admin) . "', '',0, NULL, NULL)";

            $write->execute($indexuser);

            $filedir = "INSERT INTO `{$params->prefix}filelist` (`id`, `hash`, `fromHash`, `path`, `fromPath`, `user`, `filename`, `type`, `mime`, `size`, `fid`, `dborder`, `uptime` ,`deserver`) VALUES ('1', '" . md5('/' . config('system.dirhash') . $params->admin) . "', NULL, '/', NULL, '1', '', 'dir', NULL, '', NULL, '99', '" . date('Y-m-d H:i:s', time()) . "','all')";

            $write->execute($filedir);

            file_put_contents(APP_PATH . 'install.lock', time());
            Tools::setconfig('database', ['hostname', 'database', 'username', 'password', 'prefix'], [$params->dbhost, $params->dbname, $params->dbuser, $params->dbpass, $params->prefix]);
            Tools::setconfig('config', ['dirhash', 'loginToken'], [md5($onlyID . time()), md5($onlyID . time() . 'token')]);
            $data = Codeinfo::SUCCESS;
        } catch (\Exception $e) {
            if (strstr($e->getMessage(), 'SQLSTATE[HY000]')) {
                $data = Codeinfo::DBLINKERROR;
                $data['allmsg'] = $e->getMessage();
            }
            if (strstr($e->getMessage(), 'SQLSTATE[42000]')) {
                $data = Codeinfo::DBCREATETABLEERROR;
                $data['allmsg'] = $e->getMessage();
            } else {
                $data = Codeinfo::DBFAILD;
                $data['allmsg'] = $e->getMessage();
            }
        }
        return $data;
    }
    private function createTable($write, $dbbase, $sqlarr, $prefix)
    {
        $sql = '';
        foreach ($sqlarr['createTable'] as $key => $value) {
            switch ($value) {
                case 'album':
                    $sql = "CREATE TABLE `{$prefix}album` (
                        `enid` varchar(8) NOT NULL,
                        `type` varchar(8) NOT NULL,
                        `user` int(11) NOT NULL,
                        `title` varchar(70) NOT NULL,
                        `info` varchar(150) NOT NULL,
                        `thumb` varchar(100) NOT NULL,
                        `content` text NOT NULL,
                        `time` varchar(50) NOT NULL,
                        PRIMARY KEY (`enid`),
                        INDEX `type`(`type`) USING BTREE COMMENT '分类索引',
                        INDEX `user`(`user`) USING BTREE COMMENT '用户索引'
                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'buylog':
                    $sql = "CREATE TABLE `{$prefix}buylog` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `uid` int(11) NOT NULL,
                        `fid` varchar(100) NOT NULL,
                        `from` varchar(50) NOT NULL,
                        `fromuser` int(11) NOT NULL,
                        `title` varchar(100) NOT NULL,
                        `money` int(11) NOT NULL,
                        `time` varchar(50) NOT NULL,
                        PRIMARY KEY (`id`),
                        INDEX `uid`(`uid`) USING BTREE COMMENT '用户ID',
                        INDEX `fromuser`(`fromuser`) USING BTREE COMMENT '买自用户ID'
                      ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'card':
                    $sql = "CREATE TABLE `{$prefix}card` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `cdkey` varchar(100) NOT NULL,
                        `money` int(10) NOT NULL,
                        `status` int(1) NOT NULL,
                        `time` varchar(100) NOT NULL,
                        PRIMARY KEY (`id`),
                        UNIQUE INDEX `cdkey`(`cdkey`) USING BTREE COMMENT '点卡卡号'
                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'cash':
                    $sql = "CREATE TABLE `{$prefix}cash` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `uid` int(11) NOT NULL,
                        `money` double NOT NULL,
                        `score` varchar(20) NOT NULL,
                        `pay` varchar(50) NOT NULL,
                        `uptime` varchar(50) NOT NULL,
                        `status` int(11) NOT NULL,
                        `msg` varchar(100) DEFAULT NULL,
                        `endtime` varchar(100) DEFAULT NULL,
                        PRIMARY KEY (`id`),
                        INDEX `uid`(`uid`) USING BTREE COMMENT '用户ID',
                        INDEX `status`(`status`) USING BTREE COMMENT '提现状态'
                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'comment':
                    $sql = "CREATE TABLE `{$prefix}comment` (
                        `id` 	int(11) NOT NULL AUTO_INCREMENT,
                        `aid` varchar(32) NOT NULL,
                        `content` varchar(255) NOT NULL,
                        `user` varchar(50) NOT NULL,
                        `nickname` varchar(50) NOT NULL,
                        `avatar` varchar(100) NOT NULL,
                        `time` varchar(50) NOT NULL,
                        `vtime` float(100,0) NOT NULL,
                        `color` int(10) NOT NULL,
                        PRIMARY KEY (`id`),
                        INDEX `aid`(`aid`) USING BTREE COMMENT '视频FID',
                        INDEX `user`(`user`) USING BTREE COMMENT '来自用户'
                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'filecount':
                    $sql = "CREATE TABLE `{$prefix}filecount` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `md5` varchar(100) NOT NULL,
                        `fid` varchar(100) NOT NULL,
                        `ssid` varchar(100) NOT NULL,
                        `shareid` varchar(100) NOT NULL,
                        `mime` varchar(100) DEFAULT NULL,
                        `size` varchar(100) NOT NULL,
                        `duration` varchar(50) DEFAULT NULL,
                        `gif` varchar(255) DEFAULT NULL,
                        `mp4` varchar(255) DEFAULT NULL,
                        `orgfile` varchar(255) DEFAULT NULL,
                        `path` varchar(255) DEFAULT NULL,
                        `pic` varchar(255) DEFAULT NULL,
                        `qr` varchar(255) DEFAULT NULL,
                        `title` varchar(255) NOT NULL,
                        `filetype` varchar(50) NOT NULL DEFAULT 'document',
                        `filename` varchar(100) NOT NULL,
                        `user` varchar(100) NOT NULL,
                        `createTime` varchar(100) NOT NULL,
                        PRIMARY KEY (`id`),
                        UNIQUE INDEX `md5`(`md5`) USING BTREE COMMENT '文件MD5',
                        UNIQUE INDEX `fid`(`fid`) USING BTREE COMMENT '盘内文件HASH',
                        UNIQUE INDEX `shareid`(`shareid`) USING BTREE COMMENT 'PPVOD文件标识'
                      ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'filelist':
                    $sql = "CREATE TABLE `{$prefix}filelist` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `hash` varchar(32) DEFAULT NULL,
                        `fromHash` varchar(32) DEFAULT NULL,
                        `path` text NOT NULL,
                        `fromPath` text,
                        `user` int(11) NOT NULL,
                        `filename` varchar(200) NOT NULL,
                        `type` varchar(50) NOT NULL,
                        `mime` varchar(100) DEFAULT NULL,
                        `size` char(100) NOT NULL,
                        `fid` varchar(100) DEFAULT NULL,
                        `deserver` varchar(50) DEFAULT NULL,
                        `dborder` int(2) NOT NULL DEFAULT '0',
                        `uptime` varchar(100) NOT NULL,
                        PRIMARY KEY (`id`),
                        UNIQUE INDEX `hash`(`hash`) USING BTREE COMMENT '唯一路径HASH',
                        INDEX `fromHash`(`fromHash`) USING BTREE COMMENT '上级目录HASH',
                        INDEX `user`(`user`) USING BTREE COMMENT '用户ID',
                        INDEX `fid`(`fid`) USING BTREE COMMENT '盘内文件标识',
                        INDEX `deserver`(`deserver`) USING BTREE COMMENT '目标服务器'
                      ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'goods':
                    $sql = "CREATE TABLE `{$prefix}goods` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `enid` varchar(32) NOT NULL,
                        `type` varchar(50) NOT NULL,
                        `content` varchar(200) NOT NULL,
                        `money` double NOT NULL,
                        `time` varchar(100) NOT NULL,
                        PRIMARY KEY (`id`),
                        UNIQUE INDEX `enid`(`enid`) USING BTREE COMMENT '商品ID',
                        INDEX `type`(`type`) USING BTREE COMMENT '商品类型'
                      ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'group':
                    $sql = "CREATE TABLE `{$prefix}group` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `name` varchar(50) NOT NULL,
                        `auth` int(11) NOT NULL,
                        PRIMARY KEY (`id`)
                      ) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;";

                    break;
                case 'log':
                    $sql = "CREATE TABLE `{$prefix}log` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `type` varchar(100) NOT NULL,
                        `article` text NOT NULL,
                        `createtime` varchar(100) NOT NULL,
                        PRIMARY KEY (`id`)
                    ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'record':
                    $sql = "CREATE TABLE `{$prefix}record` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `uid` int(99) NOT NULL,
                        `card` varchar(128) NOT NULL,
                        `content` varchar(100) NOT NULL,
                        `time` varchar(100) NOT NULL,
                        PRIMARY KEY (`id`),
                        INDEX `uid`(`uid`) USING BTREE COMMENT '用户ID',
                        UNIQUE INDEX `card`(`card`) USING BTREE COMMENT '卡密'
                      ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'server':
                    $sql = "CREATE TABLE `{$prefix}server` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `form` varchar(100) NOT NULL,
                        `ssid` varchar(50) NOT NULL,
                        `baseurl` varchar(200) NOT NULL,
                        `playhost` varchar(200) NOT NULL,
                        `uploadkey` varchar(255) DEFAULT NULL,
                        `apikey` varchar(255) NOT NULL,
                        `guard` varchar(100) DEFAULT NULL,
                        `weight` int(11) NOT NULL DEFAULT '1',
                        PRIMARY KEY (`id`),
                        UNIQUE INDEX `ssid`(`ssid`) USING BTREE COMMENT '服务器ID'
                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'servercache':
                    $sql = "CREATE TABLE `{$prefix}servercache` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `form` varchar(100) NOT NULL,
                        `ssid` varchar(100) NOT NULL,
                        `files` varchar(50) NOT NULL,
                        `disk` varchar(50) NOT NULL,
                        PRIMARY KEY (`id`),
                        UNIQUE INDEX `ssid`(`ssid`) USING BTREE COMMENT '服务器标识'
                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'share':
                    $sql = "CREATE TABLE `{$prefix}share` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `fid` varchar(32) NOT NULL,
                        `shareid` varchar(100) NOT NULL,
                        `user` int(11) NOT NULL,
                        `createTime` varchar(100) NOT NULL,
                        PRIMARY KEY (`id`),
                        UNIQUE INDEX `shareid`(`shareid`) USING BTREE COMMENT '分享ID',
                        INDEX `user`(`user`) USING BTREE COMMENT '用户标识',
                        INDEX `fid`(`fid`) USING BTREE COMMENT '文件标识'
                      ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'statistics':
                    $sql = "CREATE TABLE `{$prefix}statistics` (
                        `aid`  varchar(8) NOT NULL,
                        `vid` varchar(32) NOT NULL,
                        `num` int(11) NOT NULL NOT NULL DEFAULT 0,
                        INDEX `aid`(`aid`) USING BTREE COMMENT '来自',
                        INDEX `vid`(`vid`) USING BTREE COMMENT '文件标识'
                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'syssetting':
                    $sql = "CREATE TABLE `{$prefix}syssetting` (
                        `type` varchar(50) NOT NULL,
                        `content` varchar(255) NOT NULL,
                        `uptime` varchar(100) NOT NULL,
                        PRIMARY KEY (`type`)
                      ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;

                case 'sysuser':
                    $sql = "CREATE TABLE `{$prefix}sysuser` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `username` varchar(100) NOT NULL,
                        `password` varchar(100) NOT NULL,
                        `salt` varchar(8) NOT NULL,
                        `createtime` varchar(200) NOT NULL,
                        `logintime` varchar(200) NOT NULL,
                        `loginip` varchar(100) NOT NULL,
                        PRIMARY KEY (`id`),
                        UNIQUE INDEX `username`(`username`) USING BTREE COMMENT '管理员账号',
                        UNIQUE INDEX `salt`(`salt`) USING BTREE COMMENT '密码混淆密文'
                    ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'user':
                    $sql = "CREATE TABLE `{$prefix}user` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `enid` varchar(15) DEFAULT NULL,
                        `gid` int(11) NOT NULL DEFAULT '1',
                        `username` varchar(100) NOT NULL,
                        `password` varchar(32) NOT NULL,
                        `salt` varchar(8) DEFAULT NULL,
                        `phone` varchar(11) DEFAULT NULL,
                        `nickname` varchar(18) DEFAULT NULL,
                        `avatar` varchar(100) DEFAULT NULL,
                        `status` int(1) NOT NULL DEFAULT '0',
                        `hash` varchar(32) NOT NULL,
                        `createtime` varchar(100) NOT NULL,
                        `diskspace` bigint(20) NOT NULL,
                        `score` double NOT NULL DEFAULT '0',
                        `sign` varchar(100) DEFAULT '他很懒什么也没留下',
                        `alipay` varchar(100) DEFAULT NULL,
                        `logintime` varchar(100) DEFAULT NULL,
                        `loginip` varchar(100) DEFAULT NULL,
                        PRIMARY KEY (`id`),
                        UNIQUE INDEX `enid`(`enid`) USING BTREE COMMENT '用户加密ID',
                        UNIQUE INDEX `username`(`username`) USING BTREE COMMENT '用户账号',
                        UNIQUE INDEX `salt`(`salt`) USING BTREE COMMENT '用户混淆密文',
                        UNIQUE INDEX `hash`(`hash`) USING BTREE COMMENT '用户根路径HASH',
                        INDEX `status`(`status`) USING BTREE COMMENT '用户状态'
                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'useratta':
                    $sql = "CREATE TABLE `{$prefix}useratta` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `uid` int(11) NOT NULL,
                        `gid` int(11) NOT NULL,
                        `content` varchar(50) NOT NULL,
                        `stamp` varchar(100) NOT NULL,
                        `endtime` varchar(100) NOT NULL,
                        `time` varchar(100) NOT NULL,
                        PRIMARY KEY (`id`),
                        INDEX `uid`(`uid`) USING BTREE COMMENT '用户ID'
                      ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'usercache':
                    $sql = "CREATE TABLE `{$prefix}usercache` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `uid` varchar(50) NOT NULL,
                        `username` varchar(100) NOT NULL,
                        `files` varchar(50) NOT NULL,
                        `disksize` varchar(100) NOT NULL,
                        `diskspace` varchar(100) NOT NULL,
                        `diskpro` varchar(50) NOT NULL,
                        `status` int(1) NOT NULL,
                        `createtime` varchar(100) NOT NULL,
                        `logintime` varchar(100) NOT NULL,
                        `loginip` varchar(200) NOT NULL,
                        PRIMARY KEY (`id`),
                        UNIQUE INDEX `uid`(`uid`) USING BTREE COMMENT '用户ID',
                        UNIQUE INDEX `username`(`username`) USING BTREE COMMENT '用户账号'
                    ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'userext':
                    $sql = "CREATE TABLE `{$prefix}userext` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `masteruser` int(11) NOT NULL,
                        `fromuser` int(11) NOT NULL,
                        `uptime` varchar(100) NOT NULL,
                        PRIMARY KEY (`id`),
                        UNIQUE INDEX `masteruser`(`masteruser`) USING BTREE COMMENT '注册用户ID',
                        INDEX `fromuser`(`fromuser`) USING BTREE COMMENT '上级用户ID'
                      ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'userextlog':
                    $sql = "CREATE TABLE `{$prefix}userextlog` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `muser` int(11) NOT NULL,
                        `fuser` int(11) NOT NULL,
                        `content` varchar(100) NOT NULL,
                        `score` int(11) NOT NULL,
                        `time` varchar(50) NOT NULL,
                        PRIMARY KEY (`id`),
                        INDEX `muser`(`muser`) USING BTREE COMMENT '主用户',
                        INDEX `fuser`(`fuser`) USING BTREE COMMENT '受邀用户'
                      ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'usersetting':
                    $sql = "CREATE TABLE `{$prefix}usersetting` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `uid` int(11) NOT NULL,
                        `type` varchar(50) NOT NULL,
                        `content` varchar(255) NOT NULL,
                        PRIMARY KEY (`id`),
                        INDEX `uid`(`uid`) USING BTREE COMMENT '用户ID',
                        INDEX `type`(`type`) USING BTREE COMMENT '用户设置类别'
                      ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'user_center_record':
                    $sql = "CREATE TABLE `{$prefix}user_center_record` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `master` int(8) NOT NULL,
                        `user` int(8) NOT NULL,
                        `time` int(11) NOT NULL,
                        PRIMARY KEY (`id`),
                        INDEX `master`(`master`) USING BTREE COMMENT '主用户',
                        INDEX `user`(`user`) USING BTREE COMMENT '访客'
                      ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'user_fans_count':
                    $sql = "CREATE TABLE `{$prefix}user_fans_count` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `user` int(8) NOT NULL,
                        `fans` int(8) NOT NULL,
                        `time` int(11) NOT NULL,
                        PRIMARY KEY (`id`),
                        UNIQUE INDEX `user`(`user`) USING BTREE COMMENT '主用户'
                      ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'user_follow':
                    $sql = "CREATE TABLE `{$prefix}user_follow` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `master` int(8) NOT NULL,
                        `god` int(8) NOT NULL,
                        `time` int(11) NOT NULL,
                        PRIMARY KEY (`id`),
                        INDEX `master`(`master`) USING BTREE COMMENT '主用户',
                        INDEX `god`(`god`) USING BTREE COMMENT '从用户'
                      ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'file_sale':
                    $sql = "CREATE TABLE `{$prefix}file_sale` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `fid` int(8) NOT NULL,
                        `user` int(8) NOT NULL,
                        `price` int(11) NOT NULL,
                        `time` TIMESTAMP on update CURRENT_TIMESTAMP NULL,
                        PRIMARY KEY (`id`),
                        INDEX `fid`(`fid`) USING BTREE COMMENT '文件标识',
                        INDEX `user`(`user`) USING BTREE COMMENT '所属用户'
                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
                case 'click_count':
                    $sql = "CREATE TABLE `{$prefix}click_count` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                        `type` varchar(5) NOT NULL,
                        `aid` varchar(32) NOT NULL,
                        `click` int(11) NOT NULL,
                        `time` TIMESTAMP on update CURRENT_TIMESTAMP NULL,
                        PRIMARY KEY (`id`),
                        INDEX `type`(`type`) USING BTREE COMMENT '统计类别',
                        INDEX `aid`(`aid`) USING BTREE COMMENT '文件标识'
                        ) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
                    break;
            }
            $cler = "DROP TABLE IF EXISTS `{$prefix}{$value}`;";
            $write->execute($cler);
            $write->execute($sql);
            switch ($value) {
                case 'group':
                    $insert = "INSERT INTO `{$prefix}group` VALUES ('1', '普通会员', '0');";
                    $write->execute($insert);
                    $insert = "INSERT INTO `{$prefix}group` VALUES ('2', 'VIP会员', '10');";
                    $write->execute($insert);
                    break;
                case 'syssetting':
                    $insert = "INSERT INTO `{$prefix}syssetting` VALUES ('cardlink', '', '2019-07-25 23:00:00');";
                    $write->execute($insert);
                    $insert = "INSERT INTO `{$prefix}syssetting` VALUES ('markketing', '{\"onereward\":\"10\",\"tworeward\":\"3\",\"system\":\"10\",\"minimumcash\":\"5\",\"change\":\"1000\"}', '2019-07-25 17:41:37');";
                    $write->execute($insert);
            }
        }
    }
    private function Login($params)
    {
        $data['status'] = false;
        if ($user = db::name('sysuser')->where('username', $params->username)->find()) {
            if ($user['password'] === md5($params->password . $user['salt'])) {
                $data = Codeinfo::SUCCESS;
                $data['user'] = array(
                    'uid' => $user['id'],
                    'username' => $user['username'],
                );
                db::name('sysuser')->where('id', $user['id'])->setField('loginip', $_SERVER['REMOTE_ADDR']);
                Session::set('administrator', $user['username'], 'admin');
                Cookie::set('t', time());
                Logint::insert('管理员登陆IP:' . $_SERVER['REMOTE_ADDR']);
                $data['status'] = true;
            } else {
                $data = Codeinfo::PWFAILD;
            }
        } else {
            $data = Codeinfo::NOUSER;
        }
        return $data;
    }
}
