<?php
namespace app\admin\controller;
use think\Db;
use common\Download;
use common\Dbbase;
class Update extends Common{
    private $APURI='https://file.ppvod.cc/update/update.json';
    private $SERVER_INFO;
    private $TO_VER;
    private $TMP_DIR;
    public function _initialize(){
        parent::_initialize();
        $this->SERVER_INFO=json_decode(file_get_contents($this->APURI),true);
        if (@$this->SERVER_INFO['packlist'][VER]) {
            $this->TO_VER=$this->SERVER_INFO['packlist'][VER];
            $this->TMP_DIR=APP_PATH.'tmp/'.$this->TO_VER['md5'];
        }
        
    }
    public function check_right(){
        if ($this->MkTmpDir($this->TO_VER['md5'],'')) {
            $data['status']=true;
            $data['msg']="创建补丁目录成功";
        }else{
            $data['status']=false;
            $data['msg']="创建补丁目录失败检查目录权限";
        }
        return $data;
    }
    public function move_files() {
        $oldDir=$this->TMP_DIR.'/files';
        $aimDir=ROOT_PATH;
        if (self::moveDir($oldDir,$aimDir,true)) {
            $data['msg']="覆盖完成";
            $data['status']=true;
        }else{
            $data['msg']="覆盖失败,检查文件权限";
            $data['status']=false;
        }
        return $data;
    }
    private function moveDir($oldDir, $aimDir, $overWrite = false) {
        $aimDir = str_replace('', '/', $aimDir);
        $aimDir = substr($aimDir, -1) == '/' ? $aimDir : $aimDir . '/';
        $oldDir = str_replace('', '/', $oldDir);
        $oldDir = substr($oldDir, -1) == '/' ? $oldDir : $oldDir . '/';
        if (!is_dir($oldDir)) {
            return false;
        }
        if (!file_exists($aimDir)) {
            self::createDir($aimDir);
        }
        @ $dirHandle = opendir($oldDir);
        if (!$dirHandle) {
            return false;
        }
        while (false !== ($file = readdir($dirHandle))) {
            if ($file == '.' || $file == '..') {
                continue;
            }
            if (!is_dir($oldDir . $file)) {
                self::moveFile($oldDir . $file, $aimDir . $file, $overWrite);
            } else {
                self::moveDir($oldDir . $file, $aimDir . $file, $overWrite);
            }
        }
        closedir($dirHandle);
        return rmdir($oldDir);
    }
    private function moveFile($fileUrl, $aimUrl, $overWrite = false) {
        if (!file_exists($fileUrl)) {
            return false;
        }
        if (file_exists($aimUrl) && $overWrite = false) {
            return false;
        }elseif (file_exists($aimUrl) && $overWrite = true) {
            self::unlinkFile($aimUrl);
        }
        $aimDir = dirname($aimUrl);
        self::createDir($aimDir);
        rename($fileUrl, $aimUrl);
        return true;
    }
    private function createDir($aimUrl) {
        $aimUrl = str_replace('', '/', $aimUrl);
        $aimDir = '';
        $arr = explode('/', $aimUrl);
        $result = true;
        foreach ($arr as $str) {
            $aimDir .= $str . '/';
            if (!file_exists($aimDir)) {
                $result = mkdir($aimDir);
            }
        }
        return $result;
    }
    private function unlinkDir($aimDir) {
        $aimDir = str_replace('', '/', $aimDir);
        $aimDir = substr($aimDir, -1) == '/' ? $aimDir : $aimDir . '/';
        if (!is_dir($aimDir)) {
            return false;
        }
        $dirHandle = opendir($aimDir);
        while (false !== ($file = readdir($dirHandle))) {
            if ($file == '.' || $file == '..') {
                continue;
            }
            if (!is_dir($aimDir . $file)) {
                FileUtil :: unlinkFile($aimDir . $file);
            } else {
                FileUtil :: unlinkDir($aimDir . $file);
            }
        }
        closedir($dirHandle);
        return rmdir($aimDir);
    }
    private function unlinkFile($aimUrl) {
        if (file_exists($aimUrl)) {
            unlink($aimUrl);
            return true;
        } else {
            return false;
        }
    }
    public function check_db(){
        if(!file_exists($this->TMP_DIR.'/sql.sql')){
            $data['msg']='暂无数据库操作';
            $data['status']=true;
        }else{
            $config=array(
                'path'     => APP_PATH .'DBbackup/',//数据库备份路径
                'part'     => 20971520,//数据库备份卷大小
                'compress' => 0,//数据库备份文件是否启用压缩 0不压缩 1 压缩
                'level'    => 9 //数据库备份文件压缩级别 1普通 4 一般  9最高
            );
            $db= new Dbbase($config);
            $tables=$db->dataList();
            $file=['name'=>date('Ymd-His'),'part'=>1];
            foreach ($tables as $key => $value) {
                $db->setFile($file)->backup($value['name'], 0);
            }
            $sql=file_get_contents($this->TMP_DIR.'/sql.sql');
            $database=Db::connect();
            if (!empty($sql)) {
                $sql=str_replace('vd_',config('database')['prefix'],$sql);
                //$sql .= $sql;
                $sql=str_replace(PHP_EOL,'',$sql);
                preg_match_all('/(.*?);/i',$sql,$sqllist);
                $status=true;
                foreach ($sqllist[1] as $key => $value) {
                    if ($status) {
                        $msg=$database->execute($sqllist[1][$key].';');
                        if ($msg>=0) {
                            $data['msg']="数据库更新成功";
                            $data['status']=true;
                            $status=true;
                        }else{
                            $data['all']=$sqllist[1][$key];
                            $data['sdf']=$msg;
                            $data['msg']="数据库更新失败";
                            $data['status']=false;
                            $status=false;
                        }
                    }
                }
            }else{
                $data['msg']="读取数据库更新表失败";
                $data['status']=false;
            }

        }
        return $data;
    }
    public function unzip(){
        $data['msg']=$this->get_zip_originalsize($this->TMP_DIR.'/'.$this->TO_VER['md5'].'.zip',$this->TMP_DIR.'/');
        $data['status']=true;
        return $data;
    }
    public function down_pack(){
        $dw=new Download;
        if(@!$this->TO_VER['pack_url']){
            $data['status']=false;
            $data['msg']="无可用升级包";
            return $data;
        }
        $dw->OpenUrl($this->TO_VER['pack_url']);
        $dw->SaveToBin($this->TMP_DIR.'/'.$this->TO_VER['md5'].'.zip');
        $dw->Close();
        if ($dw->m_error===0) {
            $data['status']=true;
            $data['msg']="获取升级包成功";
        }else{
            $data['status']=false;
            $data['msg']=$dw->m_error;
        }
        return $data;
    }
    public function getver(){
        try {
            $data['status']=true;
            $data['current_ver']=VER;
            $data['minute']=$this->SERVER_INFO;
        } catch (\Throwable $th) {
            $data['status']=false;
            $data['msg']=$th;
        }

        return $data;
    }
    private function MkTmpDir($tmpdir,$filename)
    {
        $basedir = APP_PATH.'tmp/'.$tmpdir;
        $dirname = trim(preg_replace("#[\\\\\/]{1,}#", '/', $filename));
        $dirname = preg_replace("#([^\/]*)$#","",$dirname);
        if(!is_dir($basedir)) 
        {
            mkdir($basedir,0777,true);
        }
        if($dirname=='') 
        {
            return TRUE;
        }
        $dirs = explode('/', $dirname);
        $curdir = $basedir;
        foreach($dirs as $d)
        {
            $d = trim($d);
            if(empty($d)) continue;
            $curdir = $curdir.'/'.$d;
            if(!is_dir($curdir)) 
            {
                mkdir($curdir, 0777) or die($curdir);
            }
        }
        return TRUE;
    }
    public function get_zip_originalsize($filename, $path) {
        //先判断待解压的文件是否存在
        if(!file_exists($filename)){
          return $filename.'不存在';
        }
        $starttime = explode(' ',microtime()); //解压开始的时间
      
        //将文件名和路径转成windows系统默认的gb2312编码，否则将会读取不到
        $filename = iconv("utf-8","gb2312",$filename);
        $path = iconv("utf-8","gb2312",$path);
        //打开压缩包
        $resource = zip_open($filename);
        $i = 1;
        //遍历读取压缩包里面的一个个文件
        while ($dir_resource = zip_read($resource)) {
          //如果能打开则继续
          if (zip_entry_open($resource,$dir_resource)) {
            //获取当前项目的名称,即压缩包里面当前对应的文件名
            $file_name = $path.zip_entry_name($dir_resource);
            
            //以最后一个“/”分割,再用字符串截取出路径部分
            $file_path = substr($file_name,0,strrpos($file_name, "/"));
            //如果路径不存在，则创建一个目录，true表示可以创建多级目录
            if(!is_dir($file_path)){
              mkdir($file_path,0777,true);
            }
            //如果不是目录，则写入文件
            if(!is_dir($file_name)){
              //读取这个文件
              $file_size = zip_entry_filesize($dir_resource);
              //最大读取6M，如果文件过大，跳过解压，继续下一个
              if($file_size<(1024*1024*30)){
                $file_content = zip_entry_read($dir_resource,$file_size);
                file_put_contents($file_name,$file_content);
              }else{
                return $i++." 此文件已被跳过，原因：文件过大， -> ".iconv("gb2312","utf-8",$file_name);
              }
            }
            //关闭当前
            zip_entry_close($dir_resource);
          }
        }
        //关闭压缩包
        zip_close($resource);
        $endtime = explode(' ',microtime()); //解压结束的时间
        $thistime = $endtime[0]+$endtime[1]-($starttime[0]+$starttime[1]);
        $thistime = round($thistime,3); //保留3为小数
        return '解压完成耗时:'.$thistime.'秒';
    }
}