<?php

namespace app\common\controller;

use think\{Session, Db, Cookie, Cache, Controller, Config, Validate};
use common\{Codeinfo, Logint, Tools, Hithandle, Sign, Modifyfile};

class Common extends Controller
{
    public $uid = '';
    /**
     * @var static 用户ID
     * 
     * */
    private $username = '';
    /**
     * @var static 用户名称
     *  */
    private $exp = '';
    /**
     * @var static token失效日期
     *  */
    private $pagesize = 20;
    /**
     * @var static 数据分页大小
     *  */
    private $usercache = [];
    private $config;
    public function _initialize()
    {
        if (!Session::has('user', 'index') || empty(Cookie::get('token'))) {
            echo json_encode(Codeinfo::NOLOGIN);
            die;
        }
        $checkSign = new Sign();
        $detoken = $checkSign->decode(Cookie::get('token'), Config('system.loginToken'), ['HS256']);
        if (!$detoken || gettype($detoken) != 'object') {
            echo json_encode(Codeinfo::TOKENFAILD);
            die;
        }
        if (Session::get('user.username', 'index') != $detoken->user->username) {
            echo json_encode(Codeinfo::TOKENFAILD);
            die;
        }
        if (Session::get('user.status', 'index') != 1) {
            echo json_encode(Codeinfo::USERSTATUS . Session::get('user.status', 'index'));
            die;
        }
        $this->exp = $detoken->exp;
    }
    public function __construct()
    {
        parent::__construct();
        $this->uid = Session::get('user.id', 'index');
        $this->username = Session::get('user.username', 'index');
        $this->usercache = Cache::get('usercache' . $this->uid);
        switch ($this->usercache['status']) {
            case '3':
                echo json_encode(Codeinfo::USERSTATUS3);
                die;
                break;
            case '4':
                echo json_encode(Codeinfo::USERSTATUS4);
                die;
                break;
        }
        $this->config = json_decode(file_get_contents(APP_PATH . 'config.json'), true);
    }
    private $status = array(
        'file' => 0,
        'dir' => 0,
        'faild' => 0,
        'success' => 0,
        'repeat' => 0
    );
    public function loginout()
    {
        Cache::rm('usercache' . $this->uid);
        Session::clear('index');
        Cookie::clear('cp_');
        return true;
    }
    public function getserverlist()
    {
        $list = Db::name('server')
            ->where('weight<>0')
            ->order('weight DESC')
            ->field('ssid,form')
            ->select();
        return $list;
    }
    public function push($params)
    {
        $map['id'] = ['in', $params->ids];
        $map['user'] = $this->uid;
        $map['type'] = 'video';

        if (isset($this->config['system']['publicoff']) && $this->config['system']['publicoff'] === 1) {
            $map['user'] = ['in', [$this->uid, 1]];
        } else {
            $map['user'] = $this->uid;
        }
        $filedb = db::view('filelist', 'id,fid,user,fromPath,fromHash')
            ->view('filecount', 'title,shareid,path,size,fid,duration,ssid,createTime,pic,mp4', 'filecount.fid=filelist.fid')
            ->view('server', 'ssid,playhost', 'server.ssid=filecount.ssid')
            ->where($map)
            ->select();
        $newDB = [];
        foreach ($filedb as $key => $value) {
            unset($value['id']);
            $form = 'default';
            if ($value['fromPath'] != '/' && $value['fromHash']) {
                $form = db::name('filelist')->where('hash', $value['fromHash'])->field('filename')->value('filename');
            }
            $newDB[] = [
                'createtime' => $value['createTime'],
                'name' => $value['title'],
                'pic' => $value['playhost'] . $value['pic'],
                'size' => Tools::formatBytes($value['size']),
                'share' => $value['playhost'] . '/share/' . $value['shareid'],
                'm3u8' => $value['playhost'] . $value['path'] . '/index.m3u8',
                'mp4' => $value['playhost'] . $value['mp4'],
                'form' => $form,
                'duration' => $value['duration']
            ];
            unset($form);
        }
        $data['apuri'] = db::name('usersetting')->where('uid', $this->uid)->field('content')->find();
        $data['apuri'] = json_decode($data['apuri']['content']);
        $data['article'] = $newDB;
        return $data;
    }
    public function CopyInfo($params)
    {
        $data = Codeinfo::SUCCESS;
        //$map['user'] = $this->uid;
        $map['id'] = ['in', $params->ids];
        $map['type'] = 'video';
        $VDB = db::view('filelist', 'fid,id,user,filename')
            ->view('filecount', 'pic,mp4,shareid,ssid,path', 'filecount.fid=filelist.fid')
            ->view('server', 'playhost', 'server.ssid=filecount.ssid')
            ->where($map)
            ->order('filename desc')
            ->select();
        $html = '';
        switch ($params->type) {
            case 'pic':
                foreach ($VDB as $key => $value) {
                    if ($key == count($VDB) - 1) {
                        $html .= $value['filename'] . "\${$value['playhost']}{$value['pic']}";
                    } else {
                        $html .= $value['filename'] . "\${$value['playhost']}{$value['pic']}" . PHP_EOL;
                    }
                }
                break;
            case 'm3u8':
                foreach ($VDB as $key => $value) {
                    if ($key == count($VDB) - 1) {
                        $html .= $value['filename'] . "\${$value['playhost']}{$value['path']}/index.m3u8";
                    } else {
                        $html .= $value['filename'] . "\${$value['playhost']}{$value['path']}/index.m3u8" . PHP_EOL;
                    }
                }
                break;
            case 'mp4':
                foreach ($VDB as $key => $value) {
                    if ($key == count($VDB) - 1) {
                        $html .= $value['filename'] . "\${$value['playhost']}{$value['mp4']}";
                    } else {
                        $html .= $value['filename'] . "\${$value['playhost']}{$value['mp4']}" . PHP_EOL;
                    }
                }
                break;
            case 'share':
                foreach ($VDB as $key => $value) {
                    if ($key == count($VDB) - 1) {
                        $html .= $value['filename'] . "\${$value['playhost']}/share/{$value['shareid']}";
                    } else {
                        $html .= $value['filename'] . "\${$value['playhost']}/share/{$value['shareid']}" . PHP_EOL;
                    }
                }
                break;
        }
        $data['content'] = $html;
        return $data;
    }
    public function upserver($params)
    {
        $data = Codeinfo::SUCCESS;
        switch ($params->listen) {
            case 'all':
                $list = Db::name('server')->where('weight<>0')->order('weight DESC')->select();
                break;

            default:
                $list = Db::name('server')->where('ssid', $params->listen)->select();
                break;
        }

        if (count($list) == 0) {
            $data = Codeinfo::NOUPSERVER;
            return $data;
        }
        $data['sid'] = $list[0]['ssid'];
        $data['baseUrl'] = $list[0]['baseurl'] . Tools::CHECKFILE;
        $data['master_key'] = $list[0]['uploadkey'];
        return $data;
    }
    public function getnotice()
    {
        try {
            $data = Codeinfo::SUCCESS;
            $notice = json_decode(file_get_contents(APP_PATH . 'config.json'), true)['system'];
            $data['notice'] = !$notice['notice'] ? false : true;
            $data['content'] = $notice['notice'];
        } catch (\Exception $th) {
            $data = Codeinfo::RIGHTFAILD;
            $data['allmsg'] = $th->getMessage();
        }
        return $data;
    }
    public function soDir($params)
    {
        if (empty($params->type) || empty($params->path)) {
            $data = Codeinfo::NODIR;
            return $data;
            die;
        }
        $dirdb = [];
        switch ($params->type) {
            case 'all':

                $dirdb = db::name('filelist')
                    ->where('path', $params->path)
                    ->where('user', $this->uid)
                    ->field('hash')
                    ->where('type', 'dir')
                    ->where('deserver', 'all')
                    ->find();
                break;
            case 'public':
                $params->path = str_replace('/公共资源', '', $params->path);
                $dirdb = db::name('filelist')
                    ->where('path', $params->path ? $params->path : '/')
                    ->where('user', 1)
                    ->field('hash')
                    ->where('type', 'dir')
                    ->find();
                break;
            default:
                $map['path'] = $params->path;
                $map['deserver'] = $params->type;
                $map['user'] = $this->uid;
                if (!db::name('server')->where('ssid', $params->type)->field('id')->find()) {
                    $data = Codeinfo::NODIR;
                    return $data;
                    die;
                }
                $map['type'] = 'dir';
                if ($params->path === '/') {
                    if (!$dirdb = db::name('filelist')->where($map)->field('hash')->find()) {
                        $dirdb = array(
                            'hash' => md5(config('dirhash') . $this->uid . uniqid($params->type, true)),
                            'fromHash' => '',
                            'path' => '/',
                            'fromPath' => '',
                            'user' => $this->uid,
                            'filename' => '',
                            'type' => 'dir',
                            'size' => '-',
                            'dborder' => 99,
                            'deserver' => $params->type,
                            'uptime' => date('Y-m-d H:i:s', time())
                        );
                        db::name('filelist')->insert($dirdb);
                    }
                } else {
                    $dirdb = db::name('filelist')->where($map)->field('hash')->find();
                }
                break;
        }

        if ($dirdb) {
            $data['status'] = true;
            $data['hash'] = $dirdb['hash'];
        } else {
            $data = Codeinfo::NODIR;
        }
        return $data;
    }
    public function fileList($params)
    {
        if ($params->dir === "/") {
            $fileOrder = db::name('filelist')
                ->field('hash')
                ->order('dborder desc,id desc')
                ->where('fromPath', $params->dir)
                ->where('user', $this->uid)
                ->page($params->page, $params->pageSize)
                ->select();
            $ids = [];
            foreach ($fileOrder as $key => $value) {
                $ids[] = $value['hash'];
            }
            unset($key);
            unset($value);
            $filelistDB = db::view('filelist', 'filename,id,type,size,uptime,hash,path,fid,deserver,dborder')
                ->view('share', 'shareid', ['share.fid=filelist.fid', 'share.user=filelist.user'], 'LEFT')
                ->view('FileSale', 'price', ['FileSale.fid=filelist.fid', 'FileSale.user=filelist.user'], 'LEFT')
                ->view('server', 'form', 'server.ssid=filelist.deserver', 'LEFT')
                ->where('filelist.hash', 'in', $ids)
                ->orderRaw('field(filelist.hash,' . "'" . implode("','", $ids) . "'" . ')')
                ->select();
            if ($this->uid != 1) {
                if (isset($this->config['system']['publicoff']) && $this->config['system']['publicoff'] === 1) {
                    $publicdb = db::name('filelist')
                        ->where('user', 1)
                        ->where('type', 'dir')
                        ->where('path', '/')
                        ->field('hash,type')
                        ->find();
                    $publicdb['path'] = '/';
                    $publicdb['filename'] = '公共资源';
                    $publicdb['dborder'] = 99;
                    $publicdb['size'] = '-';
                    $publicdb['form'] = '公共资源';
                    $publicdb['deserver'] = 'public';
                    $filelistDB[] = $publicdb;
                }
            }

            $data['total'] = db::name('filelist')
                //->where('fromHash',$params->hash)
                ->where('fromPath', $params->dir)
                ->where('user', $this->uid)
                ->count();
        } else {
            $fileOrder = db::name('filelist')
                ->field('hash')
                ->order('dborder desc,id desc')
                ->where('fromHash', $params->hash)
                ->where('fromPath', $params->dir)
                ->where('user', $this->uid)
                ->page($params->page, $params->pageSize)
                ->select();
            $ids = [];
            foreach ($fileOrder as $key => $value) {
                $ids[] = $value['hash'];
            }
            unset($key);
            unset($value);
            $filelistDB = db::view('filelist', 'filename,id,type,size,uptime,hash,path,fid,deserver,dborder')
                ->view('share', 'shareid', 'share.fid=filelist.fid', 'LEFT')
                ->view('server', 'form', 'server.ssid=filelist.deserver', 'LEFT')
                ->view('FileSale', 'price', ['FileSale.fid=filelist.fid', 'FileSale.user=filelist.user'], 'LEFT')
                ->where('filelist.hash', 'in', $ids)
                ->limit($params->pageSize)
                ->orderRaw('field(filelist.hash,' . "'" . implode("','", $ids) . "'" . ')')
                ->select();
            $data['total'] = db::name('filelist')
                ->where('fromHash', $params->hash)
                ->where('fromPath', $params->dir)
                ->where('user', $this->uid)
                ->count();
        }
        foreach ($filelistDB as $key => $value) {
            if (!isset($value['shareid']) && $value['type'] != 'dir') {
                $filelistDB[$key]['shareid'] = $this->createShare(['fid' => $value['fid'], 'user' => $this->uid])['shareid'];
            }
        }
        $data['page'] = $params->page;
        $data['pagesize'] = $params->pageSize;
        $data['list'] = $filelistDB;
        return $data;
    }
    public function ifymd5($params)
    {
        $UCC = db::view('user', 'diskspace')
            ->view('usercache', 'disksize', 'usercache.uid=user.id')
            ->find($this->uid);
        if (($UCC['diskspace'] - $UCC['disksize']) <= $params->size && $UCC['diskspace'] != 0) {
            $data = Codeinfo::DISKFULL;
            return $data;
            die;
        }
        $FILEMAP['user'] = $this->uid;
        $FILEMAP['hash'] = $params->hash;
        $FILEMAP['type'] = 'dir';
        $FILEMAP['path'] = $params->path;
        if (!db::name('filelist')->where($FILEMAP)->find()) {
            return Codeinfo::FAILD;
        }
        $data = Codeinfo::FILENOHIT;
        if ($filedb = db::name('filecount')->where('md5', $params->md5)->find()) {
            $data = Codeinfo::FILEHIT;
            $data['fid'] = $filedb['fid'];
        } else {
            //待修正区域 遍历所有服务器
            $yzmserver = Db::name('server')->select();
            foreach ($yzmserver as $key => $value) {
                $reqpar = array(
                    'md5' => $params->md5,
                    'name' => $params->name
                );
                $json = Tools::getServer($value['ssid'], 'md5Check', $reqpar);

                if ($json) {
                    if (@$json->err_code === 2) {
                        $data = Codeinfo::DOMAINFAILD;
                        return $data;
                        die;
                    }
                    if (@$json->err_code === 1) {
                        $data = ['code' => '403KF', 'info' => '目标服务器上传秘钥错误', 'status' => false];
                        return $data;
                        die;
                    }
                    if ($json->ifExist === 1) {
                        !@$json->md5 ? $json->md5 = $params->md5 : '';
                        $json->user = $this->username;
                        $json->size == 0 ? $json->size = $params->size : '';
                        $json->ssid = $value['ssid'];
                        $json->title = $params->name;
                        $dbadd = Tools::fileStandard($json);
                        if (db::name('filecount')->data($dbadd)->insert()) {
                            $data = Codeinfo::FILEHIT;
                            $data['fid'] = $dbadd['fid'];
                            $obj = [
                                'title' => $dbadd['title'],
                                'qr' => $dbadd['qr'],
                                'share' => '/share/' . $dbadd['shareid'],
                                'type' => $dbadd['filetype'],
                                'fid' => $dbadd['fid'],
                                'path' => '/',
                                'createTime' => date('Y-m-d H:i:s')
                            ];
                            $obj = json_encode($obj);
                            self::createShare(json_decode($obj));
                            $cachedb = array(
                                'ssid' => $dbadd['ssid'],
                            );
                            Hithandle::cacheChange('server', 'update', $cachedb);
                        }
                    }
                }
            }
        }
        return $data;
    }
    public function addFile($params)
    {
        $map['path'] = $params->path;
        $map['hash'] = $params->hash;
        $map['type'] = 'dir';
        $map['user'] = $this->uid;
        if (!db::name('filelist')->where($map)->find()) {
            return Codeinfo::NODIR;
            die;
        }
        if (!$file = db::name('filecount')->where('fid', $params->file->fid)->find()) {
            return Codeinfo::FILEFAILD;
            die;
        }
        if ($params->deserver != 'all') {
            if (!db::name('server')->where('ssid', $params->deserver)->find()) {
                return Codeinfo::NOUPSERVER;
                die;
            }
        }
        if (!empty(db::name('filelist')->where(['fid' => $file['fid'], 'fromPath' => $params->path, 'user' => $this->uid])->find())) {
            $data['info'] = "当前目录存在相同文件";
            $data['status'] = false;
            return $data;
            die;
        }
        $dbdata = array(
            'hash' => md5(($params->path === '/') ? $params->path . $params->file->filename : $params->path . '/' . $params->file->filename . config('dirhash') . $this->uid . uniqid('', true)),
            'fromHash' => $params->hash,
            'path' => ($params->path === '/') ? $params->path . $params->file->filename : $params->path . '/' . $params->file->filename,
            'fromPath' => $params->path,
            'user' => $this->uid,
            'filename' => $params->file->filename,
            'type' => $file['filetype'],
            'mime' => $file['mime'],
            'size' => $file['size'],
            'fid' => $file['fid'],
            'deserver' => $params->deserver,
            'uptime' => date('Y-m-d H:i:s', time())
        );

        if (db::name('filelist')->data($dbdata)->insert()) {
            Hithandle::cacheChange('user', 'update');
            $data = Codeinfo::SUCCESS;
        } else {
            $data = Codeinfo::DBFAILD;
        }
        return $data;
    }
    public function mkdir($params)
    {
        $faild = ['<', '>', '?', ' ', '%', '&', '/'];
        foreach ($faild as $k => $v) {
            if (strpos($params->dirname, $v) !== false) {
                return Codeinfo::FAILD;
            }
        }
        $map = [];
        $map['deserver'] = $params->type;
        $map['user'] = $this->uid;
        $map['type'] = 'dir';
        $map['hash'] = $params->hash;
        if (!db::name('filelist')
            ->where($map)
            ->find()) {
            $data = Codeinfo::NODIR;
            return $data;
            die;
        }
        unset($map['hash']);
        $map['fromHash'] = $params->hash;
        $map['filename'] = $params->dirname;
        if (db::name('filelist')
            ->where($map)
            ->find()
        ) {
            $data = Codeinfo::REPEATDIR;
        } else {
            $dirdata = array(
                'hash' => md5(($params->path === '/') ? $params->path . $params->dirname : $params->path . '/' . $params->dirname . config('dirhash') . $this->uid . uniqid('', true)),
                'fromHash' => $params->hash,
                'path' => ($params->path === '/') ? $params->path . $params->dirname : $params->path . '/' . $params->dirname,
                'fromPath' => $params->path,
                'user' => $this->uid,
                'filename' => $params->dirname,
                'type' => 'dir',
                'size' => '-',
                'dborder' => 99,
                'deserver' => $params->type,
                'uptime' => date('Y-m-d H:i:s', time())

            );
            if (db::name('filelist')->data($dirdata)->insert()) {
                $data = Codeinfo::MKDIRSUCCESS;
            } else {
                $data = Codeinfo::DBFAILD;
            }
        }
        return $data;
    }
    public function enfileid($str, $str1)
    {
        return md5(uniqid(md5($str . $str1), true));
    }
    public function createShare($params)
    {
        if (gettype($params) === 'object') {
            $date = [
                'fid' => $params->fid,
                'user' => $this->uid
            ];
        } else {
            $date = [
                'fid' => $params['fid'],
                'user' => $params['user']
            ];
        }

        $share = new \app\common\model\Share($date);
        $sdb = $share->create_share();
        $data['sharelink'] = @$_SERVER['HTTP_HOST'] . '/s/' . $sdb;
        $data['shareid'] = $sdb;
        return $data;
    }
    public function getFile($params)
    {
        $ufile = db::name('filelist')
            ->where('id', $params->id)
            ->where('fid', $params->fid)
            ->where('user', $this->uid)
            ->where('path', $params->path)
            ->where('type', 'NEQ', 'dir')
            ->find();
        if (!$ufile) {
            $data = Codeinfo::FILEFAILD;
            return $data;
        }
        $file = Db::view('filecount', 'shareid,pic,path,filetype,orgfile')
            ->view('server', 'playhost', 'server.ssid=filecount.ssid')
            ->where('fid', 'eq', $ufile['fid'])
            ->find();
        $addfile = [];
        if ($file) {
            $data = Codeinfo::SUCCESS;
            $file['title'] = $ufile['filename'];
            $file['upath'] = $params->path;
            $data['fileinfo'] = $file;
        } else {
            $data = Codeinfo::FILEFAILD;
        }
        return $data;
    }
    public function deleteFile($params, $type = 'default')
    {
        $addfile = [];
        $map['user'] = $this->uid;
        $map['path'] = ['neq', '/'];
        $listdb = db::name('filelist')->where('id', 'in', $params->id)->where($map)->select();
        foreach ($listdb as $key => $value) {
            if ($value['type'] === 'dir') {
                self::foreachDelete($value['id']);
            } else {
                if (db::name('filelist')->where('fid', $value['fid'])->count() <= 1) {
                    $master_filedb = db::name('filecount')->where('fid', $value['fid'])->find();
                    if ($this->uid === 1) {
                        $reqpar = array(
                            'shareid' => $master_filedb['shareid']
                        );
                        Tools::getServer($master_filedb['ssid'], 'remove', $reqpar);
                    }

                    if ($type === 'default') {

                        db::name('filecount')->where('fid', $value['fid'])->delete();
                    }
                }
                if (db::name('filelist')->where('id', $value['id'])->delete()) {
                    $this->status['file'] = $this->status['file'] + 1;
                } else {
                    $this->status['faild'] = $this->status['faild'] + 1;
                }
            }
        }
        $data = Codeinfo::SUCCESS;
        Hithandle::cacheChange('user', 'update');
        $data['count'] = $this->status;
        return $data;
    }
    public function foreachDelete($id)
    {
        $filedb = db::name('filelist')->where('id', $id)->find();
        $nextmap['fromHash'] = $filedb['hash'];
        $nextdb = db::name('filelist')->where($nextmap)->select();
        foreach ($nextdb as $key => $value) {
            if ($value['type'] === 'dir') {
                self::foreachDelete($value['id']);
                if (db::name('filelist')->where('id', $value['id'])->delete()) {
                    $this->status['dir'] = $this->status['dir'] + 1;
                } else {
                    $this->status['faild'] = $this->status['faild'] + 1;
                }
            } else {
                if (db::name('filelist')->where('fid', $value['fid'])->count() <= 1) {
                    $master_filedb = db::name('filecount')->where('fid', $value['fid'])->find();
                    $master_server = db::name('server')->where('ssid', $master_filedb['ssid'])->find();
                    if ($this->uid === 1) {
                        $reqpar = array(
                            'shareid' => $master_filedb['shareid']
                        );
                        Tools::getServer($master_filedb['ssid'], 'remove', $reqpar);
                    }

                    db::name('filecount')->where('fid', $value['fid'])->delete();
                }
                if (db::name('filelist')->where('id', $value['id'])->delete()) {
                    $this->status['file'] = $this->status['file'] + 1;
                } else {
                    $this->status['faild'] = $this->status['faild'] + 1;
                }
            }
        }
        if (db::name('filelist')->where('id', $filedb['id'])->delete()) {
            $this->status['dir'] = $this->status['dir'] + 1;
        } else {
            $this->status['faild'] = $this->status['faild'] + 1;
        }
        return true;
    }
    public function pasteFile($params)
    {
        $addfile = [];
        if ($params->content != 'copy' && $params->content != 'shear') {
            $data = Codeinfo::NOMODIFY;
        } elseif (!$params->id) {
            $data = Codeinfo::NOMODIFY;
        } else {
            $Thedb = DB::name('filelist')->where('user', $this->uid)->where('hash', $params->fromhash)->field('deserver')->find();

            if ($Thedb['deserver'] != $params->form) {
                $data = Codeinfo::NOMODIFY;
                return $data;
                die;
            }
            $mode = new Modifyfile(
                [
                    'user' => $this->uid,
                    'ids' => $params->id,
                    'mdir' => $params->fromhash,
                    'mode' => $params->content
                ]
            );
        }
        Hithandle::cacheChange('user', 'update');
        $data = Codeinfo::SUCCESS;
        $data['count'] = $mode->pasteFile();
        return $data;
    }
    public function refileName($params)
    {
        $faild = ['<', '>', '?', ' ', '%', '&', '/'];
        foreach ($faild as $k => $v) {
            if (strpos($params->newname, $v) !== false) {
                return Codeinfo::FAILD;
            }
        }
        if ($params->filetype === 'dir') {
            if (
                db::name('filelist')
                ->where('id', 'NEQ', $params->id)
                ->where('type', 'dir')
                ->where('path', $params->path)
                ->where('user', $this->uid)
                ->where('filename', $params->newname)
                ->find()
            ) {
                $data = Codeinfo::REPEATDIR;
            } else {
                //路径修正
                $patharr = explode('/', $params->path);
                $patharr = array_reverse($patharr);
                $patharr[0] = $params->newname;
                $patharr = array_reverse($patharr);
                $uppath = '';
                foreach ($patharr as $key => $value) {
                    $uppath .= $value . '/';
                }
                $uppath = substr($uppath, 0, strlen($uppath) - 1);
                //路径修正
                $dirfilelist = db::name('filelist')
                    ->where('fromPath', 'LIKE', '%' . $params->path . '%')
                    ->where('id', 'NEQ', $params->id)
                    ->where('user', $this->uid)
                    ->select();
                $redb = [];
                if ($dirfilelist) {
                    foreach ($dirfilelist as $key => $value) {
                        $redb = array(
                            'path' => str_replace($params->path . '/', $uppath . '/', $value['path']),
                            'fromPath' => (strpos($value['fromPath'], $params->path . '/') != false) ? str_replace($params->path . '/', $uppath . '/', $value['fromPath']) : str_replace($params->path, $uppath, $value['fromPath']),
                        );
                        db::name('filelist')->where('id', $value['id'])->update($redb);
                    }
                }
                $master_dir = array(
                    'path' => $uppath,
                    'filename' => $params->newname,
                    'uptime' => date('Y-m-d H:i:s', time())
                );
                if (
                    db::name('filelist')
                    ->where('id', $params->id)
                    ->where('user', $this->uid)
                    ->where('hash', $params->hash)
                    ->update($master_dir)
                ) {
                    $data = Codeinfo::SUCCESS;
                } else {
                    $data = Codeinfo::DBFAILD;
                }
            }
        } else {
            $file_new = array(
                'path' => str_replace($params->lowname, $params->newname, $params->path),
                'filename' => $params->newname,
                'uptime' => date('Y-m-d H:i:s', time())
            );
            if (
                db::name('filelist')
                ->where('id', $params->id)
                ->where('user', $this->uid)
                ->where('hash', $params->hash)
                ->update($file_new)
            ) {
                $data = Codeinfo::SUCCESS;
            } else {
                $data = ['code' => 202, 'info' => '当前文件禁止操作', 'status' => false];
            }
        }
        return $data;
    }
    public function cateData($params)
    {
        if ($params->type === 'public') {
            $map['user'] = 1;
            $map['hash'] = ['neq', $params->hash];
            $map['path'] = ['neq', '/'];
            if (db::name('filelist')->where('hash', $params->hash)->field('path')->value('path') != '/') {
                $map['fromHash'] = $params->hash;
            }
            $fileOrder = db::name('filelist')
                ->field('hash')
                ->order('dborder desc,id desc')
                ->where($map)
                ->page($params->page, $params->pageSize)
                ->select();
            $ids = [];
            foreach ($fileOrder as $key => $value) {
                $ids[] = $value['hash'];
            }
            unset($key);
            unset($value);
            $data['list'] = db::view('filelist', 'filename,id,type,size,uptime,hash,path,fid,deserver,dborder')
                ->view('server', 'form', 'server.ssid=filelist.deserver', 'LEFT')
                ->view('share', 'shareid', ['share.fid=filelist.fid', 'share.user=filelist.user'], 'LEFT')
                ->view('FileSale', 'price', ['FileSale.fid=filelist.fid', 'FileSale.user=filelist.user'], 'LEFT')
                ->where('filelist.hash', 'in', $ids)
                ->orderRaw('field(filelist.hash,' . "'" . implode("','", $ids) . "'" . ')')
                ->limit($params->pageSize)
                ->select();
            foreach ($data['list'] as $key => $value) {
                $data['list'][$key]['path'] = '/公共资源' . $value['path'];
                $data['list'][$key]['deserver'] = 'public';
            }
            $data['total'] = db::name('filelist')
                ->where($map)
                ->count();
        } else {
            $map['user'] = $this->uid;
            $map['fromhash'] = $params->hash;
            $map['deserver'] = $params->type;
            $map['path'] = ['NEQ', '/'];
            $fileOrder = db::name('filelist')
                ->field('hash')
                ->order('dborder desc,id desc')
                ->where($map)
                ->page($params->page, $params->pageSize)
                ->select();
            $ids = [];
            foreach ($fileOrder as $key => $value) {
                $ids[] = $value['hash'];
            }
            unset($key);
            unset($value);
            $data['list'] = db::view('filelist', 'filename,id,type,size,uptime,hash,path,fid,deserver,dborder')
                ->view('server', 'form', 'server.ssid=filelist.deserver', 'LEFT')
                ->view('share', 'shareid', ['share.fid=filelist.fid', 'share.user=filelist.user'], 'LEFT')
                ->view('FileSale', 'price', ['FileSale.fid=filelist.fid', 'FileSale.user=filelist.user'], 'LEFT')
                ->where('filelist.hash', 'in', $ids)
                ->orderRaw('field(filelist.hash,' . "'" . implode("','", $ids) . "'" . ')')
                ->limit($params->pageSize)
                ->select();
            foreach ($data['list'] as $key => $value) {
                if (!isset($value['shareid']) && $value['type'] != 'dir') {
                    $data['list'][$key]['shareid'] = $this->createShare(['fid' => $value['fid'], 'user' => $this->uid])['shareid'];
                }
            }
            $data['total'] = db::name('filelist')
                ->field('hash')
                ->order('dborder desc,id desc')
                ->where($map)
                ->count();
        }
        $data['pagesize'] = $params->pageSize;
        $data['page'] = $params->page;
        return $data;
    }
    public function searchFile($params)
    {
        $params->name = htmlentities($params->name);
        $params->name = htmlspecialchars($params->name);
        $params->name = str_replace(['%', '_', '/'], ['\%', '\_', '\/'], $params->name);
        $map['user'] = $this->uid;
        $map['filename'] = ['like', "%{$params->name}%"];
        $map['path'] = ['neq', "/"];
        $searchDb = db::name('filelist')
            ->where($map)
            ->page($params->page, $this->pagesize)
            ->select();
        $data = Codeinfo::SUCCESS;
        $data['pagesize'] = $this->pagesize;
        $data['list'] = $searchDb;
        $data['total'] = db::name('filelist')
            ->where($map)
            ->count();
        return $data;
    }
    public function upalbum($params, $enid = '')
    {
        if (!$enid) {
            $data = Codeinfo::FAILD;
            return $data;
            die;
        }
        if (!db::name('album')->find($enid)) {
            $data = Codeinfo::FAILD;
            return $data;
            die;
        }
        $info = $params->validate(
            [
                'size' => 512000,
                'ext' => 'jpg,png,gif,jpeg'
            ]
        )->rule('sha1')->move(ROOT_PATH . 'public' . DS . 'uploads' . DS . 'album', $enid ? $enid : time() . '.jpg');
        if ($info) {
            $data['status'] = true;
            $data['path'] = '/uploads/album/' . str_replace('\\', '/', $info->getSaveName()) . '?uptime=' . time();
            $data['msg'] = 'ok';
        } else {
            $data['status'] = false;
            $data['msg'] = 'file upload error';
            $data['all_msg'] = $params->getError();
        }
        return $data;
    }
    public function createdAlbum($params)
    {
        if (isset($this->config['system']['publicoff']) && $this->config['system']['publicoff'] === 1) {
            $map['user'] = ['in', [$this->uid, 1]];
        } else {
            $map['user'] = $this->uid;
        }
        $items = db::view('filelist', 'fid,id,user')
            ->view('filecount', 'filetype', 'filecount.fid=filelist.fid')
            ->where('filelist.type', 'video')
            ->where('filelist.id', 'in', $params->ids)
            ->where($map)
            ->select();
        $ids = [];
        foreach ($items as $k => $v) {
            $ids[] = $v['id'];
        }
        if (count($ids) === 0) {
            $MSG = [
                'info' => '未匹配到可供创建专辑的视频资源',
                'status' => false,
                'code' => 204
            ];
            return $MSG;
            die;
        }
        $insert = [
            'title' => $params->title,
            'type' => $params->type,
            'thumb' => '/uploads/album.png',
            'info' => $params->info,
            'user' => $this->uid,
            'content' => json_encode($params->ids),
            'time' => date('Y-m-d H:i:s', time())
        ];
        $rule = [
            'title' => 'require|max:50',
            'type'  => 'require',
            'thumb' => 'require',
            'info'  => 'require|max:100',
            'user'  => 'require|number',
            'content' => 'require'
        ];

        $Validate = new Validate($rule);
        $result = $Validate->check($insert);
        if ($result) {
            do {
                $insert['enid'] = Tools::only(time());
            } while (!empty(db::name('album')->find($insert['enid'])));
            if (db::name('album')->insert($insert)) {
                $data = Codeinfo::SUCCESS;
                $data['enid'] = $insert['enid'];
            } else {
                $data = Codeinfo::DBFAILD;
            }
        }
        return $data;
    }
    public function showAlbum()
    {
        $albums = db::name('album')
            ->where('user', $this->uid)
            ->field('enid,thumb,title,type,time,info,content')
            ->select();
        for ($i = 0; $i < count($albums); $i++) {
            $tmp = json_decode($albums[$i]['content']);
            $arr = [];
            if (count($tmp) != 0) {
                foreach ($tmp as $key => $value) {
                    $arr[] = db::name('filelist')->field('filename,id')->find($value);
                }
                $albums[$i]['content'] = $arr;
            }
        }
        return $albums;
    }
    public function saveAlbum($params)
    {
        $map['user'] = $this->uid;
        $map['enid'] = $params->enid;
        $update = [
            'title' => $params->article->title,
            'info' => $params->article->info,
            'thumb' => '/uploads/album/' . $params->enid . '.jpg',
            'type' => $params->article->type,
            'content' => json_encode($params->article->ids)
        ];
        if (db::name('album')->where($map)->update($update)) {
            $data = Codeinfo::SUCCESS;
        } else {
            $data = Codeinfo::FAILD;
        }
        return $data;
    }
    public function deleteAlbum($params)
    {
        if (db::name('album')->where('user', $this->uid)->where('enid', $params->enid)->delete()) {
            $thumb = ROOT_PATH . 'public' . DS . 'uploads' . DS . 'album' . DS . $params->enid . '.jpg';
            file_exists($thumb) ? unlink($thumb) : '';
            $data = Codeinfo::SUCCESS;
        } else {
            $data = Codeinfo::FAILD;
        }
        return $data;
    }
    static function addAlbumIds($params)
    {
        $albumdata = db::name('album')->find($params->select);
        $ids = json_decode($albumdata['content'], true);
        if (count($ids) != 0) {
            $upids = array_merge($ids, $params->ids);
            $upids = array_unique($upids);
            $ids_arr = [];
            foreach ($upids as $key => $value) {
                $ids_arr[] = $value;
            }
        } else {
            $ids_arr = $params->ids;
        }

        if (db::name('album')->where('enid', $params->select)->update(['content' => json_encode($ids_arr)])) {
            $data = Codeinfo::SUCCESS;
        } else {
            $data = ['code' => 202, 'info' => '似乎并没有发生改变', 'status' => false];
        }

        return $data;
    }
}
