<?php

namespace app\common\controller;

use think\Db;
use think\Session;
use common\Tools;
use common\Codeinfo;
use common\Hithandle;
use think\Validate;

class Member extends Common
{
    public function _initialize()
    {
        parent::_initialize();
    }
    public function userup()
    {
        try {
            $data = Codeinfo::SUCCESS;
            $utable = db::name('user');
            $udata = $utable->find($this->uid);
            $jointime = new \DateTime($udata['createtime']);
            $today = new \DateTime();
            $data['stand'] = [
                'files' => db::name('filelist')->where('user', $this->uid)->where('type', 'neq', 'dir')->count(),
                'joinday' => date_diff($jointime, $today)->format("%a"),
                'diskspace' => $udata['diskspace'] === 0 ? '无限' : Tools::formatBytes($udata['diskspace']),
                'uname' => $udata['nickname'],
                'avatar' => $udata['avatar'],
                'alipay' => $udata['alipay'],
                'usign' => $udata['sign'],
                'score' => $udata['score'],
                'isvip' => $udata['gid'] === 2 ? true : false,
                'endtime' => $udata['gid'] === 2 ? date('Y-m-d H:i:s', db::name('useratta')->field('endtime')->where('uid', $this->uid)->where('content', 'buyvip')->find()['endtime']) : ''
            ];
            return $data;
        } catch (\Throwable $th) {
            $data = Codeinfo::YMFAILD;
            return $data;
        }
    }
    public function getPushurl()
    {
        $map = [
            'uid' => $this->uid,
            'type' => 'push'
        ];
        $urls = db::name('usersetting')->where($map)->field('content')->find();
        return json_decode($urls['content']);
    }
    public function getUsercash()
    {
        $udb = db::name('user')->field('score,alipay')->find($this->uid);
        $config = db::name('syssetting')->find('markketing');
        $config = json_decode($config['content'], true);
        $okcash = $udb['score'] / $config['change'];
        $resdata = [
            'rttcash' => round($okcash, 2),
            'bite' => $config['change'],
            'sysrule' => $config['system'],
            'minimum' => $config['minimumcash'],
            'setpay' => $udb['alipay'] ? true : false,
        ];
        $cashlist = db::name('cash')->where('uid', $this->uid)->field('uptime,pay,money,msg,status')->limit(10)->order('uptime DESC')->select();
        $data['user'] = $resdata;
        $data['cash'] = $cashlist;
        return $data;
    }
    public function getcash($params)
    {
        $udb = db::name('user')->field('score,alipay')->find($this->uid);
        $config = db::name('syssetting')->find('markketing');
        $config = json_decode($config['content'], true);
        if ($params->money < $config['minimumcash']) {
            $data = Codeinfo::CASHLOW;
            return $data;
            die;
        }
        if ($udb['score'] < ($params->money * $config['change'])) {
            $data = Codeinfo::CASHLOW;
            return $data;
            die;
        }
        if (!$udb['alipay']) {
            $data = Codeinfo::NOALIPAY;
            return $data;
            die;
        }
        if (db::name('user')->where('id', $this->uid)->setDec('score', round($params->money * $config['change'], 2))) {
            $add = [
                'uid' => $this->uid,
                'money' => $params->money - ($params->money * ($config['system'] / 100)),
                'score' => $params->money * $config['change'],
                'pay' => $udb['alipay'],
                'status' => 0,
                'msg' => '提现中',
                'uptime' => date('Y-m-d H:i:s', time())
            ];
            if (db::name('cash')->insert($add)) {
                $data = Codeinfo::SUCCESS;
            } else {
                $data = Codeinfo::DBFAILD;
            }
        }
        return $data;
    }
    public function SavePushUrl($params)
    {
        if ($sid = db::name('usersetting')->where('type', 'push')->where('uid', $this->uid)->field('id')->find()) {

            $update = [
                'content' => json_encode($params->urls)
            ];
            db::name('usersetting')->where($sid)->update($update) ? $data = Codeinfo::SUCCESS : $data = Codeinfo::DBFAILD;
        } else {
            $add = [
                'type' => 'push',
                'uid' => $this->uid,
                'content' => json_encode($params->urls)
            ];
            if (db::name('usersetting')->insert($add)) {
                $data = Codeinfo::SUCCESS;
            } else {
                $data = Codeinfo::DBFAILD;
            }
        }
        return $data;
    }
    public function userRecharge($params)
    {
        if ($params->cdkey && strlen($params->cdkey) === 32) {
            $cddata = db::name('card')->where('cdkey', $params->cdkey)->where('status', 0)->field('money')->find();
            if (!$cddata) {
                $data = Codeinfo::NOCDKEY;
                return $data;
                die;
            } else {
                $user = db::name('user')->find($this->uid);
                if (!$user) {
                    $data = Codeinfo::NOUSER;
                } else {
                    if (db::name('user')->where('id', $this->uid)->setInc('score', $cddata['money'])) {
                        $log = [
                            'uid' => $this->uid,
                            'card' => $params->cdkey,
                            'content' => $cddata['money'],
                            'time' => date('Y-m-d H:i:s', time())
                        ];
                        if (db::name('record')->insert($log)) {
                            db::name('card')->where('cdkey', $params->cdkey)->where('status', 0)->delete();
                            $data = Codeinfo::CDKEYSUCCESS;
                        }
                    } else {
                        $data = Codeinfo::CDKEYERROR;
                    }
                }
            }
        } else {
            $data = Codeinfo::CDKEYFAILD;
        }
        return $data;
    }
    public function buyCard($params)
    {
        $itemdb = db::name('goods')->where('enid', $params->eid)->find();
        if (empty($itemdb)) {
            $data = Codinfo::NOITEMS;
            return $data;
            die;
        }
        $udb = db::name('user')->find($this->uid);
        if ($udb['score'] >= $itemdb['money']) {
            switch ($itemdb['type']) {
                case 'space':
                    if (db::name('user')->where('id', $this->uid)->setInc('diskspace', ($itemdb['content'] * 1024 * 1024 * 1024))) {
                        if (db::name('user')->where('id', $this->uid)->setDec('score', $itemdb['money'])) {

                            Hithandle::cacheChange('user', 'update');
                        }
                    }
                    $data = Codeinfo::BUYSUCCESS;
                    break;
                case 'vip':
                    $group = [
                        'uid' => $this->uid,
                        'gid' => 2,
                        'content' => 'buyvip',
                        'stamp' => time(),
                        'endtime' => strtotime('+' . $itemdb['content'] . ' day'),
                        'time' => date('Y-m-d H:i:s', time())
                    ];
                    $gdb = db::name('useratta')->where('uid', $this->uid)->where('gid', 2)->find();
                    if (!$gdb) {
                        db::name('useratta')->insert($group) ? $data = Codeinfo::SUCCESS : $data = Codeinfo::FAILD;
                    } else {
                        if (($gdb['endtime'] - time()) >= 0) {
                            $upvip = [
                                'stamp' => time(),
                                'endtime' => strtotime('+' . $itemdb['content'] . ' day', $gdb['endtime']),
                                'time' => date('Y-m-d H:i:s', time())
                            ];
                            db::name('useratta')->where('uid', $this->uid)->update($upvip) ? $data = Codeinfo::SUCCESS : $data = Codeinfo::FAILD;
                        }
                    }
                    if ($udb['gid'] != 2) {
                        db::name('user')->where('id', $this->uid)->setfield('gid', 2) ? $data = Codeinfo::SUCCESS : $data = Codeinfo::FAILD;
                    } else {
                        $data = Codeinfo::SUCCESS;
                    }

                    break;
            }
            return $data;
        } else {
            $data = Codeinfo::CASHLOW;
            return $data;
            die;
        }
    }
    public function getItem()
    {
        $items = db::name('goods')->field('enid,type,content,money')->select();
        return $items;
    }
    public function recharge($params)
    {
        $table = db::name('record');
        $map = [
            'uid' => $this->uid,
        ];
        $data['log'] = $table->where($map)->field('card,content,time')->order('time DESC')->select();
        $data['cardlink'] = db::name('syssetting')->field('content')->find('cardlink');
        return $data;
    }
    public function saveuser($params)
    {
        $update = [
            'nickname' => $params->uname,
            'avatar' => is_file(ROOT_PATH . 'public' . DS . 'uploads' . DS . 'avatar' . DS . $this->uid . '.jpg') ? '/uploads/avatar/' . $this->uid . '.jpg' : '',
            'sign' => $params->usign,
            'alipay' => $params->alipay
        ];
        $rule = [
            'nickname' => ['max' => 18],
            'sign'  => ['max' => 100],
        ];
        $message = [
            'nickname' => '昵称超过字数限制',
            'sign' => '个人说明超过字数限制'
        ];
        $Validate = new Validate($rule, $message);
        $result = $Validate->check($update);
        if ($result) {
            if (db::name('user')->where('id', $this->uid)->update($update)) {
                $data = Codeinfo::SUCCESS;
            } else {
                $data = Codeinfo::FAILD;
            }
        } else {
            $data['status'] = false;
            $data['info'] = $Validate->getError();
        }

        return $data;
    }
    public function resetPw($params)
    {
        if (strlen($params->lowpass) >= 8 && strlen($params->newPw) >= 8 && strlen($params->newPw) <= 20 && ($params->newPw === $params->rePw)) {
            parse_str(base64_decode($params->token));
            $udb = db::name('user')->where('id', $this->uid)->find();
            if (md5($params->lowpass . $udb['salt']) === $udb['password']) {
                if (db::name('user')->where('id', $this->uid)->setField('password', md5($params->newPw . $udb['salt']))) {
                    $data = Codeinfo::SUCCESS;
                } else {
                    $data = Codeinfo::PWMODIFYFAILD;
                }
            } else {
                $data['status'] = false;
                $data['code'] = "202FF";
                $data['info'] = "原密码错误";
            }
        } else {
            $data = Codeinfo::PWNOFROM;
        }
        return $data;
    }
    public function upavatar($params)
    {
        $info = $params->validate(
            [
                'size' => 512000,
                'ext' => 'jpg,png,gif,jpeg'
            ]
        )->rule('sha1')->move(ROOT_PATH . 'public' . DS . 'uploads' . DS . 'avatar', $this->uid . '.jpg');
        if ($info) {
            $data['status'] = true;
            $data['path'] = '/uploads/avatar/' . str_replace('\\', '/', $info->getSaveName()) . '?uptime=' . time();
            $data['msg'] = 'ok';
        } else {
            $data['status'] = false;
            $data['msg'] = 'file upload error';
            $data['all_msg'] = $params->getError();
        }
        return $data;
    }
    public function getUserlink()
    {
        $udb = db::name('user')->field('enid')->find($this->uid);
        if (!$udb['enid']) {
            do {
                $enid = Tools::only($this->uid . time());
            } while (!empty(db::name('user')->where('enid', $enid)->find()));
            db::name('user')->where('id', $this->uid)->setfield('enid', $enid);
        } else {
            $enid = $udb['enid'];
        }
        return $enid;
    }
    public function getFromuser()
    {
        $data = db::view('userext', 'fromuser,uptime')
            ->view('user', 'username,avatar', 'user.id=userext.fromuser')
            ->where('masteruser', $this->uid)
            ->order('uptime DESC')
            ->select();
        foreach ($data as $key => $value) {
            unset($data[$key]['fromuser']);
            $data[$key]['username'] = Tools::hideStar($value['username']);
            $data[$key]['uptime'] = Tools::tranTime($value['uptime']);
        }
        return $data;
    }
    public function saleFile($params)
    {
        $map = [
            'fid' => $params->fid,
            'user' => $this->uid
        ];
        $share = db::name('filelist')->where($map)->field('id')->find();
        if ($share) {
            if (is_numeric($params->price)) {
                if ($saledb = db::name('FileSale')->where($map)->find()) {
                    $saledb['price'] = $params->price;
                    unset($saledb['time']);
                    db::name('FileSale')->update($saledb) ? $data = Codeinfo::SUCCESS : $data = Codeinfo::DBNOUP;
                } else {
                    $saleInser = [
                        'fid' => $params->fid,
                        'user' => $this->uid,
                        'price' => $params->price
                    ];
                    if (db::name('FileSale')->insert($saleInser)) {
                        $data = Codeinfo::SUCCESS;
                    } else {
                        $data = Codeinfo::FAILD;
                    }
                }
            } else {
                $data = Codeinfo::SALEERROR;
            }
        } else {
            $data = [
                'code' => 204,
                'info' => '当前文件禁止操作',
                'status' => false
            ];
        }
        return $data;
    }
    public function buyfile($params)
    {
        $rule = [
            'file' => ['require', 'min' => 32, 'max' => 32],
            'from' => ['require', 'min' => 8, 'max' => 8],
            'type' => ['require', 'min' => 5, 'max' => 5],
            '__token__'  => ['token'],
        ];
        $message = [
            'file.require' => '文件不存在',
            'type.require' => '非法请求',
            '__token__.require' => '非法请求',
            '__token__.token'   => '请不要重复提交'
        ];
        $params = json_encode($params);
        $params = json_decode($params, true);

        $Validate = new Validate($rule, $message);
        $result = $Validate->check($params);
        if ($result) {
            switch ($params['type']) {
                case 'share':
                    $share = db::name('share')->where('shareid', $params['from'])->find();
                    if (!$share) {
                        $data = Codeinfo::FAILD;
                        return $data;
                        die;
                    }
                    $file = db::name('filelist')->where('fid', $params['file'])->where('user', $share['user'])->field('fid,filename,id')->find();
                    if (!$file || $share['fid'] != $file['fid']) {
                        $data = Codeinfo::FAILD;
                        return $data;
                        die;
                    }
                    $filePrice = db::name('FileSale')->where('fid', $share['fid'])->where('user', $share['user'])->value('price');
                    $userPrice = db::name('usersetting')->where('uid', $share['user'])->where('type', 'score')->value('content');
                    $m_user = $share['user'];
                    if (!$filePrice && !$userPrice) {
                        $data = Codeinfo::FAILD;
                        return $data;
                        die;
                    } else {
                        $m_user = $share['user'];
                        $price = $filePrice ? $filePrice : (int) $userPrice;
                    }
                    break;
                case 'album':
                    $album = db::name('album')->find($params['from']);
                    if (!$album) {
                        $data = Codeinfo::FAILD;
                        return $data;
                        die;
                    };
                    $ids = json_decode($album['content'], true);
                    $file = db::name('filelist')->where('fid', $params['file'])->where('user', $album['user'])->field('filename,fid,id')->find();
                    if (!$file) {
                        $data = Codeinfo::FAILD;
                        return $data;
                        die;
                    }
                    if (!in_array($file['id'], $ids)) {
                        $data = Codeinfo::FAILD;
                        return $data;
                        die;
                    }
                    $filePrice = db::name('FileSale')->where('fid', $params['file'])->where('user', $album['user'])->value('price');
                    $userPrice = db::name('usersetting')->where('uid', $album['user'])->where('type', 'score')->value('content');
                    if (!$filePrice && !$userPrice) {
                        $data = Codeinfo::FAILD;
                        return $data;
                        die;
                    } else {
                        $m_user = $album['user'];
                        $price = $filePrice ? $filePrice : (int) $userPrice;
                    }
                    $params['from'] = db::name('share')->where('fid', $params['file'])->where('user', $album['user'])->value('shareid');
                    break;
            }


            $user = db::name('user')->find($this->uid);
            if ($price === 0) {
                $data = [
                    'status' => false,
                    'info' => '当前资源无需购买'
                ];
                return $data;
                die;
            }
            if ($m_user == $user['id']) {
                $data = [
                    'status' => false,
                    'info' => '你不能购买自己的资源'
                ];
                return $data;
                die;
            }
            $buymap = [
                'uid' => $this->uid,
                'fid' => $file['fid'],
                'from' => $params['from']
            ];
            if (db::name('buylog')->where($buymap)->find()) {
                $data['code'] = 203;
                $data['info'] = "您已经购买过此资源";
                $data['status'] = false;
            } else {
                if ($user['score'] >= $price) {
                    db::name('user')->where('id', $this->uid)->setDec('score', $price);
                    db::name('user')->where('id', $m_user)->setInc('score', $price);
                    $map = [
                        'uid' => $this->uid,
                        'fid' => $file['fid'],
                        'from' => $params['from'],
                        'fromuser' => $m_user,
                        'title' => $file['filename'],
                        'money' => $price,
                        'time' => date('Y-m-d H:i:s', time())
                    ];
                    if (db::name('buylog')->insert($map)) {
                        $data = Codeinfo::SUCCESS;
                    } else {
                        $data = Codeinfo::DBFAILD;
                    }
                } else {
                    $data = Codeinfo::CASHLOW;
                }
            }
        } else {
            $data['status'] = false;
            $data['info'] = $Validate->getError();
        }
        return $data;
    }
    public function getoffer()
    {
        $data = db::view('buylog', 'title,time,money,from')
            ->view('user', 'nickname,username', 'user.id=buylog.uid')
            ->where('fromuser', $this->uid)
            ->page(1, 50)
            ->order('time desc')
            ->select();
        foreach ($data as $key => $value) {
            $data[$key]['username'] = Tools::hideStar($data[$key]['username']);
            $data[$key]['time'] = Tools::tranTime($data[$key]['time']);
        }
        return $data;
    }
    public function getinvite()
    {
        $map['muser'] = $this->uid;
        $data = db::view('userextlog', 'time,content,score')
            ->view('user', 'nickname,username', 'user.id=userextlog.fuser')
            ->where($map)
            ->limit(50)
            ->order('time desc')
            ->select();
        foreach ($data as $key => $value) {
            $data[$key]['username'] = Tools::hideStar($data[$key]['username']);
            $data[$key]['time'] = Tools::tranTime($data[$key]['time']);
        }
        return $data;
    }
    public function getScore()
    {
        $score = db::name('usersetting')->where('uid', $this->uid)->where('type', 'price')->value('content');
        $data = Codeinfo::SUCCESS;
        $data['score'] = !$score ? 0 : $score;
        return $data;
    }
    public function saveScore($params)
    {
        $update = [
            'score' => $params->score
        ];
        $rule = [
            'score' => 'number|max:8'
        ];
        $message = [
            'score' => '积分错误'
        ];
        $Validate = new Validate($rule, $message);
        $result = $Validate->check($update);
        if ($result) {
            if ($setid = db::name('usersetting')->where('uid', $this->uid)->where('type', 'score')->find()) {
                db::name('usersetting')->where('id', $setid['id'])->setField('content', $params->score) ? $data = Codeinfo::SUCCESS : $data = Codeinfo::DBFAILD;
            } else {
                $inner = [
                    'uid' => $this->uid,
                    'type' => 'score',
                    'content' => (int) $params->score
                ];
                db::name('usersetting')->insert($inner) ? $data = Codeinfo::SUCCESS : $data = Codeinfo::DBFAILD;
            }
        } else {
            $data['status'] = false;
            $data['info'] = $Validate->getError();
        }
        return $data;
    }
}
