<?php

namespace app\common\model;

use think\Db;
use app\common\controller\Common;
use think\Validate;
use common\Codeinfo;
use common\Tools;

class Follow extends Common
{
    public $msg = [];
    private $params;
    private $status;
    public function __construct($params)
    {
        parent::__construct();
        $validate = new Validate([
            'uid'  => 'require|max:8|min:8',
        ]);
        $data = [
            'uid'  => $params->uid,
        ];
        if (!$validate->check($data)) {
            $this->status = false;
            $this->msg = Codeinfo::FAILD;
        } else {
            $this->status = true;
            $this->params = $params;
        }
    }
    public function followList()
    {
        $udb = db::name('user')->where('enid', $this->params->uid)->find();
        if ($udb['enid'] != $this->params->uid) {
            return $this->msg = Codeinfo::FAILD;
        }
        $nofollow = false;
        $noconn = false;
        $data = [];
        $data = db::view('UserFollow','time')
            ->view('user', 'username,nickname,avatar,enid', 'user.id=UserFollow.god')
            ->where('UserFollow.master', $udb['id'])
            ->select();
        if ($data) {
            // foreach ($data as $key => $value) {
            //     $ids[] = $value['god'];
            // }
            // unset($key);
            // unset($value);
            if (count($data) != 0) {
                // $new = db::view('filelist', 'uptime')
                //     ->view('user', 'username,nickname,avatar,enid', 'user.id=filelist.user')
                //     ->where('filelist.type', 'video')
                //     ->where('filelist.user', 'in', $ids)
                //     ->where('filelist.uptime', '> time', strtotime('-1 months'))
                //     //->limit(count($ids))
                //     ->group('user')
                //     //->orderRaw('field(filelist.user,' . implode(',', $ids) . ')')
                //     //->fetchSql(true)
                //     ->select();
                // dump($new);
                // die;
                foreach ($data as $key => $value) {
                    $unew = db::name('filelist')
                        ->where('uptime', '> time', strtotime('-1 months'))
                        ->where('type', 'video')
                        ->where('user', $this->uid)
                        ->field('id')
                        ->find();
                    if (!$unew) {
                        unset($data[$key]);
                    }
                }
                unset($key);
                unset($value);
                if (!$data) {
                    $noconn = true;
                } else {
                    foreach ($data as $key => $value) {
                        !$value['nickname'] ? $data[$key]['nickname'] = Tools::hideStar($value['username']) : '';
                        unset($data[$key]['username']);
                    }
                    unset($key);
                    unset($value);
                }
            }
        } else {
            $nofollow = true;
        }
        $nofollow ? $msg = ['code' => 203, 'info' => '你还没有关注的偶像', 'status' => false] : '';
        $noconn ? $msg = ['code' => 204, 'info' => '你关注的偶像失联了', 'status' => false] : '';
        $msg['list'] = $data;
        return $this->msg = $msg;
    }
    public function follow()
    {
        if (!$this->status) {
            return $this->msg;
            die;
        }
        $udb = db::name('user')->where('enid', $this->params->uid)->cache(true)->find();
        if (!$udb) {
            return $this->msg = Codeinfo::NOUSER;
            die;
        }
        if ($this->uid === $udb['id']) {
            return $this->msg = ['code' => 202, 'info' => '你不能关注自己', 'status' => false];
            die;
        }
        $follow = Db::name('UserFollow');
        if ($follow->where('master', $this->uid)->where('god', $udb['id'])->find()) {
            $follow->where('master', $this->uid)->where('god', $udb['id'])->delete();
            db::name('UserFansCount')->where('user', $udb['id'])->setDec('fans', 1);
            db::name('UserFansCount')->where('user', $udb['id'])->setField('time', time());
            return $this->msg = ['code' => 202, 'info' => '取消关注成功', 'status' => true];
            die;
        } else {
            $insert = [
                'master' => $this->uid,
                'god' => $udb['id'],
                'time' => time()
            ];
            try {
                if (db::name('UserFansCount')->where('user', $udb['id'])->find()) {
                    db::name('UserFansCount')->where('user', $udb['id'])->setInc('fans', 1);
                    db::name('UserFansCount')->where('user', $udb['id'])->setField('time', time());
                } else {
                    $count = [
                        'user' => $udb['id'],
                        'fans' => 1,
                        'time' => time()
                    ];
                    db::name('UserFansCount')->insert($count);
                }

                $follow->insert($insert);
                $this->msg = Codeinfo::SUCCESS;
            } catch (\Throwable $th) {
                $this->msg = Codeinfo::DBFAILD;
            }
        }
    }
}
