<?php

namespace app\common\model;

use think\Db;
use common\Tools;

class Square
{
    public $pageSize = 25;
    public $page = 1;
    public function __construct()
    { }
    public function get()
    {
        $mt_count = db::name('filelist')->count();
        $mt_count_num = mt_rand(0, $mt_count);
        $sq_list = db::view('filelist', 'filename,uptime,fid')
            ->view('filecount', 'path,duration,ssid', 'filecount.fid=filelist.fid')
            ->view('server', 'playhost', 'server.ssid=filecount.ssid')
            ->view('share', 'shareid', 'share.fid = filecount.fid')
            ->view('user', 'username,nickname,enid', 'user.id=filelist.user')
            ->where('filelist.type', 'video')
            ->where('filelist.id', ['>', $mt_count_num], ['<', $mt_count_num + $this->pageSize], 'and')
            ->where('share.user=filelist.user')
            ->limit($this->pageSize)
            ->select();
        foreach ($sq_list as $key => $value) {
            $sq_list[$key]['username'] = $value['nickname'] ? $value['nickname'] : Tools::hideStar($value['username']);
            $sq_list[$key]['uptime'] = Tools::tranTime($value['uptime']);
            !$value['duration'] ? $sq_list[$key]['duration'] = '00:00:00' : '';
            unset($sq_list[$key]['ssid']);
            unset($sq_list[$key]['user']);
        }
        return $sq_list;
    }
}
