<?php
/*
 * @Descripttion: 
 * @version: 2.3.0
 * @Author: Token
 * @Date: 2019-09-19 00:11:38
 * @LastEditors: Token
 * @LastEditTime: 2019-10-21 21:19:18
 */

namespace app\index\controller;

use think\View;
use think\Db;
use think\Controller;
use common\Tools;
use common\Ppsign;
use common\Sign;
use common\Codeinfo;
use think\Session;
use think\Config;
use think\Cache;
use think\Request;
use app\index\model\Ajaxlogin;
use app\common\model\User;
use app\common\model\Square;
use app\index\model\commonView;
use app\common\model\Share;

class Index extends Controller
{
    private $start = 1;
    /**
     * 限制试看开始秒数
     */
    private $end = 30;
    /**
     * 限制试看多少秒结束
     */
    private $webconfig = [];
    /**
     * 网站配置
     */
    private $cardLink = '';
    /**
     * 点卡购买链接
     */
    public function _initialize()
    {
        $this->webconfig = json_decode(file_get_contents(APP_PATH . 'config.json'), true)['system'];
        $this->cardLink = db::name('syssetting')->cache(true)->find('cardlink');
        $mark = db::name('syssetting')->find('markketing');
        $mark['content']=json_decode($mark['content'],true);
        if(isset($mark['content']['test'])){
            $this->end = $mark['content']['test'];
        }
        session_start();
    }
    public function index()
    {
        header('Location: index.html');
    }
    public function square()
    {
        $header = new commonView();
        $header->type = 'header';
        $square = new Square();
        $square->page = 1;
        $sq_list = $square->get();
        $view = new View();
        $view->webname = $this->webconfig['webname'];
        $view->cardlink = $this->cardLink;
        $view->header = $header->build();
        $header->type = 'footer';
        $view->footer = $header->build();
        $view->sqdata = $sq_list;
        return $view->fetch('square');
    }
    public function UserCenter($uid, $r = 'h', $p = 1)
    {
        $uid = Tools::remove_xss($uid);
        $router = Tools::remove_xss($r);
        $page = Tools::remove_xss($p);
        if (strlen($uid) != 8) {
            return json(Codeinfo::FAILD);
            die;
        }
        if (!is_numeric($page)) {
            return json(Codeinfo::FAILD);
            die;
        }
        $udb = Db::view('user', 'avatar,username,nickname,sign,id')
            ->view('usercache', 'files', 'usercache.uid=user.id', 'LEFT')
            ->where('user.enid', $uid)
            ->find();
        if (!$udb) {
            return json(Codeinfo::NOUSER);
            die;
        }
        $udb['nickname'] ? $udb['nickname'] : $udb['nickname'] = Tools::hideStar($udb['username']);
        !$udb['files'] ? $udb['files'] = 0 : '';
        !$udb['sign'] ? $udb['sign'] = '他很懒什么也没留下~' : '';
        empty($udb['avatar']) ? $udb['avatar'] = '/model/static/img/default-avatar.jpg' : '';
        unset($udb['username']);
        $data['user'] = $udb;
        $dbpre = config::get('database.prefix');
        $data['count'] = [
            'video' => db::query(
                "SELECT
                            COUNT( id ) AS filecount 
                        FROM
                            `{$dbpre}filelist` 
                        WHERE
                            `type` = 'video' 
                        AND 
                            `user`={$udb['id']}"
            )[0]['filecount'],
            'album' => db::name('album')->where('user', $udb['id'])->count('enid'),
            'fans'  => db::name('UserFollow')->where('god', $udb['id'])->count('id')
        ];
        switch ($router) {
            case 'h':
                $file_key = db::name('filelist')->where('user', $udb['id'])->where('type', 'video')->field('fid')->order('id desc')->limit(10)->select();
                $fids = [];
                foreach ($file_key as $key => $value) {
                    $fids[] = $value['fid'];
                }
                unset($key);
                unset($value);
                $data['videos'] = db::view('filelist', 'filename,size,uptime')
                    ->view('filecount', 'ssid,path,duration', 'filecount.fid=filelist.fid')
                    ->view('share', 'shareid', ['share.fid=filelist.fid', 'share.user=filelist.user'], 'LEFT')
                    ->view('server', 'playhost', 'server.ssid=filecount.ssid')
                    ->view('FileSale', 'price', ['FileSale.fid=filelist.fid', 'FileSale.user=filelist.user'], 'LEFT')
                    ->view('usersetting', ['content' => 'defaultscore'], ['usersetting.uid=filelist.user', 'usersetting.type="score"'], 'LEFT')
                    ->where('filelist.user', $udb['id'])
                    ->where('filelist.fid', 'in', $fids)
                    ->where('filelist.type', 'video')
                    ->order('filelist.id desc')
                    ->select();
                $data['videos'] = Tools::arr2size($data['videos'], 'size');
                $data['videos'] = Tools::arr2time($data['videos'], 'uptime');
                $data['albums'] = db::name('album')->where('user', $udb['id'])->limit(10)->order('time desc')->select();
                foreach ($data['albums'] as $key => $value) {
                    $data['albums'][$key]['content'] = count(json_decode($value['content'], true));
                    $data['albums'][$key]['time'] = Tools::tranTime($value['time']);
                }
                unset($key);
                unset($value);
                $data['fans'] = db::view('UserFollow', 'time')
                    ->view('user', 'avatar,nickname,username,enid', 'user.id=UserFollow.master')
                    ->where('UserFollow.god', $udb['id'])
                    ->order('UserFollow.time desc')
                    ->limit(20)
                    ->select();
                foreach ($data['fans'] as $key => $value) {
                    !$value['nickname'] ? $data['fans'][$key]['nickname'] = Tools::hideStar($value['username']) : '';
                }
                unset($key);
                unset($value);
                break;
            case 'v':
                $file_key = db::name('filelist')->where('user', $udb['id'])->where('type', 'video')->field('fid')->order('id desc')->page($page, 20)->select();
                $fids = [];
                foreach ($file_key as $key => $value) {
                    $fids[] = $value['fid'];
                }
                unset($key);
                unset($value);
                $data['videos'] = [];
                if ($file_key) {
                    $data['videos'] = db::view('filelist', 'filename,size,uptime')
                        ->view('filecount', 'ssid,path,duration', 'filecount.fid=filelist.fid')
                        ->view('share', 'shareid', ['share.fid=filelist.fid', 'share.user=filelist.user'])
                        ->view('server', 'playhost', 'server.ssid=filecount.ssid')
                        ->view('FileSale', 'price', ['FileSale.fid=filelist.fid', 'FileSale.user=filelist.user'], 'LEFT')
                        ->view('usersetting', ['content' => 'defaultscore'], ['usersetting.uid=filelist.user', 'usersetting.type="score"'], 'LEFT')
                        ->where('filelist.user', $udb['id'])
                        ->where('filelist.fid', 'in', $fids)
                        ->where('share.user', $udb['id'])
                        ->order('filelist.id desc')
                        ->limit(20)
                        ->select();
                    $data['videos'] = Tools::arr2size($data['videos'], 'size');
                    $data['videos'] = Tools::arr2time($data['videos'], 'uptime');
                }
                break;
            case 'a':
                $data['albums'] = [];
                $data['albums'] = db::name('album')->where('user', $udb['id'])->page($page, 20)->order('time desc')->select();
                if ($data['albums']) {
                    foreach ($data['albums'] as $key => $value) {
                        $data['albums'][$key]['content'] = count(json_decode($value['content'], true));
                        $data['albums'][$key]['time'] = Tools::tranTime($value['time']);
                    }
                }

                break;
            case 'f':
                $data['fans'] = [];
                $data['fans'] = db::view('UserFollow', 'time')
                    ->view('user', 'avatar,nickname,username,enid', 'user.id=UserFollow.master')
                    ->where('UserFollow.god', $udb['id'])
                    ->order('UserFollow.time desc')
                    ->page($page, 100)
                    ->select();
                foreach ($data['fans'] as $key => $value) {
                    !$value['nickname'] ? $data['fans'][$key]['nickname'] = Tools::hideStar($value['username']) : '';
                }
                unset($key);
                unset($value);
                break;
            default:
                return json(Codeinfo::FAILD);
                die;
                break;
        }
        /**
         * 判断是否登录
         * 判断是否关注
         */
        $User = new \app\common\model\User;
        $result = $User->isLogin();
        $islogin = false;
        $isfollow = false;
        if ($result['status']) {
            $islogin = true;
            $follow = Db::name('UserFollow');
            $result['id'] = Session::get('user.id', 'index');
            $isfollow = $follow->where('master', $result['id'])->where('god', $udb['id'])->find() ? true : false;
            /** 判断当前登录用户与目标用户 */
            if ($result['id'] != $udb['id']) {
                $record = Db::name('UserCenterRecord');
                if ($red = $record->where('master', $udb['id'])->where('user', $result['id'])->find()) {
                    if (date('Y-m-d') != date('Y-m-d', $red['time'])) {
                        $red['time'] = time();
                        $record->update($red);
                    }
                } else {
                    $red = [
                        'master' => $udb['id'],
                        'user' => $result['id'],
                        'time' => time()
                    ];
                    $record->insert($red);
                }
            }
        }
        /** end */
        $view = new View();
        $view->isfollow = $isfollow;
        $view->webname = $this->webconfig['webname'];
        $header = new commonView();
        $header->type = 'header';
        $view->header = $header->build();
        $header->type = 'footer';
        $view->footer = $header->build();
        $view->data = $data;
        $view->uid = $uid;
        $view->page = $page;
        $view->router = $router;
        return $view->fetch('/usercenter/index');
    }
    public function album($aid, $vid)
    {
        $vid--;
        if (empty($aid)) {
            abort(404, '不存在的专辑');
            die;
        }
        $album = db::view('album', 'title,info,content,time,user,thumb,type')
            ->view('user', 'avatar,nickname,sign,username,enid', 'user.id=album.user')
            ->cache(true, 60)
            ->find($aid);
        if (!$album) {
            abort(404, '不存在的专辑');
            die;
        }
        if (self::mobile()) {
            $this->redirect('/mobile?m=album&c=' . $aid, 301);
            die;
        }
        $albums_id = json_decode($album['content'], true);
        $albums = array_slice($albums_id, $vid > 0 ? $vid - 1 : $vid, 20, true);
        !isset($albums[$vid]) ? die('不存在的列表数据') : '';
        $next = isset($albums[$vid + 1]) ? 1 : 0;
        foreach ($albums as $k => $v) {
            $albums[$k] = db::view('filelist', 'filename,id,fid,type,user,uptime')
                ->view('filecount', 'ssid,fid,path,duration', 'filecount.fid=filelist.fid')
                ->view('server', 'playhost', 'server.ssid=filecount.ssid')
                ->view('share', 'shareid', 'share.fid=filelist.fid', "LEFT")
                ->view('FileSale', 'price', ['FileSale.fid=filelist.fid', 'FileSale.user=filelist.user'], 'LEFT')
                ->view('usersetting', ['content' => 'defaultscore'], ['usersetting.uid="' . $album['user'] . '"', 'usersetting.type="score"'], 'LEFT')
                ->view('ClickCount', 'click', ['ClickCount.type="share"', 'ClickCount.aid=filelist.fid'], 'LEFT')
                ->view('statistics', 'num', ['statistics.vid=filelist.fid', 'statistics.aid=share.shareid'], 'LEFT')
                ->where('filelist.id', $v)
                ->where('filelist.user', 'in', (isset($this->webconfig['publicoff']) && $this->webconfig['publicoff'] === 1) ? [$album['user'], 1] : [$album['user']])
                ->where('filecount.filetype', 'video')
                ->where('share.user', 'in', (isset($this->webconfig['publicoff']) && $this->webconfig['publicoff'] === 1) ? [$album['user'], 1] : [$album['user']])
                ->cache(true, 10)
                ->find();
        }
        $albums[$vid]['uptime'] = Tools::tranTime($albums[$vid]['uptime']);
        $sign = new Ppsign;
        $sign->sid = $albums[$vid]['ssid'];
        $view = new View;
        $view->next = $next;
        $view->albums = $albums;
        $view->vid = $vid;
        $view->aid = $aid;
        $view->sign = $sign->encode();
        if (!$albums[$vid]['price'] && !$albums[$vid]['defaultscore']) {
            $albums[$vid]['price'] = 0;
        } else {
            $albums[$vid]['price'] = $albums[$vid]['price'] ? $albums[$vid]['price'] : (int) $albums[$vid]['defaultscore'];
        }
        $view->active = $albums[$vid];
        $album['nickname'] = !$album['nickname'] ? Tools::hideStar($album['username']) : $album['nickname'];
        $view->album = $album;
        $view->cardlink = $this->cardLink;
        $isbuy = false;
        $user = new User;
        $header = new commonView();
        $header->type = 'header';
        $view->header = $header->build();
        $header->type = 'footer';
        $view->footer = $header->build();
        $user->isLogin();
        $result = $user->done();
        if (!$result['status']) {
            $islogin = 0;
        } else {
            $islogin = 1;
            $view->luser = $result;
        }
        $view->randalbum = db::name('album')->orderRaw('rand()')->field('enid,title,thumb')->limit(20)->select();
        $view->isbuy = $isbuy;
        $view->islogin = $islogin;
        $view->webname = $this->webconfig['webname'];
        if (!cache::get(session_id() . 'sharenum' . $albums[$vid]['fid'])) {
            if (db::name('ClickCount')->where('type', 'album')->where('aid', $albums[$vid]['fid'])->find()) {
                db::name('ClickCount')->where('type', 'album')->where('aid', $albums[$vid]['fid'])->setinc('click');
            } else {
                $cout = [
                    'type' => 'album',
                    'aid' => $albums[$vid]['fid'],
                    'click' => 1
                ];
                db::name('ClickCount')->insert($cout);
            }
            cache::set(session_id() . 'sharenum' . $albums[$vid]['fid'], time(), 86400);
        };
        return $view->fetch('album');
    }
    public function m3u8($vsign)
    {
        $sign = new Sign();
        $detoken = $sign->decode($vsign, Config('system.loginToken'), ['HS256']);
        if (!$detoken || gettype($detoken) != 'object') {
            return json(Codeinfo::TOKENFAILD);
            die;
        }
        if (!$m3u8 = Cache::get($detoken->data->fid . 'm3u8' . $this->start . $this->end)) {
            $sign = new Ppsign;
            $sign->sid = $detoken->data->ssid;
            $m3u8url = "{$detoken->data->playhost}{$detoken->data->path}/index.m3u8?sign={$sign->encode()}&start={$this->start}&end={$this->end}";
            $m3u8 = Tools::curlGet($m3u8url);
            if (!$m3u8) {
                $data = [
                    'code' => 502,
                    'msg' => '存储单元通信失败',
                    'status' => false
                ];
                return json($data);
                die;
            }
            if (!strstr($m3u8, $detoken->data->playhost)) {
                if (strstr($m3u8, '/ppvod/')) {
                    $m3u8 = str_replace('/ppvod/', $detoken->data->playhost . '/ppvod/', $m3u8);
                } else {
                    $m3u8 = str_replace($detoken->data->path, $detoken->data->playhost . $detoken->data->path, $m3u8);
                }
            }
            Cache::set($detoken->data->fid . 'm3u8' . $this->start . $this->end, $m3u8, 7200);
        }
        header("Content-type: application/vnd.apple.mpegurl");
        header('Content-Disposition: attachment; filename="m3u8.m3u8"');
        echo $m3u8;
    }
    public function share($sid = '')
    {
        if (!$sid) {
            abort(404, '不存在的分享数据');
            die;
        }
        $sdb = db::view('share', 'shareid,fid,user')
            ->view('filelist', 'filename,type,uptime', ['filelist.fid=share.fid', 'filelist.user=share.user'])
            ->view('user', 'avatar,username,sign,enid', 'user.id=share.user')
            ->view('FileSale', 'price', ['FileSale.fid=share.fid', 'FileSale.user=share.user'], 'LEFT')
            ->view('usersetting', ['content' => 'defaultscore'], ['usersetting.uid=filelist.user', 'usersetting.type="score"'], 'LEFT')
            ->view('filecount', 'path,duration', 'filecount.fid=filelist.fid')
            ->view('server', 'playhost,ssid', 'server.ssid=filecount.ssid')
            ->view('ClickCount', 'click', ['ClickCount.type="share"', 'ClickCount.aid=share.shareid'], 'LEFT')
            ->where('share.shareid', $sid)
            ->find();
        if (!$sdb) {
            abort(404, '不存在的分享数据');
            die;
        }
        if (empty($sdb['avatar'])) {
            $sdb['avatar'] = "/model/static/img/default-avatar.jpg";
        }
        if (self::mobile()) {
            $this->redirect('/mobile?m=share&c=' . $sid, 301);
            die;
        }
        $count = db::view('filecount', 'ssid,fid,shareid,orgfile')
            ->view('server', 'ssid,playhost', 'server.ssid=filecount.ssid')
            ->where('fid', $sdb['fid'])
            ->find();
        $view = new View;
        $isbuy = false;
        if (!$sdb['price'] && !$sdb['defaultscore']) {
            $isget = false;
            $sdb['price'] = 0;
        } else {
            $sdb['price'] = $sdb['price'] ? $sdb['price'] : (int) $sdb['defaultscore'];
            $isget = true;
        }
        $user = new User;
        $user->isLogin();
        $result = $user->done();
        if (!$result['status']) {
            $islogin = 0;
        } else {
            $islogin = 1;
            $view->luser = $result;
        }
        $sdb['uptime'] = Tools::tranTime($sdb['uptime']);
        $mt_rand = db::name('share')->count();
        $mt_rand_num = mt_rand(0, $mt_rand);
        $randData = db::view('share', 'shareid,fid')
            ->view('filelist', 'filename', ['filelist.fid=share.fid', 'filelist.user=share.user'])
            ->view('filecount', 'path,duration', ['filecount.fid=filelist.fid'])
            ->view('FileSale', 'price', ['FileSale.fid=share.fid', 'FileSale.user=share.user'], 'LEFT')
            ->view('server', 'playhost', 'server.ssid=filecount.ssid')
            ->view('ClickCount', 'click', ['ClickCount.type="share"', 'ClickCount.aid=filelist.fid'], 'LEFT')
            ->view('statistics', 'num', ['statistics.aid=share.shareid', 'statistics.vid=share.fid'], 'LEFT')
            ->where('share.id', ['>', $mt_rand_num], ['<', $mt_rand_num + 20])
            ->limit(20)
            ->select();
        $otherData = db::view('share', 'shareid')
            ->view('filelist', 'filename', ['filelist.fid=share.fid', 'filelist.user=share.user'])
            ->view('filecount', 'path,duration', 'filecount.fid=share.fid')
            ->view('server', 'playhost', 'server.ssid=filecount.ssid')
            ->view('FileSale', 'price', ['FileSale.fid=share.fid', 'FileSale.user=share.user'], 'LEFT')
            ->view('statistics', 'num', ['statistics.aid=share.shareid', 'statistics.vid=share.fid'], 'LEFT')
            ->where('share.shareid', 'neq', $sid)
            //->cache(true)
            ->limit(10)
            ->select();
        $data['master'] = $sdb;
        $data['master']['username'] = Tools::hideStar($sdb['username']);
        $data['count'] = $count;
        $view->isget = $isget;
        $view->isbuy = $isbuy;
        $view->cardlink = $this->cardLink;
        $view->oterfile = $randData;
        $view->islogin = $islogin;
        $view->otherData = $otherData;
        $view->data = $data;
        $header = new commonView();
        $header->type = 'header';
        $view->header = $header->build();
        $header->type = 'footer';
        $view->footer = $header->build();
        $view->webname = $this->webconfig['webname'];
        if (!cache::get(session_id() . 'sharenum' . $sid)) {
            if (db::name('ClickCount')->where('type', 'share')->where('aid', $sid)->find()) {
                db::name('ClickCount')->where('type', 'share')->where('aid', $sid)->setinc('click');
            } else {
                $cout = [
                    'type' => 'share',
                    'aid' => $sid,
                    'click' => 1
                ];
                db::name('ClickCount')->insert($cout);
            }

            cache::set(session_id() . 'sharenum' . $sid, time(), 86400);
        };

        return $view->fetch('share');
    }
    public function iframeLogin()
    {
        if (Session::get('user', 'index')) {
            return json(['msg' => '重复登陆']);
        }
        $view = new View;
        return $view->fetch('user');
    }
    public function ajaxlogin(Request $par)
    {
        if (!$par->param()['par']) {
            return json(Codeinfo::FAILD);
            die;
        }
        $params = json_decode($par->param()['par'], true);
        $login = new Ajaxlogin(
            $params
        );
        $login->login();
        return $login->returnJson();
    }
    public function iframeReg()
    {
        if (Session::get('user', 'index')) {
            return json(['msg' => '重复登陆']);
        }
        $view = new View;
        $view->force = $this->webconfig['force'];
        return $view->fetch('reg');
    }
    public function ajaxReg(Request $par)
    {
        if (Session::get('user', 'index')) {
            return json(['msg' => '重复登陆']);
        }
        if (!$par->param()['par']) {
            return json(Codeinfo::FAILD);
            die;
        }
        $params = json_decode($par->param()['par'], true);
        $login = new Ajaxlogin(
            $params
        );
        $login->reg();
        return $login->returnJson();
    }
    public function iframeResetpass()
    {
        if (Session::get('user', 'index')) {
            return json(['msg' => '重复登陆']);
        }
        $view = new View;
        return $view->fetch('resetpass');
    }
    public function ajaxResetpass(Request $par)
    {
        if (!$par->param()['par']) {
            return json(Codeinfo::FAILD);
            die;
        }
        $params = json_decode($par->param()['par'], true);
        $login = new Ajaxlogin(
            $params
        );
        $login->resetPass();
        return $login->returnJson();
    }
    private function mobile()
    {
        $agent = $_SERVER['HTTP_USER_AGENT'];
        if (stristr($agent, 'Iphone') || stristr($agent, 'Android') || stristr($agent, 'MeeGo') || stristr($agent, 'iPad') || stristr($agent, 'Windows Phone') || stristr($agent, 'JUC') || stristr($agent, 'spider') || stristr($agent, 'MicroMessenger')) {
            return true;
        } else {
            return false;
        }
    }
    public function iframeComment($vid, $model = "mobile")
    {
        $data = db::name('comment')->where('aid', $vid)->order('time desc')->select();
        foreach ($data as $key => $value) {
            $data[$key]['time'] = Tools::tranTime($value['time']);
            if (is_file(ROOT_PATH . 'public' . DS . 'uploads' . DS . 'avatar' . DS . $value['user'] . '.jpg')) {
                $data[$key]['avatar'] = '/uploads/avatar/' . $value['user'] . '.jpg';
            } else {
                $data[$key]['avatar'] = '/model/static/img/default_' . mt_rand(1, 10) . '.jpg';
            }
        }
        $view = new View;
        $view->vid = $vid;
        $view->data = $data;
        switch ($model) {
            case 'mobile':
                return $view->fetch('comment');
                break;
            case 'pc':
                return $view->fetch('pc_comment');
                break;
        }
    }
}
