<?php
namespace app\index\model;
use think\Model;
use think\Db;
use think\Validate;
use common\Codeinfo;
use common\Sign;
use app\common\model\User;
use think\Config;
use think\Session;
use think\Cookie;
use think\Cache;
class Ajaxlogin extends Model{
    private $db;
    /**
     * 数据库对象
     */
    private $params;
    /**
     * 构造参数
     */
    private $msg;
    /**
     * 获取回执结果
     */
    private $config;
    /**
     * 系统配置文件
     */
    private $ssid;
    /**
     * session_id $str
     */
    public function __construct($params){
        $rule = [
            'username'   => 'require|email',
            'password'   => 'min:8|max:16',
            '__token__'  => ['token'],
        ];
        $message = [
            'username.require' => '非法请求',
            'username' => '用户名格式不正确',
            '__token__.require' => '非法请求',
            '__token__.token'   => '请不要重复提交'
        ];
        $Validate=new Validate($rule,$message);
        $result=$Validate->check($params);
        if (!$result) {
            $data=[
                'code'=>202,
                'info'=>$Validate->getError(),
                'status'=>false
            ];
            echo json_encode($data);
            die;
        }
        $this->db=Db::name('user');
        $this->params=$params;
        $this->config=json_decode(file_get_contents(APP_PATH.'config.json'),true)['system'];
        $this->ssid=session_id();
    }
    public function login(){
        if (!$this->params['username'] || !$this->params['password']) {
            $this->msg=Codeinfo::FAILD;
            return;
            die;
        }
        $udb=$this->db->where('username',$this->params['username'])->find();
        if (!$udb) {
            $ccuser=Cache::pull($this->ssid.'ify');
            if (empty($ccuser['user']) || $this->params['username']!=$ccuser['user']) {
                $this->msg=Codeinfo::NOUSER;
                return;
            }else{
                if ($ccuser['password']!=$this->params['password']) {
                    $this->msg=Codeinfo::PWFAILD;
                    return;
                    die;
                }
                $user=new User;
                $user->username=$this->params['username'];
                $user->password=$this->params['password'];
                @$this->params['extend']?$user->extend=$this->params['extend']:'';
                $user->createUser();
                $result=$user->done();
                if (!$result['status']) {
                    $this->msg=$result;
                    return;
                }
                return $this->login();
            }
        }
        if ($ccmod=Cache::pull($this->ssid.'modify')) {
            if ($this->params['password']==$ccmod['password']) {
                $this->params['password']=$ccmod['password'];
                $newpass=md5($ccmod['password'].$udb['salt']);
                $this->db->where("username",$this->params['username'])->setField('password',$newpass);
                return $this->login();
            }
        }
        if ($udb['password'] != md5($this->params['password'].$udb['salt'])) {
            $this->msg=Codeinfo::PWFAILD;
            return;
            die;
        }
        if ($udb['status']!=1) {
            $this->msg=Codeinfo::USERSTATUS.$udb['status'];
            return;
            die;
        }
        if ($vipuser=db::name('useratta')->where('uid',$udb['id'])->find()) {
            if ($vipuser['endtime']<=time()) {
                $this->db->where('id',$udb['id'])->setfield('gid',1);
                db::name('useratta')->where('id',$vipuser['id'])->delete();
            }
        }
        $token=[
            "iss"=>"",
            "aud"=>"",
            "iat" => time(),
            "nbf" => time(),
            "exp" => time()+$this->config['timeout'],
            "user" => $udb
        ];
        $checkSign=new Sign;
        $sign=$checkSign->encode($token,config::get('system.loginToken'));
        Session::set('user',$udb,'index');
        Cookie::set('cp_token',$sign);
        $this->msg=Codeinfo::SUCCESS;
        $this->msg['token']=$sign;
        $this->msg['username']=$udb['username'];
        $this->msg['loginTime']=time();
        return;
    }
    public function reg(){
        if ($this->config['weboff']==1 || $this->config['regoff']==1) {
            return $this->msg=Codeinfo::REGOFF;
        }
        if ($this->db->where('username',$this->params['username'])->find()) {
            return $this->msg=Codeinfo::USERSTATUS1;
        }
        $user=new User();
        if ($this->config['force']===0) {
            $user->username=$this->params['username'];
            $user->password=$this->params['password'];
            $user->createUser();
        }else{
            $user->username=$this->params['username'];
            $user->emailReg();
        }
        return $this->msg=$user->done();
    }
    public function resetPass(){
        $user=new User;
        $user->username=$this->params['username'];
        $user->resetPass();
        return $this->msg=$user->done();
    }
    public function returnJson(){
        return json($this->msg);
    }
}