<?php

namespace common;

class Codeinfo
{
    const FAILD                     = array('info' => '非法请求', 'code' => 403, 'status' => false);
    const YUMFAILD                  = array('info' => '服务器脚本出现故障等待管理员修复', 'code' => 502, 'status' => false);
    const NOLOGIN                   = array('info' => '您还没有登录', 'code' => 403, 'status' => false);
    const NODIR                     = array('info' => '目录不存在', 'code' => '404ND', 'status' => false);
    const NOUSER                    = array('info' => '用户不存在', 'code' => '404NU', 'status' => false);
    const LOGINSUCCESS              = array('info' => '登陆成功', 'code' => '200LS', 'status' => true);
    const REGSUCCESS                = array('info' => '注册成功', 'code' => '200RS', 'status' => true);
    const USERSTATUS0               = array('info' => '您的账号等待审核,通过后才能使用', 'code' => '201US0', 'status' => false);
    const USERSTATUS1               = array('info' => '已存在的账号', 'code' => '200US1', 'status' => false);
    const USERSTATUS3               = array('info' => '此账号已被系统封禁', 'code' => '203US3', 'status' => false);
    const USERSTATUS4               = array('info' => '此账号邮箱验证尚未通过', 'code' => '204US4', 'status' => false);
    const PWFAILD                   = array('info' => '密码错误', 'code' => '500PAF', 'status' => false);
    const CDFAILD                   = array('info' => '验证码错误', 'code' => '500CAF', 'status' => false);
    const SUCCESS                   = array('info' => 'OK', 'code' => 200, 'status' => true);
    const SESSIONFAILD              = array('info' => '亲的浏览器似乎出了些问题', 'code' => '500SSF', 'status' => false);
    const EMAILSUCCESS              = array('info' => '密码已经发送至邮箱,有效期30分钟', 'code' => '200ES', 'status' => true);
    const EMAILFAILD                = array('info' => '邮件发送失败', 'code' => '500EF', 'status' => false);
    const FROMFAILD                 = array('info' => '表单验证失败', 'code' => '500FF', 'status' => false);
    const CREATEMASTERDIRFAILD      = array('info' => '创建用户基础目录失败', 'code' => '500CDF', 'status' => false);
    const DBFAILD                   = array('info' => '数据库操作失败', 'code' => '500DBF', 'status' => false);
    const DBNOUP                   = array('info' => '并没有什么更新', 'code' => '202DBN', 'status' => false);
    const MKDIRSUCCESS              = array('info' => '创建成功', 'code' => '200MDS', 'status' => true);
    const REPEATDIR                 = array('info' => '已经存在的文件夹', 'code' => '203RED', 'status' => false);
    const PWMODIFYFAILD             = array('info' => '修改失败', 'code' => '500PMF', 'status' => false);
    const PWNOFROM                  = array('info' => '密码不符合要求', 'code' => '205PNF', 'status' => false);
    const CREATESHARESUCCESS        = array('info' => '创建成功', 'code' => '200CSS', 'status' => true);
    const FILEFAILD                 = array('info' => '文件不存在', 'code' => '404FF', 'status' => false);
    const NOMODIFY                  = array('info' => '未知的文件操作', 'code' => '404NM', 'status' => false);
    const SHAREFAILD                = array('info' => '此链接已失效', 'code' => '404SF', 'status' => false);
    const WEBOFF                    = array('info' => '当前网盘系统处于关闭状态', 'code' => '403WO', 'status' => false);
    const REGOFF                    = array('info' => '当前网盘系统禁止注册', 'code' => '403RO', 'status' => false);
    const CONFIGFAILD               = array('info' => '配置文件操作失败', 'code' => '500CFF', 'status' => false);
    const SERVERTIMEOUT             = array('info' => '服务器连接超时', 'code' => '502STO', 'status' => false);
    const SERVERREPEAT              = array('info' => '存在相同的存储单元', 'code' => '204SRE', 'status' => false);
    const SERVERINSTALLCLOCK        = array('info' => '不可逆的安装操作', 'code' => '505SIC', 'status' => false);
    const NOINSTALL                 = array('info' => '系统安装异常', 'code' => '202NI', 'status' => false);
    const DBLINKERROR               = array('info' => '数据库链接失败', 'code' => '502DLE', 'status' => false);
    const DBCREATETABLEERROR        = array('info' => '数据库表创建失败', 'code' => '502DTE', 'status' => false);
    const NOUPSERVER                = array('info' => '暂无可用存储单元', 'code' => '404NS', 'status' => false);
    const TOKENFAILD                = array('info' => '令牌验证失败', 'code' => '403TF', 'status' => false);
    const RIGHTFAILD                = array('info' => '文件写入失败,检查系统权限', 'code' => '500RF', 'status' => false);
    const FILEDELETEFAILD           = array('info' => '文件删除失败,请手动操作', 'code' => '500FDF', 'status' => false);
    const FILEDELETESUCCESS         = array('info' => '删除成功', 'code' => '200FDS', 'status' => true);
    const DOMAINFAILD               = array('info' => '目标服务器禁止上传', 'code' => '403DF', 'ifExist' => 0, 'status' => false);
    const FILEHIT                   = array('info' => '文件命中', 'code' => '200FHS', 'ifExist' => 1, 'status' => true);
    const FILENOHIT                 = array('info' => '文件未命中', 'code' => '202FNH', 'ifExist' => 0, 'status' => true);
    const DISKFULL                  = array('info' => '您的空间已满', 'code' => '205DF', 'ifExist' => 0, 'status' => false);
    const DIEIP                     = array('info' => '由于您的频繁操作已被系统锁定', 'code' => '403DIF', 'status' => false);
    const MKDRIFAILD                = array('info' => '创建文件夹失败', 'code' => '502MDF', 'status' => false);
    const NOCDKEY                   = array('info' => '没找到对应的CDKEY', 'code' => '204NCDF', 'status' => false);
    const CDKEYFAILD                = array('info' => '非法卡密', 'code' => '403CDF', 'status' => false);
    const CDKEYSUCCESS              = array('info' => '充值成功', 'code' => '200CDS', 'status' => true);
    const CDKEYERROR                = array('info' => '充值失败', 'code' => '500CDE', 'status' => false);
    const NOITEMS                   = array('info' => '商品不存在', 'code' => '404NT', 'status' => false);
    const BUYSUCCESS                = array('info' => '购买成功', 'code' => '200BS', 'status' => true);
    const CASHLOW                   = array('info' => '您没有足够的积分', 'code' => '202CL', 'status' => false);
    const NOALIPAY                  = array('info' => '没找到对应支付宝账号', 'code' => '202NA', 'status' => false);
    const SALESUCCESS               = array('info' => '出售成功', 'code' => '200SS', 'status' => true);
    const SALEERROR                 = array('info' => '出售失败', 'code' => '202SE', 'status' => false);
}
