; !function (win) {
    "use strict";
    var $Pui = function () {
        this.describe = 'PPui kernel';
        this.ver = '1.0.0';
        $.ajax({ dataType: "script", url: '//at.alicdn.com/t/font_1362083_sd7i8sev3ym.js', cache: true });
    };
    window.eleCon = 'null';
    $Pui.prototype = {
        use: function (apps, callback) {
            let that = this;
            $.each(apps, function (i, item) {
                that[item] = that[item];
            })
            callback();
        },
        tips: function(ele,content,call){
            let _ele = $('.pui-tips[pui-element=' + ele + ']');
            _ele.css('position','relative');
            let that = this;
            let thisEle;
            _ele.hover(function(){
                let elePosition = _ele.offset();
                that.set(_ele.height()+15,(_ele.width()/4),content);
            },function(){
                that.unset();
            });
            this.set = function(top,left,content){
                let html = "<div class='pui-content' style=\"position:absolute;left:-"+(left + 10)+"px;top:"+ top +"px;width:150px;height:150px;border-radius:5px;box-shadow:0 0 5px #d7d7d7;z-index:2000;background-color:#fff;padding:15px;color:#333;\">" + content + "</div>";
                this.thisEle = $(html).appendTo('.pui-tips[pui-element=' + ele + ']');
                call();
            }
            this.unset = function(){
                this.thisEle.remove();
            }
            
        },
        message: function (type, content, timeout) {
            var time = timeout || 1500;
            var eleCount = $('.message');
            if (eleCount.length > 0) {
                var newHeight = $(eleCount[0]).height() + 10;
                var top = newHeight * eleCount.length
                var top = top + 10;
            } else {
                var top = 10;
            }
            switch (type) {
                case 'info':
                    var html = "<div class=\"message info slideDown ppShadow-10\" style=\"top:" + top + "px\"><svg class=\"icon\" aria-hidden=\"true\"><use xlink:href=\"#icon-info\"></use></svg><div class=\"content\">" + content + "</div>"
                    break;
                case 'success':
                    var html = "<div class=\"message success slideDown ppShadow-10\" style=\"top:" + top + "px\"><svg class=\"icon\" aria-hidden=\"true\"><use xlink:href=\"#icon-success\"></use></svg><div class=\"content\">" + content + "</div>"
                    break;
                case 'faild':
                    var html = "<div class=\"message faild slideDown ppShadow-10\" style=\"top:" + top + "px\"><svg class=\"icon\" aria-hidden=\"true\"><use xlink:href=\"#icon-faild\"></use></svg><div class=\"content\">" + content + "</div>"
                    break;
                case 'warning':
                    var html = "<div class=\"message warning slideDown ppShadow-10\" style=\"top:" + top + "px\"><svg class=\"icon\" aria-hidden=\"true\"><use xlink:href=\"#icon-warning\"></use></svg><div class=\"content\">" + content + "</div>"
                    break;
                default:
                    break;
            }
            var ele = $(html).appendTo('body');
            setTimeout(() => {
                $(ele).removeClass('slideDown').addClass('slideUp').remove();
            }, time);
        },
        modal: function (type, data, callback) {
            var index = "<div class=\"modal ppShadow-20\"><div class=\"title\">提示:<span class=\"close\"><svg class=\"icon\" aria-hidden=\"true\"><use xlink:href=\"#icon-close\"></use></svg></span></div><div class=\"content\">";
            switch (type) {
                case 'iframe':
                    var html = '<iframe src="' + data + '"></iframe>';
                    break;
                case 'msg':
                    let tmp = '';
                    $.each(data.btn, function (i, v) {
                        tmp = tmp + '<a class="ppButton ppBlue" href="javascript:;" ppui-bid="' + v.bid + '">' + v.btname + '</a>'
                    });
                    var html = '<div class="article">' + data.content + '</div><div class="bottom_btn">' + tmp + '</div>';
                    break;
                default:
                    break;
            }
            var end = "</div></div>";
            var ele = $(index + html + end).appendTo('body');
            $(ele).css('margin-top', '-' + ($(ele).height() / 2) + 'px');
            $(ele).find('span.close').click(function () {
                $(ele).remove();
            })
            if (typeof $(ele).find('.bottom_btn') != 'undefined') {
                let eles = $(ele).find('.bottom_btn').find('a');
                $.each(eles, function (i, v) {
                    $(v).click(function () {
                        callback($(v).attr('ppui-bid'));
                    })
                })
            }
        },
        domLoading: function (ele, call) {
            var ele = $('.ppLoading[pui-element=' + ele + ']');
            $.each(ele, function (i, item) {
                let parHeight = $(item).height();
                $(item).append("<div class=\"loadingDom\" style=\"height:" + parHeight + "px;\"> <div class=\"loading\"><svg class=\"icon spinner\" aria-hidden=\"true\"><use xlink:href=\"#icon-loading2\"></use></svg><span>Loading...</span></div></div>");
            });
            var status = {
                data: ele.attr('pui-data'),
                done: function () {
                    ele.removeClass('ppLoading');
                    ele.find('.loadingDom').remove();
                },
                faild: function () {
                    ele.find('.loadingDom .loading').html('<svg class=\"icon faild\" aria-hidden=\"true\"><use xlink:href=\"#icon-shibai\"></use></svg><span>加载失败</span>');
                }
            };
            call(status);
        },
        give: function (ele, callback) {
            this.give.setEle = function (element, status) {
                if (status === 'select') {
                    element.addClass(element.attr('pui-flash'));
                    element.attr('pui-status', 'select');
                    element.css('color', '#ffd524');
                } else {
                    element.removeClass(element.attr('pui-flash'));
                    element.attr('pui-status', 'cancel');
                    element.css('color', '#999999');
                }

            };
            let that = this;
            $('.ppGive[pui-element=' + ele + ']').click(function () {
                let element = $(this);
                var edata = element.attr('pui-id');
                if (element.attr('pui-status') == 'select') {
                    that.give.setEle(element, 'cancel');
                    callback('cancel', edata);
                } else {
                    that.give.setEle(element, 'select');
                    callback('select', edata);
                }
            });
            callback('init', $('.ppGive[pui-element=' + ele + ']'));
        },
        reHtmlfontsize: function () {
            let width = document.body.clientWidth;
            $('html').css('font-size', width / 7.5 + "px");
        },
        getApi: function (model, params, callback) {
            let par = {
                'model': model,
                'params': JSON.stringify(params)
            }
            let that = this;
            $.post('/api', par, function (res) {
                if (typeof res === 'string') {
                    res = JSON.parse(res);
                }
                if (res.status) {
                    callback(res.show);
                } else {
                    that.message('faild', res.info);
                }
            })
                .fail(function (msg) {
                    that.message('faild', '服务器故障', 3000);
                })
        },
        $PPP: function (url, ele) {
            this._url = url;
            this._ele = ele;
            this.status = 'ready';
            this.init = function () {
                let hls = new Hls();
                hls.loadSource(this._url);
                hls.attachMedia(this._ele);
            }
            this.init();
            let self = this;
            let Current = $(this._ele);
            Current.click(function () {
                switch (Current.attr('ppp-status')) {
                    case 'pause':
                    case 'ready':
                        self.play();
                        break;
                    case 'play':
                        self.pause();
                        break;
                    default:
                        break;
                }
            });
            this._ele.addEventListener('play', function () {
                self.setStatus('play');
                if (window.eleCon != this && window.eleCon != 'null') {
                    window.eleCon.pause();
                    window.eleCon = this;
                } else {
                    window.eleCon = this;
                }
            });
            this._ele.addEventListener('pause', function () {
                self.setStatus('pause');
            });
            this._ele.addEventListener('ended', function () {
                self.setStatus('ended');
            });
            this.play = function () {
                this._ele.play();
            }
            this.pause = function () {
                this._ele.pause();
            }
            this.destruction = function () {

            }
            this.setStatus = function (val) {
                $(this._ele).attr('PPP-status', val);
                this.status = val;
            }
        },
        $Cookies: {
            set: function (key, value, exdays) {
                var d = new Date();
                d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
                var expires = "expires=" + d.toGMTString();
                document.cookie = key + "=" + value + "; " + expires;
            },
            get: function (key) {
                var name = key + "=";
                var ca = document.cookie.split(';');
                for (var i = 0; i < ca.length; i++) {
                    var c = ca[i].trim();
                    if (c.indexOf(name) == 0) return c.substring(name.length, c.length);
                }
                return "";
            }
        }
    };
    win.$Pui = new $Pui();
}(window);