<?php

namespace app\common\controller;

use think\Db;
use think\Session;
use think\Cache;
use think\Cookie;
use think\Controller;
use think\Config;
use think\Validate;
use common\Codeinfo;
use common\Tools;
use common\Sign;
use common\Hithandle;
use PHPMailer\SendEmail;
use app\common\model\User;

class Userauth
{
    private $params = [];
    /**
     *@var object 传参
     */
    private $userdb = [];
    /**
     *@var array 用户指针
     */
    private $ssid = '';
    /**
     *@var static 
     */
    private $token = [
        "iss" => "",
        "aud" => "",
        "iat" => '',
        "nbf" => '',
        "exp" => '',
        "user" => []
    ];
    private $config = [];
    /**
     *@var array 
     */
    private $key = '';
    public function __construct($par = [])
    {
        $this->params = $par;
        $this->ssid = session_id();
        $this->config = json_decode(file_get_contents(APP_PATH . 'config.json'), true)['system'];
        $this->token['iat'] = time();
        $this->token['nbf'] = time();
        $this->token['exp'] = time() + $this->config['timeout'];
        $this->key = config::get('system.loginToken');
    }
    public function login()
    {
        $checkSign = new Sign();
        if ($this->params->ify->token) {
            $detoken = $checkSign->decode($this->params->ify->token, $this->key, ['HS256']);
            if (!$detoken) {
                return Codeinfo::TOKENFAILD;
                die;
            }

            if ($this->params->ify->sid != $this->ssid || $this->ssid != $detoken->ssid) {
                return Codeinfo::TOKENFAILD;
                die;
            }
        } else {
            return Codeinfo::TOKENFAILD;
            die;
        }

        if ($this->params->username && $this->params->password) {
            if ($this->userdb = DB::name('user')->where("username", $this->params->username)->find()) {
                /*$userDATA */
                if ($ccmod = Cache::pull($this->ssid . 'modify')) {
                    if ($this->params->password === $ccmod['password']) {
                        $this->userdb['password'] = md5($ccmod['password'] . $this->userdb['salt']);
                        db::name('user')->where("username", $this->params->username)->setField('password', $this->userdb['password']);
                    }
                }
                if ($this->userdb['password'] === md5($this->params->password . $this->userdb['salt'])) {

                    switch ($this->userdb['status']) {
                        case '0':
                            $data = Codeinfo::USERSTATUS0;
                            break;
                        case '1':
                            if ($vipuser = db::name('useratta')->where('uid', $this->userdb['id'])->find()) {
                                if ($vipuser['endtime'] <= time()) {
                                    db::name('user')->where('id', $this->userdb['id'])->setfield('gid', 1);
                                    db::name('useratta')->where('id', $vipuser['id'])->delete();
                                }
                            }
                            $onlyEnid = Tools::only(time());
                            !$this->userdb['enid'] ? db::name('user')->where('id', $this->userdb['id'])->setField('enid', $onlyEnid) : '';
                            $data = Codeinfo::SUCCESS;
                            $this->token['user'] = $this->userdb;
                            $data['token'] = $checkSign->encode($this->token, $this->key);
                            Session::set('user', $this->userdb, 'index');
                            Cookie::set('token', $data['token']);
                            $USERDISKINFO = Hithandle::cacheChange('user', 'update');
                            $data['user'] = $this->userdb['username'];
                            $data['avatar'] = $this->userdb['avatar'];
                            $data['usign'] = $this->userdb['sign'];
                            $data['nickname'] = $this->userdb['nickname'];
                            $data['hash'] = $this->userdb['hash'];
                            $data['pro'] = $USERDISKINFO['diskpro'];
                            $data['count'] = Tools::formatBytes($USERDISKINFO['disksize']);
                            $data['space'] = Tools::formatBytes($this->userdb['diskspace']);
                            $data['enid'] = $this->userdb['enid'] ? $this->userdb['enid'] : $onlyEnid;
                            break;
                        case '3':
                            $data = Codeinfo::USERSTATUS3;
                            break;
                    }
                } else {
                    $data = Codeinfo::PWFAILD;
                }
            } else {
                $ccuser = Cache::pull($this->ssid . 'ify');
                if (empty($ccuser['user']) || $this->params->username != $ccuser['user']) {
                    $data = Codeinfo::NOUSER;
                } else {
                    if ($ccuser['password'] == $this->params->password) {
                        $salt = Tools::only(time());
                        $MASTERHASH = md5('/' . config('system.dirhash') . $this->params->username);
                        $userINFO = array(
                            'username' => $this->params->username,
                            'password' => md5($this->params->password . $salt),
                            'salt' => $salt,
                            'hash' => $MASTERHASH,
                            'phone' => '',
                            'diskspace' => $this->config['defaultspace'],
                            'status' => $this->config['isVerify'] == 1 ? 0 : 1,
                            'createtime' => date('Y-m-d H:i:s', time()),
                        );
                        if ($userINFO['id'] = db::name('user')->insertGetId($userINFO)) {
                            $this->userdb = $userINFO;
                            $filedirDB = array(
                                'hash' => $MASTERHASH,
                                'fromHash' => '',
                                'fromPath' => '',
                                'path' => '/',
                                'user' => $userINFO['id'],
                                'filename' => '',
                                'type' => 'dir',
                                'size' => '-',
                                'dborder' => 99,
                                'deserver' => 'all',
                                'uptime' => date('Y-m-d H:i:s', time())
                            );
                            if (db::name('filelist')->data($filedirDB)->insert()) {
                                $data = Codeinfo::SUCCESS;
                                Session::set('user', $this->userdb, 'index');
                                $USERDISKINFO = Hithandle::cacheChange('user', 'update');
                                if (!empty($ccuser['extend'])) {
                                    $exconfig = db::name('syssetting')->find('markketing');
                                    $exconfig = json_decode($exconfig['content']);
                                    if ($exuser = db::name('user')->where('enid', $ccuser['extend'])->find()) {
                                        $exadd = [
                                            'masteruser' => $exuser['id'],
                                            'fromuser' => $userINFO['id'],
                                            'uptime' => date('Y-m-d H:i:s', time())
                                        ];
                                        db::name('userext')->insert($exadd);
                                        db::name('user')->where('id', $exuser['id'])->setInc('score', $exconfig->onereward);
                                        db::name('userextlog')->insert(
                                            [
                                                'muser' => $exuser['id'],
                                                'fuser' => $userINFO['id'],
                                                'content' => '一级推广',
                                                'score' => $exconfig->onereward,
                                                'time' => date('Y-m-d H:i:s', time())
                                            ]
                                        );
                                        if ($fromuser = db::name('userext')->where('fromuser', $exuser['id'])->find()) {
                                            db::name('user')->where('id', $fromuser['masteruser'])->setInc('score', $exconfig->tworeward);
                                            db::name('userextlog')
                                                ->insert(
                                                    [
                                                        'muser' => $fromuser['masteruser'],
                                                        'fuser' => $userINFO['id'],
                                                        'content' => '二级推广',
                                                        'score' => $exconfig->tworeward,
                                                        'time' => date('Y-m-d H:i:s', time())
                                                    ]
                                                );
                                        }
                                    }
                                }
                                switch ($userINFO['status']) {
                                    case '0':
                                        $data = Codeinfo::USERSTATUS0;
                                        break;
                                    case '1':
                                        $checkSign = new Sign();
                                        $this->token['user'] = $this->userdb;
                                        $data['token'] = $checkSign->encode($this->token, $this->key);
                                        Cookie::set('token', $data['token']);
                                        if ($vipuser = db::name('useratta')->where('uid', $this->userdb['id'])->find()) {
                                            if ($vipuser['endtime'] <= time()) {
                                                db::name('user')->where('id', $this->userdb['id'])->setfield('gid', 1);
                                                db::name('useratta')->where('id', $vipuser['id'])->delete();
                                            }
                                        }
                                        $data['user'] = $userINFO['username'];
                                        $data['hash'] = $filedirDB['hash'];
                                        $data['avatar'] = $this->userdb['avatar'];
                                        $data['usign'] = $this->userdb['sign'];
                                        $data['nickname'] = $this->userdb['nickname'];
                                        $data['pro'] = Tools::formatBytes($USERDISKINFO['diskpro']);
                                        $data['count'] = Tools::formatBytes($USERDISKINFO['disksize']);
                                        break;
                                    case '3':
                                        $data = Codeinfo::USERSTATUS3;
                                        break;
                                }
                            } else {
                                $data = Codeinfo::CREATEMASTERDIRFAILD;
                            }
                        } else {
                            $data = Codeinfo::DBFAILD;
                        }
                    } else {
                        $data = Codeinfo::PWFAILD;
                    }
                }
            }
        } else {
            $data = Codeinfo::FROMFAILD;
        }
        return $data;
    }
    public function reg()
    {
        $checkSign = new Sign();
        if ($this->params->ify->token) {
            $detoken = $checkSign->decode($this->params->ify->token, $this->key, ['HS256']);
            if (!$detoken || $detoken == 'Key may not be empty') {
                return Codeinfo::TOKENFAILD;
                die;
            }
            if ($this->params->ify->sid != $this->ssid || $this->ssid != $detoken->ssid) {
                return Codeinfo::TOKENFAILD;
                die;
            }
        } else {
            return Codeinfo::TOKENFAILD;
            die;
        }
        if ($this->params->username) {
            if ($userDATA = DB::name('user')->where("username", $this->params->username)->find()) {
                $data = Codeinfo::USERSTATUS1;
            } else {
                $User = new User();
                $User->username = $this->params->username;
                if ($this->config['force'] === 0) {
                    if ($this->params->username && ($this->params->password == $this->params->rpassword)) {
                        $User->password = $this->params->password;
                        $User->createUser();
                        $data = $User->done();
                    }
                } else {
                    $User->emailReg();
                    $data = $User->done();
                }
            }
        } else {
            $data = Codeinfo::FROMFAILD;
        }
        return $data;
    }
}
