<?php

namespace app\common\model;

use think\Db;
use think\Cache;
use think\Config;
use common\Codeinfo;
use common\Ppsign;
use common\Sign;
use think\Model;
use common\Tools;

class Album extends Model
{
    public $par;
    /**
     * 
     * 构造参数 @Object
     */
    private $db;
    /**
     * 
     * 数据库对象 @Object
     */
    private $count;
    /**
     * 
     * 统计 @Object
     *  */
    private $cachetime;
    /**
     * 
     * 缓存周期 @Number
     */
    private $uip;
    /**
     * 
     * 客户端IP @String
     */
    public function __construct()
    {
        $this->db = db::name('album');
        $this->count = db::name('statistics');
        $this->cachetime = 86400;
        $this->uip = self::getClientIp();
    }
    public function giveLaud()
    {
        $data = Codeinfo::SUCCESS;
        switch ($this->par->modify) {
            case 'give':
                switch ($this->par->type) {
                    case '赞':
                        $CL = Cache::get('laud' . $this->par->aid . $this->par->vid . $this->uip);
                        if (!$CL) {
                            Cache::rm('trample' . $this->par->aid . $this->par->vid . $this->uip);
                            if ($this->count->where('aid', $this->par->aid)->where('vid', $this->par->vid)->setInc('num') === 0) {
                                $add = [
                                    'aid' => $this->par->aid,
                                    'vid' => $this->par->vid,
                                    'num' => 1
                                ];
                                if ($this->count->insert($add)) {
                                    $data['count'] = 1;
                                    $data = Codeinfo::SUCCESS;
                                } else {
                                    $data = Codeinfo::DBFAILD;
                                }
                            } else {
                                $data['count'] = $this->count->where('aid', $this->par->aid)->where('vid', $this->par->vid)->field('num')->find()['num'];
                            }
                            Cache::set('laud' . $this->par->aid . $this->par->vid . $this->uip, time(), $this->cachetime);
                        }
                        break;
                    case '踩':
                        $CL = Cache::get('trample' . $this->par->aid . $this->par->vid . $this->uip);
                        if (!$CL) {
                            Cache::rm('laud' . $this->par->aid . $this->par->vid . $this->uip);
                            if ($this->count->where('aid', $this->par->aid)->where('vid', $this->par->vid)->setDec('num') === 0) {
                                $add = [
                                    'aid' => $this->par->aid,
                                    'vid' => $this->par->vid,
                                    'num' => 0
                                ];
                                if ($this->count->insert($add)) {
                                    $data['count'] = 0;
                                    $data = Codeinfo::SUCCESS;
                                } else {
                                    $data = Codeinfo::FAILD;
                                }
                            } else {
                                $data['count'] = $this->count->where('aid', $this->par->aid)->where('vid', $this->par->vid)->field('num')->find()['num'];
                            }
                            Cache::set('trample' . $this->par->aid . $this->par->vid . $this->uip, time(), $this->cachetime);
                        }
                        break;
                }
                break;
        }
        return $data;
    }
    public function getVideo()
    {
        $SDB = Db::name('share');
        $FSDB = Db::name('FileSale');
        $ADB = Db::name('album');
        $FDB = Db::name('filelist');
        switch ($this->par->type) {
            case 'share':
                $share = $SDB->where('shareid', $this->par->vid)->find();
                $ufiledb = $FDB->where('fid', $share['fid'])->where('user', 'in', (isset($this->webconfig['publicoff']) && $this->webconfig['publicoff'] === 1) ? [$share['user'], 1] : [$share['user']])->find();
                if (!$ufiledb) {
                    return Codeinfo::FAILD;
                    die;
                }
                break;
            case 'album':
                $albumdb = $ADB->find($this->par->vid);
                if (!$albumdb) {
                    return Codeinfo::FAILD;
                    die;
                } else {
                    $ufiledb = $FDB->where('fid', $this->par->aid)->where('user', 'in', (isset($this->webconfig['publicoff']) && $this->webconfig['publicoff'] === 1) ? [$albumdb['user'], 1] : [$albumdb['user']])->find();
                    if (!$ufiledb) {
                        return Codeinfo::FAILD;
                        die;
                    } else {
                        $ids = json_decode($albumdb['content'], true);
                        if (!in_array($ufiledb['id'], $ids)) {
                            return Codeinfo::FAILD;
                            die;
                        } else {
                            $share = $ufiledb;
                        }
                    }
                }

                break;
            default:
                return Codeinfo::FAILD;
                die;
                break;
        }
        $file = db::view('filecount', 'ssid,path,fid,filetype,orgfile')
            ->view('server', 'playhost', 'server.ssid=filecount.ssid')
            ->where('filecount.fid', $ufiledb['fid'])
            ->find();
        if (!$file) {
            $data = Codeinfo::FILEFAILD;
            return $data;
            die;
        }
        $sale = 0;
        $filePrice = $FSDB->where('fid', $share['fid'])->where('user', $share['user'])->value('price');
        $userPrice = db::name('usersetting')->where('uid', $share['user'])->where('type', 'score')->value('content');
        if (!$filePrice && !$userPrice) {
            $sale = 0;
        } else {
            $sale = $filePrice ? $filePrice : (int) $userPrice;
        }
        $user = new User;
        $ppsign = new Ppsign;
        $ppsign->sid = $file['ssid'];
        $sign = new Sign;
        $token['data'] = $file;
        $token['iat'] = time();
        $token['nbf'] = time();
        $token['exp'] = time() + 7200;
        $data['is'] = false;
        $data['orgfile'] = '';
        $data['type'] = $file['filetype'];
        if ($sale > 1) {
            //$data['ssid'] = $share['shareid'];
            $data['is'] = true;
            $data['price'] = $sale;
            $user->isLogin();
            $result = $user->done();
            if (!$result['status']) {
                $data['islogin'] = false;
                if ($file['filetype'] === 'video') {
                    $data['url'] = '/m3u8?vsign=' . $sign->encode($token, config::get('system.loginToken'));
                }
            } else {
                $data['islogin'] = true;
                if ($share['user'] != $result['id']) { //浏览者是不是等于发布者
                    $user->uid = $result['id'];
                    $user->isbuy($file['fid']);
                    if (!$user->done()) {
                        $data['isbuy'] = false;
                        if ($file['filetype'] === 'video') {
                            $data['url'] = '/m3u8?vsign=' . $sign->encode($token, config::get('system.loginToken'));
                        }
                    } else {
                        $data['isbuy'] = true;
                        $data['orgfile'] = $file['playhost'] . $file['orgfile'];
                        if ($file['filetype'] === 'video') {
                            $data['url'] = $file['playhost'] . $file['path'] . '/index.m3u8?sign=' . $ppsign->encode();
                        }
                    }
                } else {
                    $data['isbuy'] = true;
                    $data['orgfile'] = $file['playhost'] . $file['orgfile'];
                    if ($file['filetype'] === 'video') {
                        $data['url'] = $file['playhost'] . $file['path'] . '/index.m3u8?sign=' . $ppsign->encode();
                    }
                }
            }
        } else {
            if ($file['filetype'] === 'video') {
                $data['orgfile'] = $file['playhost'] . $file['orgfile'];
                $data['url'] = $file['playhost'] . $file['path'] . '/index.m3u8?sign=' . $ppsign->encode();
            } else {
                $data['orgfile'] = $file['playhost'] . $file['orgfile'];
            }
        }
        return $data;
    }
    private function getClientIp()
    {
        $ip = 'unknown';
        $unknown = 'unknown';
        if (isset($_SERVER['HTTP_X_FORWARDED_FOR']) && $_SERVER['HTTP_X_FORWARDED_FOR'] && strcasecmp($_SERVER['HTTP_X_FORWARDED_FOR'], $unknown)) {
            $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
        } elseif (isset($_SERVER['REMOTE_ADDR']) && $_SERVER['REMOTE_ADDR'] && strcasecmp($_SERVER['REMOTE_ADDR'], $unknown)) {
            $ip = $_SERVER['REMOTE_ADDR'];
        }
        if (strpos($ip, ',') !== false) {
            $ip = reset(explode(',', $ip));
        }
        return $ip;
    }
}
