<?php

namespace app\common\model;

use think\Model;
use think\Db;
use common\Codeinfo;
use Iplocation\IpLocation;
use think\Cache;
use common\Tools;

class Comment extends Model
{
    /**
     * 视频源
     */
    private $vid;
    /**
     * 当前用户
     */
    private $user;
    /**
     * 评论数据库对象
     */
    private $db;
    /**
     * 文件指针
     */
    private $file;
    /**
     * 网盘配置信息
     */
    private $config;
    /**
     * 评论内容
     */
    public $content;
    public function __construct($vid)
    {
        $this->db = db::name('comment');
        $this->vid = $vid;
        if (empty($this->vid)) {
            echo json_encode(Codeinfo::FAILD);
            die;
        }
        if (!$this->file = db::name('filelist')->where('fid', $this->vid)->find()) {
            echo json_encode(Codeinfo::NOFILE);
            die;
        }
        $this->config = json_decode(file_get_contents(APP_PATH . 'config.json'), true)['system'];
    }
    public function insert()
    {
        if (empty($this->content) || strlen($this->content) >= 150) {
            $msg = [
                'info' => '评论字数超过限制',
                'code' => 202,
                'status' => false
            ];
            return $msg;
        }
        $this->content = Tools::remove_xss($this->content);
        $user = new User();
        $user->isLogin();
        $result = $user->done();
        if (!$result['status'] && !$this->config['comment']) {
            return $result;
        }
        $colors = [
            16777215, 15024726, 16769331, 6610199, 3788031, 13959417
        ];
        if ($this->config['comment'] && !$result['status']) {

            $IL = new IpLocation();
            $userip = $IL->getlocation($_SERVER['REMOTE_ADDR']);
            if (cache::get('commentclock' . $this->vid . $userip['ip'])) {
                $data = [
                    'status' => false,
                    'info' => '非会员用户每天只允许发送一条',
                    'code' => 202,
                ];
                return $data;
                die;
            }
            $cd = [
                'aid' => $this->vid,
                'content' => $this->content,
                'user' => 0,
                'nickname' => $userip['country'] . ' 网友',
                'avatar' => '/model/static/img/default_' . mt_rand(1, 10) . '.jpg',
                'time' => date('Y-m-d H:i:s', time()),
                'vtime' => $this->vtime,
                'color' => $colors[array_rand($colors)]
            ];
            if ($this->db->insert($cd)) {
                Cache::set('commentclock' . $this->vid . $userip['ip'], time(), 86400);
                return Codeinfo::SUCCESS;
            } else {
                return Codeinfo::DBFAILD;
            }
        } else {
            if (cache::get('commentclock' . $this->vid . $result['id'])) {
                $data = [
                    'info' => '两次评论间隔需要5分钟',
                    'status' => false,
                    'code' => 202
                ];
                return $data;
            }
            $cd = [
                'aid' => $this->vid,
                'content' => $this->content,
                'user' => $result['id'],
                'nickname' => $result['nickname'] ? $result['nickname'] : Tools::hideStar($result['username']),
                'avatar' => $result['avatar'] ? $result['avatar'] : $user->avatar,
                'time' => date('Y-m-d H:i:s', time()),
                'vtime' => $this->vtime,
                'color' => $colors[array_rand($colors)]
            ];
            if ($this->db->insert($cd)) {
                Cache::set('commentclock' . $this->vid . $result['id'], time(), 300);
                return Codeinfo::SUCCESS;
            } else {
                return Codeinfo::DBFAILD;
            }
        }
    }
}
