<?php

namespace app\index\controller;

use think\Request;
use think\Cookie;
use think\Controller;
use common\Codeinfo;
use common\Tools;
use common\CloseIP;
use app\common\controller\Userauth;
use app\common\controller\Common;
use app\common\controller\Member;
use app\common\model\Album;
use app\common\model\Comment;
use app\common\model\User;
use app\common\model\Square;

class Api extends Controller
{
    private $webconfig = [];
    public function __construct()
    {
        $SESSIP = new CloseIP();
        if ($SESSIP->init()) {
            echo json_encode(Codeinfo::DIEIP);
            die;
        } else {
            $this->webconfig = json_decode(file_get_contents(APP_PATH . 'config.json'), true)['system'];
        }
        Cookie::init(['prefix' => 'cp_', 'expire' => $this->webconfig['timeout'], 'path' => '/']);
        session_start();
    }
    /**
     * @param $reqdata
     */
    public function index(Request $reqdata)
    {
        debug('begin');
        $param = $reqdata->param();
        @$model = $param['model'];
        @$params = json_decode($param['params']);
        if ($params) {
            $params = Tools::remove_xss($params);
        }
        $data = [];
        $data = Codeinfo::FAILD;
        $data['systime'] = time();
        switch ($model) {
            case 'website':
            case 'WebStatus':
                $data = Codeinfo::SUCCESS;
                if ($model === 'website') {
                    $data['show'] = [
                        'WebName' => $this->webconfig['webname'],
                        'WebSubtitle' => $this->webconfig['subname'],
                        'Style' => json_decode(file_get_contents(APP_PATH . 'style.json'))
                    ];
                } else {
                    $data['show'] = [
                        'WebOff' => $this->webconfig['weboff'] == 1 ? true : false,
                        'RegOff' => $this->webconfig['regoff'] == 1 ? true : false,
                        'force' => $this->webconfig['force'] == 1 ? true : false,
                    ];
                }
                break;
            case 'reg':
            case 'login':
            case 'login_status':
                $data = Codeinfo::SUCCESS;
                if ($model != 'login_status') {
                    if ($this->webconfig['weboff'] == 1 || $this->webconfig['regoff'] == 1) {
                        $data['show'] = Codeinfo::REGOFF;
                    } else {
                        $USER = new Userauth($params);
                        $data['show'] = $USER->$model($params);
                    }
                } else {
                    $User = new User();
                    $User->isLogin();
                    $result = $User->done();
                    if ($result['status']) {
                        $data['show'] = $result['info'];
                    } else {
                        $data['show'] = $result;
                    }
                }
                break;
            case 'modifyPassword':
                $data = Codeinfo::SUCCESS;
                $User = new User();
                $User->username = $params->username;
                $User->resetPass();
                $data['show'] = $User->done();
                break;
            case 'giveLaud':
            case 'getVideo':
                $data = Codeinfo::SUCCESS;
                $Model = new Album;
                $Model->par = $params;
                $data['show'] = $Model->$model();
                break;
            case 'sendComment':
                $data = Codeinfo::SUCCESS;
                $Model = new Comment($params->vid);
                $Model->content = $params->content;
                $Model->vtime = $params->vtime;
                $data['show'] = $Model->insert();
                break;
            case 'square':
                $data = Codeinfo::SUCCESS;
                $Model = new Square();
                $Model->page = $params->page;
                $data['show'] = $Model->get();
                break;
            case 'loginout':
            case 'upserver':
            case 'addFile':
            case 'ifymd5':
            case 'countFile':
            case 'fileList':
            case 'mkdir':
            case 'soDir':
            case 'searchFile':
            case 'cateData':
            case 'refileName':
            case 'pasteFile':
            case 'deleteFile':
            case 'getFile':
            case 'createShare':
            case 'push':
            case 'CopyInfo':
            case 'getserverlist':
            case 'getnotice':
            case 'upalbum':
            case 'createdAlbum':
            case 'showAlbum':
            case 'saveAlbum':
            case 'deleteAlbum':
            case 'addAlbumIds':
                try {
                    $data = Codeinfo::SUCCESS;
                    $ModelAction = new Common;
                    if ($model === 'upalbum') {
                        $data['show'] = $ModelAction->$model($reqdata->file('file'), $reqdata->param()['enid']);
                    } else {
                        $data['show'] = $ModelAction->$model($params);
                    }
                } catch (\Throwable $e) {
                    $data = Codeinfo::YUMFAILD;
                }
                break;
            case 'resetPw':
            case 'userup':
            case 'saveuser':
            case 'upavatar':
            case 'recharge':
            case 'userRecharge':
            case 'getItem':
            case 'buyCard':
            case 'SavePushUrl':
            case 'getPushurl':
            case 'getUsercash':
            case 'getcash':
            case 'getUserlink':
            case 'getFromuser':
            case 'saleFile':
            case 'buyfile':
            case 'getoffer':
            case 'getinvite':
            case 'getScore':
            case 'saveScore':
                $data = Codeinfo::SUCCESS;
                $ModelAction = new Member;
                if ($model === 'upavatar') {
                    $data['show'] = $ModelAction->$model($reqdata->file('file'));
                } else {
                    $data['show'] = $ModelAction->$model($params);
                }

                break;
            case 'follow':
            case 'followList':
                $data = Codeinfo::SUCCESS;
                $action = new \app\common\model\Follow($params);
                $action->$model();
                $data['show'] = $action->msg;
                break;
        }
        debug('end');
        $data['ver'] = VER;
        $data['consuming'] = debug('begin', 'end');
        return json($data);
    }
}
