<?php

namespace common;

use think\captcha\Captcha;
use think\Db;

class Tools
{
	const IMGEXT	= array(
		'webp', 'jpg', 'png', 'ico', 'bmp', 'gif', 'tif', 'pcx', 'tga', 'bmp', 'pxc', 'tiff', 'jpeg', 'exif', 'fpx', 'svg', 'psd', 'cdr', 'pcd', 'dxf', 'ufo', 'eps', 'ai', 'hdri'
	);
	const ZIPEXT	= array(
		'rar', 'zip', 'tar', 'cab', 'uue', 'jar', 'iso', 'z', '7-zip', 'ace', 'lzh', 'arj', 'gzip', 'bz2', 'tz'
	);
	const VIDEOEXT 	= array(
		'mp4', 'avi', '3gp', 'rmvb', 'wmv', 'mkv', 'mpg', 'vob', 'mov', 'flv', 'swf', 'ape', 'mmf', 'amr'
	);
	const MUSICEXT	= array(
		'mp3', 'wma', 'aac', 'wav', 'wavpack', 'm4a', 'm4r', 'ogg',
	);
	const EXEEXT	= array(
		'exe', 'msi', 'app', 'apk', 'ipa'
	);
	const TEXTEXT	= array(
		'txt', 'lrc', 'wfs', 'host', 'box', 'perfect', 'dot', 'dsf', 'efe', 'ini', 'lnk', 'log', 'ost', 'pcs', 'tmp',
	);
	const XLSEXT	= array(
		'xls', 'xlsb', 'xlsx'
	);
	const PPTEXT	= array(
		'ppt', 'pdf', 'pps', 'pptx'
	);
	const WORDEXT	= array(
		'doc', 'docx', 'word', 'wps',
	);
	const CODEEXT	= array(
		'json', 'html', 'htm', 'java', 'js', 'css', 'less', 'php', 'asp', 'jsp', 'e', 'vue', 'scss', 'map'
	);
	const BTEXT	= array(
		'torrent', 'bt'
	);
	const REMOVEFILE	= '/api/removetask';
	const CHECKFILE		= '/uploads';
	const GETONEDB			= '/api/gettask';
	const GETDB			= '/api/gettask2';
	const GETSYSINFO	= '/api/sysinfo';
	static function file_format($str)
	{
		// 取文件后缀名
		$str = strtolower(pathinfo($str, PATHINFO_EXTENSION));
		// 匹配不同的结果
		switch ($str) {
			case in_array($str, self::IMGEXT):
				return 'image';
				break;
			case in_array($str, self::VIDEOEXT):
				return 'video';
				break;
			case in_array($str, self::ZIPEXT):
				return 'zip';
				break;
			case in_array($str, self::TEXTEXT):
				return 'text';
				break;
			case in_array($str, self::XLSEXT):
				return 'xls';
				break;
			case in_array($str, self::PPTEXT):
				return 'ppt';
				break;
			case in_array($str, self::WORDEXT):
				return 'word';
				break;
			case in_array($str, self::CODEEXT):
				return 'code';
				break;
			case in_array($str, self::EXEEXT):
				return 'exe';
				break;
			case in_array($str, self::BTEXT):
				return 'bt';
				break;
			case in_array($str, self::MUSICEXT):
				return 'music';
				break;
			default:
				return 'document';
				break;
		}
	}
	static function arr2time($data, $field = '')
	{
		foreach ($data as $key => $value) {
			$data[$key][$field] = self::tranTime($value[$field]);
		}
		return $data;
	}
	static function arr2size($data, $field)
	{
		foreach ($data as $key => $value) {
			$data[$key][$field] = self::formatBytes($value[$field]);
		}
		return $data;
	}
	static function arr2type($data, $field)
	{
		foreach ($data as $key => $value) {
			$data[$key][$field] = self::file_format($value[$field]);
		}
		return $data;
	}
	static function arr2userstatus($data, $field)
	{
		foreach ($data as $key => $value) {
			$data[$key][$field] = self::userstatus($value[$field]);
		}
		return $data;
	}
	static function userstatus($num)
	{
		switch ($num) {
			case '0':
				$msg = "待审核";
				break;
			case 1:
				$msg = '正常';
				break;
			case 3:
				$msg = '封禁';
				break;
			case 4:
				$msg = '待验证';
				break;
			default:
				$msg = '未知';
				break;
		}
		return $msg;
	}
	static function type2str($str)
	{
		$str = strtolower($str);
		$sure = false;
		$text = "文档";
		foreach (self::IMGEXT as $k => $v) {
			if ($v === $str && $sure === false) {
				$sure = true;
				$text = "图片";
			}
		}
		if (!$sure) {
			foreach (self::VIDEOEXT as $key => $value) {
				if ($value === $str && $sure === false) {
					$sure = true;
					$text = "视频";
				}
			}
		}
		return $text;
	}
	static function ifmime($mime)
	{
		$video = false;
		foreach (self::VIDEOEXT as $key => $value) {
			if ($value === $mime) {
				$video = true;
			}
		}
		$image = false;
		foreach (self::IMGEXT as $k => $v) {
			if ($v === $mime) {
				$image = true;
			}
		}
		$data = array(
			'isVideo' => $video,
			'isImage' => $image
		);
		return $data;
	}
	static function tranTime($time)
	{
		$time = strtotime($time);
		$rtime = date("Y-m-d H:i", $time);
		$rtime2 = date("Y-m-d H:i", $time);
		$htime = date("H:i", $time);
		$time = time() - $time;
		if ($time < 60) {
			$str = '刚刚';
		} elseif ($time < 60 * 60) {
			$min = floor($time / 60);
			$str = $min . ' 分钟前';
		} elseif ($time < 60 * 60 * 24) {
			$h = floor($time / (60 * 60));
			$str = $h . '小时前 ' . $htime;
		} elseif ($time < 60 * 60 * 24 * 3) {
			$d = floor($time / (60 * 60 * 24));
			if ($d == 1)
				$str = '昨天 ' . $htime;
			else
				$str = '前天 ' . $htime;
		} elseif ($time < 60 * 60 * 24 * 7) {
			$d = floor($time / (60 * 60 * 24));
			$str = $d . ' 天前 ' . $htime;
		} elseif ($time < 60 * 60 * 24 * 30) {
			$str = '一个月前';
		} else {
			$str = $rtime;
		}
		return $str;
	}
	static function formatBytes($size)
	{
		$units = array(' B', ' KB', ' MB', ' GB', ' TB', ' PB');
		for ($i = 0; $size >= 1024 && $i < 5; $i++) $size /= 1024;
		return round($size, 2) . $units[$i];
	}
	static function getServer($ssid, $type, $params = array())
	{
		$sdb = Db::name('server')->where('ssid', $ssid)->find();
		switch ($type) {
			case 'md5Check':
				$getpar = array(
					'uploadkey' => $sdb['uploadkey'],
					'status' => 'md5Check',
					'md5' => $params['md5'],
					'name' => $params['name'],
					'_' => $_SERVER['REQUEST_TIME']
				);
				$APIURI = $sdb['baseurl'] . self::CHECKFILE . '?' . http_build_query($getpar);
				break;
			case 'remove':
				$getpar = array(
					'id' => $params['shareid'],
					'key' => $sdb['apikey']
				);
				$APIURI = $sdb['baseurl'] . self::REMOVEFILE . '?' . http_build_query($getpar);
				break;
			case 'getonedb':
				$getpar = array(
					'key' => $sdb['apikey'],
					'id' => $params['id']
				);
				$APIURI = $sdb['baseurl'] . self::GETONEDB . '?' . http_build_query($getpar);
				break;
			case 'getdb':
				$getpar = array(
					'key' => $sdb['apikey'],
					'limit' => $params['limit'],
					'page' => $params['page'],
				);
				$APIURI = $sdb['baseurl'] . self::GETDB . '?' . http_build_query($getpar);
				break;
			case 'getinfo':
				$getpar = [
					'key' => $sdb['apikey'],
				];
				$APIURI = $sdb['baseurl'] . self::GETSYSINFO . '?' . http_build_query($getpar);
				break;
		}
		$serverRES = self::curlGet($APIURI);
		if (!$serverRES) {
			Logint::insert('存储单元 [' . $sdb['form'] . '] 通信失败', 'error');
		} else {
			$serverRES = json_decode($serverRES);
			switch ($type) {
				case 'remove':
					switch (@$serverRES->err_code) {
						case '-1':
						case -1:
							Logint::insert('存储单元 [' . $sdb['form'] . '] 读写密钥错误', 'error');
							$serverRES = false;
							break;
					}
					break;
			}
		}
		return $serverRES;
	}
	static function curlGet($url, $POST = array())
	{
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		if ($POST) {
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($POST));
		}
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_TIMEOUT, 10);
		@$_SERVER['HTTP_ORIGIN'] ? curl_setopt($ch, CURLOPT_REFERER, $_SERVER['HTTP_ORIGIN']) : '';
		$output = curl_exec($ch);
		curl_close($ch);
		return $output;
	}
	static function ifycode($code, $type)
	{
		$captcha = new Captcha();
		return $captcha->check($code, $type);
	}
	static function only($instr)
	{
		$instr = md5($instr . uniqid(time(), true), true);
		$dict = '0123456789ABCDEFGHIJKLMNOPQRSTUV';
		$outstr = '';
		for ($i = 0; $i < 8; $i++) {
			$ord = ord($instr[$i]);
			$outstr .= $dict[($ord ^ ord($instr[$i + 8])) - $ord & 0x1F];
		}
		return $outstr;
	}
	static function hideStar($str)
	{ //用户名、邮箱、手机账号中间字符串以*隐藏
		if (strpos($str, '@')) {
			$email_array = explode("@", $str);
			$prevfix = (strlen($email_array[0]) < 4) ? "" : substr($str, 0, 1); //邮箱前缀
			$count = 0;
			$str = preg_replace('/([\d\w+_-]{0,100})@/', '***@', $str, -1, $count);
			$rs = $prevfix . $str;
		} else {
			$pattern = '/(1[3458]{1}[0-9])[0-9]{4}([0-9]{4})/i';
			if (preg_match($pattern, $str)) {
				$rs = preg_replace($pattern, '$1****$2', $str); // substr_replace($name,'****',3,4);
			} else {
				$rs = substr($str, 0, 3) . "***" . substr($str, -1);
			}
		}
		return $rs;
	}
	static function setconfig($config, $pat, $rep)
	{
		if (is_array($pat) and is_array($rep)) {
			for ($i = 0; $i < count($pat); $i++) {
				$pats[$i] = '/\'' . $pat[$i] . '\'(.*?),/';
				if (is_int($rep[$i])) {
					$reps[$i] = "'" . $pat[$i] . "'" . "=>" . $rep[$i] . ",";
				} else {
					$reps[$i] = "'" . $pat[$i] . "'" . "=>" . "'" . $rep[$i] . "',";
				}
			}
			$fileurl = APP_PATH . $config . ".php";
			$string = file_get_contents($fileurl); //加载配置文件
			$string = preg_replace($pats, $reps, $string); // 正则查找然后替换
			file_put_contents($fileurl, $string); // 写入配置文件
			return true;
		} else {
			return false;
		}
	}
	static function fileStandard($par)
	{
		if (@$par->shareid) {
			$shareid = $par->shareid;
		} else {
			preg_match('/\/share\/(.*)/i', $par->share, $match);
			$shareid = $match[1];
		}
		$duration = '';
		if (!@$par->duration) {
			if (@$par->metadata->time) {
				$duration = self::Sec2Time($par->metadata->time);
			}
		} else {
			$duration = $par->duration;
		}
		$path = parse_url(@$par->url ? $par->url : $par->rpath, PHP_URL_PATH);
		$path = str_replace('\\', '/', $path);
		// if (strpos($path, 'index.m3u8')) {
		// 	preg_match('/(.*?)\/index.m3u8/i', $path, $match);
		// 	preg_match('/mp4\/(.*?)\./i', $par->mp4, $filename);
		// } elseif (isset($par->rpath)) {
		// 	$match[1] = $par->rpath;
		// 	$patharr = explode('/', $par->rpath);
		// 	$patharr = array_reverse($patharr);
		// 	$filename[1] = $patharr[0];
		// } else {
		// 	preg_match('/(.*?)\./i', $path, $match);
		// 	preg_match('/.*\/(.*?)\./i', $path, $filename);
		// }
		// !@$par->extname ? $mime = strrchr($match[1], ".") : $mime = $par->extname;
		// !$mime ? $mime = '.mp4' : '';
		$filetype = self::file_format('.' . $par->suffix);
		$dbadd = array(
			'md5' => @!$par->md5 ? $par->_id : $par->md5,
			'fid' => md5(uniqid(md5(@!$par->md5 ? $par->_id : $par->md5 . time()), true)),
			'size' => @$par->size ? $par->size : $par->metadata->length,
			'shareid' => $shareid,
			'ssid' => $par->ssid,
			'mime' => '.' . $par->suffix,
			'filetype' => $filetype,
			'duration' => $duration,
			'path' => $par->rpath,
			'filename' => $par->path,
			'user' => $par->user,
			'qr' => '/qrapi/' . $shareid,
			'orgfile' => $path,
			'title' => @$par->title ? self::remove_xss($par->title) : self::remove_xss($par->orgfile),
			'createTime' => date('Y-m-d H:i:s', time())
		);
		strlen($dbadd['title']) > 200 ? $dbadd['title'] = substr($dbadd['title'], -1, 100) : '';
		if ($filetype === 'video') {
			$dbadd['mp4'] = $par->rpath . '/mp4/' . $par->path . '.mp4';
			$dbadd['pic'] = $par->rpath . '/' . '1.jpg';
			$dbadd['gif'] = $par->rpath . '/' . '1.gif';
			$dbadd['orgfile'] = $dbadd['mp4'];
		}
		return $dbadd;
	}
	static function Sec2Time($time)
	{
		if (is_numeric($time)) {
			$value = array(
				"years" => 0, "days" => 0, "hours" => 0,
				"minutes" => 0, "seconds" => 0,
			);
			if ($time >= 31556926) {
				$value["years"] = floor($time / 31556926);
				$time = ($time % 31556926);
			}
			if ($time >= 86400) {
				$value["days"] = floor($time / 86400);
				$time = ($time % 86400);
			}
			if ($time >= 3600) {
				$value["hours"] = floor($time / 3600);
				$time = ($time % 3600);
			}
			if ($time >= 60) {
				$value["minutes"] = floor($time / 60);
				$time = ($time % 60);
			}
			$value["seconds"] = floor($time);
			$t = sprintf("%02d", $value["hours"]) . ":" . sprintf("%02d", $value["minutes"]) . ":" . sprintf("%02d", $value["seconds"]);
			return $t;
		} else {
			return (bool) FALSE;
		}
	}
	static function path2mp4($path)
	{
		$patharr = explode('/', $path);
		return $path . '/mp4/' . $patharr[2] . '.mp4';
	}
	static function remove_xss($val)
	{
		if (gettype($val) === 'object') {
			foreach ($val as $key => $value) {
				$val->$key = self::remove_xss($value);
			}
		} else {
			$val = preg_replace('/([\x00-\x08\x0b-\x0c,\x0e-\x19])/', '', $val);
			$search = 'abcdefghijklmnopqrstuvwxyz';
			$search .= 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
			$search .= '1234567890!@#$%^&*()';
			$search .= '~`";:?+/={}[]-_|\'\\';
			for ($i = 0; $i < strlen($search); $i++) {
				$val = preg_replace('/(&#[xX]0{0,8}' . dechex(ord($search[$i])) . ';?)/i', $search[$i], $val);
				$val = preg_replace('/(�{0,8}' . ord($search[$i]) . ';?)/', $search[$i], $val);
			}
			$ra1 = array('javascript', 'vbscript', 'expression', 'applet', 'meta', 'xml', 'blink', 'link', 'style', 'script', 'embed', 'object', 'iframe', 'frame', 'frameset', 'ilayer', 'layer', 'bgsound', 'title', 'base', 'php');
			$ra2 = array('onabort', 'onactivate', 'onafterprint', 'onafterupdate', 'onbeforeactivate', 'onbeforecopy', 'onbeforecut', 'onbeforedeactivate', 'onbeforeeditfocus', 'onbeforepaste', 'onbeforeprint', 'onbeforeunload', 'onbeforeupdate', 'onblur', 'onbounce', 'oncellchange', 'onchange', 'onclick', 'oncontextmenu', 'oncontrolselect', 'oncopy', 'oncut', 'ondataavailable', 'ondatasetchanged', 'ondatasetcomplete', 'ondblclick', 'ondeactivate', 'ondrag', 'ondragend', 'ondragenter', 'ondragleave', 'ondragover', 'ondragstart', 'ondrop', 'onerror', 'onerrorupdate', 'onfilterchange', 'onfinish', 'onfocus', 'onfocusin', 'onfocusout', 'onhelp', 'onkeydown', 'onkeypress', 'onkeyup', 'onlayoutcomplete', 'onload', 'onlosecapture', 'onmousedown', 'onmouseenter', 'onmouseleave', 'onmousemove', 'onmouseout', 'onmouseover', 'onmouseup', 'onmousewheel', 'onmove', 'onmoveend', 'onmovestart', 'onpaste', 'onpropertychange', 'onreadystatechange', 'onreset', 'onresize', 'onresizeend', 'onresizestart', 'onrowenter', 'onrowexit', 'onrowsdelete', 'onrowsinserted', 'onscroll', 'onselect', 'onselectionchange', 'onselectstart', 'onstart', 'onstop', 'onsubmit', 'onunload');
			$ra = array_merge($ra1, $ra2);
			$found = true;
			while ($found == true) {
				$val_before = $val;
				for ($i = 0; $i < sizeof($ra); $i++) {
					$pattern = '/';
					for ($j = 0; $j < strlen($ra[$i]); $j++) {
						if ($j > 0) {
							$pattern .= '(';
							$pattern .= '(&#[xX]0{0,8}([9ab]);)';
							$pattern .= '|';
							$pattern .= '|(�{0,8}([9|10|13]);)';
							$pattern .= ')*';
						}
						$pattern .= $ra[$i][$j];
					}
					$pattern .= '/i';
					$replacement = substr($ra[$i], 0, 2) . ' ' . substr($ra[$i], 2);
					$val = preg_replace($pattern, $replacement, $val);
					if ($val_before == $val) {
						$found = false;
					}
				}
			}
			$str2 = [
				'<', '>'
			];
			$str2_prg = [
				'&lt;', '&gt;'
			];
			$val = str_replace($str2, $str2_prg, $val);
		}
		return is_numeric($val) ? (int) $val : $val;
	}
}
