$(function () {
    $Pui.use(['give', 'reHtmlfontsize', '$PPP', '$Cookies', 'domLoading', 'message', 'getApi', 'modal'], function () {
        var $PPP = $Pui.$PPP;
        $Pui.reHtmlfontsize();
        var $Cookies = $Pui.$Cookies;
        /**
        * 监听窗口变化
        */
        window.addEventListener('resize', function () {
            $Pui.reHtmlfontsize();
        });
        /**
         * 创建LOADING模态框
         */
        $Pui.domLoading('comment', function (done) {
            var iframe = $('#Comment iframe');
            iframe.prop('src', '/comment?vid=' + done.data);
            iframe.on('load', function () {
                done.done();
            });
        });
        /**
         * send conment
         */
        window.sendComment = function () {
            var params = {
                'vid': $('input[name="vid"]').val(),
                'content': $('input[name="content"]').val(),
                'vtime': 0,
                '__token__': $('input[name="token"]').val(),
            }
            if (params.content.length < 5 || typeof params.content == 'undefined') {
                $Pui.message('warning', '评论字数不得小于5');
            } else {
                $Pui.getApi('sendComment', params, function (call) {
                    if (call.status) {
                        $Pui.message('success', '评论成功', 1500);
                    } else {
                        if (call.code === 403) {
                            $Pui.modal('iframe', '/if_login');
                        } else {
                            $Pui.message('faild', call.info, 3000);
                        }
                    }
                });
            }
        }
        /**
         * 获取视频连接
         */
        window.getVideoUrl = function (e) {
            //获取当前点击元素
            let ele = $(e);
            //获取当前状态
            let status = ele.data().status;
            if (status == 'ready') {
                ele.data('status', 'loading');
                ele.find('svg').addClass('spinner');
                /**
                 * 获取元素参数
                 */
                let eleData = ele.data();
                $Pui.getApi('getVideo', eleData, function (call) {
                    /**
                     * 获取播放器元素
                     */
                    //$(ele.parent('.player')).attr('id',ele.data('vid'));
                    window.box = ele.data('vid');
                    let video = ele.prev('video');
                    /**
                     * 实例化播放器 (url,element)
                     */
                    let player = new $PPP(call.url, video[0]);
                    $('input[name=ssid]').val(call.ssid);
                    if (call.is) {
                        if (call.islogin) {
                            if (!call.isbuy) {
                                player._ele.addEventListener('ended', function () {
                                    let config = {
                                        'content': '完整版需要打赏 ' + call.price + ' 积分观看',
                                        'btn': [
                                            {
                                                'btname': '打赏',
                                                'bid': 'buyfile'
                                            }
                                        ]
                                    };
                                    $Pui.modal('msg', config, function (call) {
                                        switch (call) {
                                            case 'buyfile':
                                                let params = {
                                                    file: $('input[name=vid]').val(),
                                                    title: $('input[name=title]').val(),
                                                    from: $('input[name=form]').val(),
                                                    type: $('input[name=type]').val(),
                                                    __token__: $('input[name=token]').val(),
                                                }
                                                $Pui.getApi('buyfile', params, function (res) {
                                                    if (res.status) {
                                                        $Pui.message('success', '购买成功', 3000);
                                                        window.location.reload();
                                                    } else {
                                                        $Pui.message('faild', res.info, 3000);
                                                    }
                                                })
                                                break;
                                        }
                                    });
                                })
                            }
                        } else {
                            player._ele.addEventListener('ended', function () {
                                let config = {
                                    'content': '完整版需要登陆后观看',
                                    'btn': [
                                        {
                                            'btname': '登陆',
                                            'bid': 'login'
                                        }
                                    ]
                                };
                                $Pui.modal('msg', config, function (call) {
                                    switch (call) {
                                        case 'login':
                                            $Pui.modal('iframe', '/if_login');
                                            break;
                                    }
                                });
                            });
                        }
                    }
                    player.play();
                    ele.hide();
                    video.show();
                });
            }
        }
        /**
         * 创建点赞对象
         */
        $Pui.give('like', function (status, data) {
            switch (status) {
                case 'init':
                    $.each(data, function (i, item) {
                        let id = $(item).attr('pui-id');
                        if ($Cookies.get('cp_' + id) === 'true') {
                            $Pui.give.setEle($(item), 'select');
                        }
                    })
                    break;
                case 'select':
                    $Cookies.set('cp_' + data, true);
                    var par = data.split('_');
                    var params = {
                        aid: par[0],
                        vid: par[1],
                        modify: 'give',
                        type: '赞'
                    };
                    $Pui.getApi('giveLaud', params, function (res) {
                        $('.ppGive[pui-id=' + data + ']').find('span').text(res.count);
                    })
                    break;
                case 'cancel':
                    $Cookies.set('cp_' + data, false);
                    var par = data.split('_');
                    var params = {
                        aid: par[0],
                        vid: par[1],
                        modify: 'give',
                        type: '踩'
                    };
                    $Pui.getApi('giveLaud', params, function (res) {
                        $('.ppGive[pui-id=' + data + ']').find('span').text(res.count);
                    })
                    break;
            }
        });
    });
    /**
     * 监听滚动析构播放器
     */
    window.addEventListener('scroll', function () {
        if (eleCon != 'null') {
            let ele = $(eleCon);
            let eleTop = ele.offset().top;
            let eleHeight = ele.height();
            let viewTop = $(document).scrollTop();
            if (viewTop >= eleTop + eleHeight / 2) {
                eleCon.pause();
            }
        }
    })
})