// 分享页交互组件
$(function () {
    layui.use(["element", "layer"], function () {
        var element = layui.element,
            layer = layui.layer;
        var org = "";
        $Pui.use(["give", "getApi", "$Cookies", "tips"], function () {
            var $Cookies = $Pui.$Cookies;
            $Pui.give("like", function (type, ele) {
                switch (type) {
                    case "init":
                        if (
                            $Cookies.get(
                                "cp_" + info.vid + "_" + info.aid
                            ) === "true"
                        ) {
                            $Pui.give.setEle($(ele), "select");
                        }
                        break;
                    case "select":
                        $Cookies.set(
                            "cp_" + info.vid + "_" + info.aid,
                            true
                        );
                        var params = {
                            aid: info.vid,
                            vid: info.aid,
                            modify: "give",
                            type: "赞"
                        };
                        $Pui.getApi("giveLaud", params, function (res) {
                            $(".ppGive[pui-id=" + ele + "]")
                                .find("span")
                                .text(res.count);
                        });
                        break;
                    case "cancel":
                        $Cookies.set(
                            "cp_" + info.vid + "_" + info.aid,
                            false
                        );
                        var params = {
                            aid: info.vid,
                            vid: info.aid,
                            modify: "give",
                            type: "踩"
                        };
                        $Pui.getApi("giveLaud", params, function (res) {
                            $(".ppGive[pui-id=" + ele + "]")
                                .find("span")
                                .text(res.count);
                        });
                        break;
                }
            });
            $Pui.tips("qrcode", '<div id="qrcode"></div>', function (call) {
                $('#qrcode').qrcode({
                    render: "canvas",
                    width: 150,
                    height: 150,
                    text: location.origin + '/mobile?m=share&c=' + info.vid
                });
            });
            let params = {
                type: 'share',
                vid: info.vid
            };
            $Pui.getApi("getVideo", params, function (res) {
                if (res.type === "video") {
                    var player = new DPlayer({
                        container: document.getElementById("player"),
                        autoplay: true,
                        video: {
                            url: res.url,
                            type: "hls"
                        },
                        danmaku: {
                            id: info.aid,
                            api: "/danmu"
                        }
                    });
                    player.play();
                } else {
                    $("#player").html(
                        '<div class="file"><div class="file_ico"><svg class="icon" aria-hidden="true"><use xlink:href="#icon-file"></use></svg></div></div>'
                    );
                    $("#msg_box")
                        .find(".msg_content")
                        .html("该文件需要打赏 " + info.price + " 积分后才可下载");
                }

                if (res.is) {
                    if (!res.islogin) {
                        if (res.type === "video") {
                            player.on("ended", function () {
                                openLogin("if_login");
                            });
                        } else {
                            openLogin("if_login");
                        }
                    } else {
                        if (!res.isbuy) {
                            if (res.type === "video") {
                                player.on("ended", function () {
                                    $("#msg_box").css("display", "flex");
                                });
                            } else {
                                $("#msg_box").css("display", "flex");
                            }
                            $("#msg_box").find('.close').click(function () {
                                $("#msg_box").css("display", 'none');
                            })
                        } else {
                            org = res.orgfile;
                        }
                    }
                } else {
                    org = res.orgfile;
                }
            });
        });
        window.openLogin = function (type) {
            let size = [
                $("#player").width() * 0.35 <= 300
                    ? 300
                    : $("#player").width() * 0.35,
                $("#player").height() * 0.6 <= 320
                    ? 320
                    : $("#player").height() * 0.6
            ];
            let offset = [
                $("#player").offset().top + ($("#player").height() - size[1]) / 2,
                $("#player").offset().left + ($("#player").width() - size[0]) / 2
            ];
            layer.open({
                type: 2,
                title: info.hostname + "登陆",
                shadeClose: true,
                shade: false,
                moveOut: false,
                resize: false,
                offset: offset,
                area: [size[0] + "px", size[1] + "px"],
                content: "/" + type,
                end: function () {
                    location.reload();
                }
            });
        };
        window.out = function () {
            let params = {
                model: "loginout"
            };
            $.post("/api", params, function (res) {
                location.reload();
            });
        };
        window.down = function () {
            if (!org) {
                layer.msg("暂时不提供下载", {
                    offset: "t",
                    anim: 6
                });
            } else {
                window.open(org);
            }
        };
        window.buyfile = function () {
            let params = {
                file: info.aid,
                from: info.vid,
                type: info.type,
                __token__: info.token
            };
            $Pui.getApi("buyfile", params, function (res) {
                if (res.status) {
                    location.reload();
                } else {
                    layer.msg(res.info, {
                        offset: "t",
                        anim: 6
                    });
                }
            });
        };
        $('button[name=follow]').click(function(){
            let params = {
                uid:info.user
            };
            $Pui.getApi('follow',params,function(result){
                if (!result.status) {
                    switch (result.code) {
                        case 403:
                            openLogin('if_login');
                            break;
                        default:
                            layer.msg(result.info);
                            break;
                    }
                } else {
                    
                    if (result.info==='OK') {
                        layer.msg('关注成功');
                    } else {
                        layer.msg('取消关注');
                    }
                }
            })
        });
    });
})